/*      Compiler: ECL 23.9.9                                          */
/*      Source: /builddir/build/BUILD/ecl-23.9.9/src/clos/kernel.lsp  */
#include <ecl/ecl-cmp.h>
#include "clos/kernel.eclh"
/*      function definition for SETF-FIND-CLASS                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1464setf_find_class(cl_narg narg, cl_object v1new_value, cl_object v2name, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<2)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>4)) FEwrong_num_arguments_anonym();
 {
  cl_object v3errorp;
  cl_object v4env;
  va_list args; va_start(args,v2name);
  {
   int i = 2;
   if (i >= narg) {
    v3errorp = ECL_NIL;
   } else {
    i++;
    v3errorp = va_arg(args,cl_object);
   }
   if (i >= narg) {
    v4env = ECL_NIL;
   } else {
    i++;
    v4env = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   cl_object v5old_class;
   v5old_class = cl_find_class(2, v2name, ECL_NIL);
   if (Null(v5old_class)) { goto L5; }
   if ((si_of_class_p(2, v5old_class, ECL_SYM("BUILT-IN-CLASS",931)))!=ECL_NIL) { goto L8; }
   {
    cl_object v6;
    v6 = (ECL_SYM("EQ",335)->symbol.gfdef);
    if (!((v2name)==(ECL_SYM("CLASS",935)))) { goto L14; }
    goto L11;
    goto L12;
L14:;
    goto L12;
L12:;
    if (!((v2name)==(ECL_SYM("BUILT-IN-CLASS",931)))) { goto L5; }
    goto L6;
L11:;
    goto L6;
   }
L8:;
L6:;
   if ((v1new_value)==(v5old_class)) { goto L3; }
   cl_error(2, VV[3], v2name);
   goto L3;
L5:;
   if (Null(L1466classp(v1new_value))) { goto L18; }
   si_hash_set(v2name, ecl_symbol_value(ECL_SYM("*CLASS-NAME-HASH-TABLE*",1018)), v1new_value);
   goto L3;
L18:;
   if (!(v1new_value==ECL_NIL)) { goto L20; }
   cl_remhash(v2name, ecl_symbol_value(ECL_SYM("*CLASS-NAME-HASH-TABLE*",1018)));
   goto L3;
L20:;
   cl_error(2, VV[4], v1new_value);
  }
L3:;
  value0 = v1new_value;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function LAMBDA13                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1465__lambda13(cl_narg narg, cl_object v1v, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  cl_object v2x;
  ecl_va_list args; ecl_va_start(args,v1v,narg,1);
  v2x = cl_grab_rest_args(args);
  ecl_va_end(args);
  value0 = cl_listX(3, VV[5], v1v, v2x);
  return value0;
 }
}
/*      function definition for CLASSP                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1466classp(cl_object v1obj)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(ECL_INSTANCEP(v1obj))) { goto L2; }
  {
   cl_object v2topmost;
   v2topmost = cl_find_class(2, ECL_SYM("CLASS",935), ECL_NIL);
   if (v2topmost==ECL_NIL) { goto L6; }
   T0 = si_instance_class(v1obj);
   if (Null(si_subclassp(2, T0, v2topmost))) { goto L2; }
   goto L4;
L6:;
  }
L4:;
  value0 = ECL_T;
  cl_env_copy->nvalues = 1;
  return value0;
L2:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for INSTALL-METHOD                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1468install_method(cl_narg narg, cl_object v1name, cl_object v2qualifiers, cl_object v3specializers, cl_object v4lambda_list, cl_object v5fun, ...)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<5)) FEwrong_num_arguments_anonym();
 {
  cl_object v6options;
  ecl_va_list args; ecl_va_start(args,v5fun,narg,5);
  env0 = ECL_NIL;
  CLV0 = env0 = CONS(v1name,env0);                /*  NAME            */
  CLV1 = env0 = CONS(v3specializers,env0);        /*  SPECIALIZERS    */
  v6options = cl_grab_rest_args(args);
  ecl_va_end(args);
  {
   cl_object v7gf;
   cl_object v8fun;
   cl_object v9specializers;
   cl_object v10method;
   v7gf = (cl_env_copy->function=(VV[10]->symbol.gfdef))->cfun.entry(1, ECL_CONS_CAR(CLV0)) /*  ENSURE-GENERIC-FUNCTION */;
   v8fun = L1470wrapped_method_function(v5fun);
   {
    cl_object v11;
    {
     cl_object v12;
     v12 = ecl_make_cclosure_va((cl_objectfn)LC1467__lambda19,env0,Cblock,1);
     v11 = v12;
    }
    {
     cl_object v12;
     cl_object v13;
     v12 = ECL_NIL;
     {
      cl_object v14;
      v14 = ECL_CONS_CAR(CLV1);
      if (ecl_unlikely(!ECL_LISTP(v14))) FEtype_error_list(v14);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v13 = v14;
     }
     {
      cl_object v14;
      cl_object v15;
      v14 = ecl_list1(ECL_NIL);
      v15 = v14;
L11:;
      if (!(ecl_endp(v13))) { goto L13; }
      goto L12;
L13:;
      v12 = ECL_CONS_CAR(v13);
      {
       cl_object v16;
       v16 = ECL_CONS_CDR(v13);
       if (ecl_unlikely(!ECL_LISTP(v16))) FEtype_error_list(v16);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v13 = v16;
      }
      {
       cl_object v16;
       v16 = v15;
       if (ecl_unlikely(ECL_ATOM(v16))) FEtype_error_cons(v16);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       T0 = v16;
      }
      T1 = ecl_function_dispatch(cl_env_copy,v11)(1, v12);
      v15 = ecl_list1(T1);
      (ECL_CONS_CDR(T0)=v15,T0);
      goto L11;
L12:;
      v9specializers = ecl_cdr(v14);
      goto L3;
     }
    }
   }
L3:;
   T0 = ecl_function_dispatch(cl_env_copy,ECL_SYM("GENERIC-FUNCTION-METHOD-CLASS",1593))(1, v7gf) /*  GENERIC-FUNCTION-METHOD-CLASS */;
   v10method = (cl_env_copy->function=(ECL_SYM("MAKE-METHOD",955)->symbol.gfdef))->cfun.entry(6, T0, v2qualifiers, v9specializers, v4lambda_list, v8fun, v6options) /*  MAKE-METHOD */;
   (cl_env_copy->function=(ECL_SYM("ADD-METHOD",930)->symbol.gfdef))->cfun.entry(2, v7gf, v10method) /*  ADD-METHOD */;
   value0 = v10method;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      closure LAMBDA19                                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1467__lambda19(cl_narg narg, cl_object v1x, ...)
{
 cl_object T0;
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;                                     /*  SPECIALIZERS    */
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  if (!(ECL_CONSP(v1x))) { goto L1; }
  T0 = ecl_cadr(v1x);
  value0 = ecl_function_dispatch(cl_env_copy,ECL_SYM("INTERN-EQL-SPECIALIZER",1597))(1, T0) /*  INTERN-EQL-SPECIALIZER */;
  return value0;
L1:;
  if (Null(si_of_class_p(2, v1x, ECL_SYM("SPECIALIZER",1627)))) { goto L3; }
  value0 = v1x;
  cl_env_copy->nvalues = 1;
  return value0;
L3:;
  {
   cl_object v2;
   v2 = cl_find_class(2, v1x, ECL_NIL);
   if (Null(v2)) { goto L6; }
   value0 = v2;
   cl_env_copy->nvalues = 1;
   return value0;
L6:;
   value0 = cl_error(3, VV[7], ECL_CONS_CAR(CLV0), ECL_CONS_CAR(CLV1));
   return value0;
  }
 }
 }
}
/*      function definition for WRAPPED-METHOD-FUNCTION               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1470wrapped_method_function(cl_object v1method_function)
{
 cl_object env0 = ECL_NIL;
 cl_object CLV0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  env0 = ECL_NIL;
  CLV0 = env0 = CONS(v1method_function,env0);     /*  METHOD-FUNCTION */
  {
   cl_object v2;
   v2 = ecl_make_cclosure_va((cl_objectfn)LC1469__lambda23,env0,Cblock,2);
   value0 = v2;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      closure LAMBDA23                                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1469__lambda23(cl_narg narg, cl_object v1_combined_method_args_, cl_object v2_next_methods_, ...)
{
 cl_object CLV0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV0 = env0;                                     /*  METHOD-FUNCTION */
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=2)) FEwrong_num_arguments_anonym();
 {
  ecl_bds_bind(cl_env_copy,ECL_SYM(".COMBINED-METHOD-ARGS.",1544),v1_combined_method_args_); /*  .COMBINED-METHOD-ARGS. */
  ecl_bds_bind(cl_env_copy,ECL_SYM("*NEXT-METHODS*",1546),v2_next_methods_); /*  *NEXT-METHODS* */
TTL:
  value0 = cl_apply(2, ECL_CONS_CAR(CLV0), ecl_symbol_value(ECL_SYM(".COMBINED-METHOD-ARGS.",1544)));
  ecl_bds_unwind1(cl_env_copy);
  ecl_bds_unwind1(cl_env_copy);
  return value0;
 }
 }
}
/*      function definition for ENSURE-GENERIC-FUNCTION               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1487ensure_generic_function(cl_narg narg, cl_object v1name, ...)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  cl_object v2lambda_list;
  cl_object v3l_l_p;
  ecl_va_list args; ecl_va_start(args,v1name,narg,1);
  {
   cl_object keyvars[2];
   cl_parse_key(args,1,L1487ensure_generic_functionkeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   if (Null(keyvars[1])) {
    v2lambda_list = ECL_UNBOUND;
   } else {
    v2lambda_list = keyvars[0];
   }
   v3l_l_p = keyvars[1];
  }
  if (Null(cl_fboundp(v1name))) { goto L2; }
  T0 = cl_fdefinition(v1name);
  if (!(ECL_INSTANCEP(T0))) { goto L2; }
  value0 = cl_fdefinition(v1name);
  return value0;
L2:;
  {
   cl_object v4_class;
   cl_object v5gfun;
   v4_class = cl_find_class(1, ECL_SYM("STANDARD-GENERIC-FUNCTION",976));
   v5gfun = si_allocate_raw_instance(ECL_NIL, v4_class, ecl_make_fixnum(11));
   si_instance_set(v5gfun, ecl_make_fixnum(0), v1name);
   si_instance_set(v5gfun, ecl_make_fixnum(1), ECL_NIL);
   T0 = ecl_function_dispatch(cl_env_copy,ECL_SYM("FIND-METHOD-COMBINATION",1585))(3, ECL_NIL, ECL_SYM("STANDARD",974), ECL_NIL) /*  FIND-METHOD-COMBINATION */;
   si_instance_set(v5gfun, ecl_make_fixnum(2), T0);
   si_instance_set(v5gfun, ecl_make_fixnum(3), v2lambda_list);
   if (Null(v3l_l_p)) { goto L14; }
   T1 = si_process_lambda_list(v2lambda_list, ECL_T);
   T0 = ecl_cdr(T1);
   goto L12;
L14:;
   T0 = ECL_NIL;
   goto L12;
L12:;
   si_instance_set(v5gfun, ecl_make_fixnum(4), T0);
   T0 = cl_find_class(1, ECL_SYM("STANDARD-METHOD",977));
   si_instance_set(v5gfun, ecl_make_fixnum(5), T0);
   si_instance_set(v5gfun, ecl_make_fixnum(6), ECL_NIL);
   si_instance_set(v5gfun, ecl_make_fixnum(7), ECL_NIL);
   si_instance_set(v5gfun, ecl_make_fixnum(8), ECL_NIL);
   si_instance_set(v5gfun, ecl_make_fixnum(9), ECL_NIL);
   si_instance_set(v5gfun, ecl_make_fixnum(10), ECL_NIL);
   if (Null(v4_class)) { goto L22; }
   si_instance_sig_set(v5gfun);
L22:;
   clos_set_funcallable_instance_function(v5gfun, ECL_SYM("STANDARD-GENERIC-FUNCTION",976));
   si_fset(2, v1name, v5gfun);
   value0 = v5gfun;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for (SETF GENERIC-FUNCTION-NAME)          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1488_setf_generic_function_name_(cl_object v1new_name, cl_object v2gf)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(ecl_symbol_value(VV[0]))) { goto L1; }
  value0 = (cl_env_copy->function=(ECL_SYM("REINITIALIZE-INSTANCE",965)->symbol.gfdef))->cfun.entry(3, v2gf, ECL_SYM("NAME",1306), v1new_name) /*  REINITIALIZE-INSTANCE */;
  return value0;
L1:;
  value0 = (cl_env_copy->function=ECL_CONS_CAR(VV[34]))->cfun.entry(3, v1new_name, v2gf, ECL_SYM("NAME",1606)) /*  (SETF SLOT-VALUE) */;
  return value0;
 }
}
/*      function definition for STD-COMPUTE-DISCRIMINATING-FUNCTION   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1489std_compute_discriminating_function(cl_object v1generic_function)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = ecl_function_dispatch(cl_env_copy,VV[36])(1, v1generic_function) /*  UNOPTIMIZED-DISCRIMINATOR */;
  cl_env_copy->nvalues = 2;
  cl_env_copy->values[1] = ECL_T;
  cl_env_copy->values[0] = T0;
  return cl_env_copy->values[0];
 }
}
/*      function definition for COMPUTE-DISCRIMINATING-FUNCTION       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1490compute_discriminating_function(cl_object v1gf)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_function_dispatch(cl_env_copy,VV[12])(1, v1gf) /*  STD-COMPUTE-DISCRIMINATING-FUNCTION */;
  return value0;
 }
}
/*      function definition for SET-GENERIC-FUNCTION-DISPATCH         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1492set_generic_function_dispatch(cl_object v1gf)
{
 cl_object T0, T1;
 volatile cl_object lex0[1];
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;                                  /*  COMPUTED-DISCRIMINATOR */
   cl_object v4;                                  /*  OPTIMIZABLE     */
   value0 = ecl_function_dispatch(cl_env_copy,VV[13])(1, v1gf) /*  COMPUTE-DISCRIMINATING-FUNCTION */;
   {
    const int v5 = cl_env_copy->nvalues;
    v3 = value0;
    cl_object v6;
    v6 = (v5<=1)? ECL_NIL : cl_env_copy->values[1];
    v4 = v6;
   }
   T0 = cl_slot_value(v1gf, VV[14]);
   {
    cl_fixnum v5;
    v5 = ecl_length(T0);
    if (!((v5)>(63))) { goto L2; }
   }
   v4 = ECL_NIL;
L2:;
   {
    cl_object v5;
    cl_object v6;
    v5 = cl_slot_value(v1gf, VV[15]);
    T0 = cl_class_of(v1gf);
    T1 = cl_slot_value(T0, ECL_SYM("NAME",1606));
    v6 = ecl_make_bool((T1)==(ECL_SYM("STANDARD-GENERIC-FUNCTION",976)));
    lex0[0] = v5;                                 /*  METHODS         */
    if ((v4)!=ECL_NIL) { goto L8; }
    T0 = v3;
    goto L7;
L8:;
    if ((v6)!=ECL_NIL) { goto L10; }
    T0 = ECL_T;
    goto L7;
L10:;
    {
     cl_object v7;
     v7 = LC1491only_slot_accessors_p(lex0, ECL_SYM("STANDARD-OPTIMIZED-READER-METHOD",1638));
     if (Null(v7)) { goto L13; }
     T0 = v7;
     goto L7;
L13:;
     {
      cl_object v8;
      v8 = LC1491only_slot_accessors_p(lex0, ECL_SYM("STANDARD-OPTIMIZED-WRITER-METHOD",1639));
      if (Null(v8)) { goto L16; }
      T0 = v8;
      goto L7;
L16:;
      T0 = ECL_SYM("STANDARD-GENERIC-FUNCTION",976);
     }
    }
L7:;
    value0 = clos_set_funcallable_instance_function(v1gf, T0);
    return value0;
   }
  }
 }
}
/*      local function ONLY-SLOT-ACCESSORS-P                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1491only_slot_accessors_p(volatile cl_object *lex0, cl_object v1class_name)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(lex0[0])) { goto L2; }
  {
   cl_object v2class;
   v2class = cl_find_class(2, v1class_name, ECL_NIL);
   {
    cl_object v3m;
    cl_object v4;
    v3m = ECL_NIL;
    {
     cl_object v5;
     v5 = lex0[0];
     if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v4 = v5;
    }
L10:;
    if (!(ecl_endp(v4))) { goto L12; }
    goto L11;
L12:;
    v3m = ECL_CONS_CAR(v4);
    {
     cl_object v5;
     v5 = ECL_CONS_CDR(v4);
     if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v4 = v5;
    }
    T0 = cl_class_of(v3m);
    if ((v2class)==(T0)) { goto L20; }
    goto L2;
L20:;
    goto L10;
L11:;
    goto L4;
   }
  }
L4:;
  value0 = v1class_name;
  cl_env_copy->nvalues = 1;
  return value0;
L2:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for STD-COMPUTE-APPLICABLE-METHODS        */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
cl_object clos_std_compute_applicable_methods(cl_object v1gf, cl_object v2args)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3methods;
   {
    cl_object v4;
    cl_object v5method;
    cl_object v6;
    v4 = ecl_instance_ref((v1gf),(7));
    v5method = ECL_NIL;
    {
     cl_object v7;
     v7 = v4;
     if (ecl_unlikely(!ECL_LISTP(v7))) FEtype_error_list(v7);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v6 = v7;
    }
    {
     cl_object v7;
     cl_object v8;
     v7 = ecl_list1(ECL_NIL);
     v8 = v7;
L9:;
     if (!(ecl_endp(v6))) { goto L11; }
     goto L10;
L11:;
     v5method = ECL_CONS_CAR(v6);
     {
      cl_object v9;
      v9 = ECL_CONS_CDR(v6);
      if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v6 = v9;
     }
     if (Null(LC1559applicable_method_p(v5method, v2args))) { goto L19; }
     {
      cl_object v9;
      v9 = v8;
      if (ecl_unlikely(ECL_ATOM(v9))) FEtype_error_cons(v9);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      T0 = v9;
     }
     v8 = ecl_list1(v5method);
     (ECL_CONS_CDR(T0)=v8,T0);
L19:;
     goto L9;
L10:;
     v3methods = ecl_cdr(v7);
     goto L1;
    }
   }
L1:;
   {
    cl_object v4;
    v4 = (ECL_SYM("CLASS-OF",937)->symbol.gfdef);
    {
     cl_object v5;
     cl_object v6;
     v5 = ECL_NIL;
     v6 = v2args;
     {
      cl_object v7;
      cl_object v8;
      v7 = ecl_list1(ECL_NIL);
      v8 = v7;
L33:;
      if (!(ecl_endp(v6))) { goto L35; }
      goto L34;
L35:;
      v5 = ECL_CONS_CAR(v6);
      {
       cl_object v9;
       v9 = ECL_CONS_CDR(v6);
       if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v6 = v9;
      }
      {
       cl_object v9;
       v9 = v8;
       if (ecl_unlikely(ECL_ATOM(v9))) FEtype_error_cons(v9);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       T1 = v9;
      }
      T2 = ecl_function_dispatch(cl_env_copy,v4)(1, v5);
      v8 = ecl_list1(T2);
      (ECL_CONS_CDR(T1)=v8,T1);
      goto L33;
L34:;
      T0 = ecl_cdr(v7);
      goto L27;
     }
    }
   }
L27:;
   value0 = L1664sort_applicable_methods(v1gf, v3methods, T0);
   return value0;
  }
 }
}
/*      local function METHOD-SPECIALIZERS                            */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object LC1554method_specializers(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(2));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function GENERIC-FUNCTION-METHODS                       */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object LC1536generic_function_methods(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(7));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function EQL-SPECIALIZER-FLAG                           */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object LC1528eql_specializer_flag(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(0));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function EQL-SPECIALIZER-OBJECT                         */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object LC1524eql_specializer_object(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(2));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function APPLICABLE-METHOD-P                            */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object LC1559applicable_method_p(cl_object v1method, cl_object v2args)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4spec;
   cl_object v5;
   v3 = ecl_instance_ref((v1method),(2));
   v4spec = ECL_NIL;
   {
    cl_object v6;
    v6 = v3;
    if (ecl_unlikely(!ECL_LISTP(v6))) FEtype_error_list(v6);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v5 = v6;
   }
   {
    cl_object v6arg;
    cl_object v7;
    v6arg = ECL_NIL;
    {
     cl_object v8;
     v8 = v2args;
     if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v7 = v8;
    }
L10:;
    if (!(ecl_endp(v5))) { goto L12; }
    goto L11;
L12:;
    v4spec = ECL_CONS_CAR(v5);
    {
     cl_object v8;
     v8 = ECL_CONS_CDR(v5);
     if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v5 = v8;
    }
    if (!(ecl_endp(v7))) { goto L20; }
    goto L11;
L20:;
    v6arg = ECL_CONS_CAR(v7);
    {
     cl_object v8;
     v8 = ECL_CONS_CDR(v7);
     if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v7 = v8;
    }
    if (Null(ecl_instance_ref((v4spec),(0)))) { goto L30; }
    T0 = ecl_instance_ref((v4spec),(2));
    if (ecl_eql(v6arg,T0)) { goto L28; }
    goto L29;
L30:;
    if ((si_of_class_p(2, v6arg, v4spec))!=ECL_NIL) { goto L28; }
L29:;
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 1;
    return value0;
L28:;
    goto L10;
L11:;
    value0 = ECL_T;
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      function definition for STD-COMPUTE-APPLICABLE-METHODS-USING-CLASSES */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object L1597std_compute_applicable_methods_using_classes(cl_object volatile v1gf, cl_object volatile v2classes)
{
 cl_object T0;
 cl_object volatile env0 = ECL_NIL;
 volatile struct ecl_cclosure aux_closure;
 cl_object volatile CLV0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   env0 = ECL_NIL;
   CLV0 = env0 = CONS(ECL_NEW_FRAME_ID(cl_env_copy),env0); /*  STD-COMPUTE-APPLICABLE-METHODS-USING-CLASSES */
   {
    ecl_frs_push(cl_env_copy,ECL_CONS_CAR(CLV0));
    if (__ecl_frs_push_result!=0) {
    value0 = cl_env_copy->values[0];
    ecl_frs_pop(cl_env_copy);
    return value0;
    } else {
    {
     cl_object v3methods;
     cl_object v4sorted_methods;
     {
      cl_object v5;
      cl_object v6method;
      cl_object v7;
      v5 = ecl_instance_ref((v1gf),(7));
      v6method = ECL_NIL;
      {
       cl_object v8;
       v8 = v5;
       if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v7 = v8;
      }
      {
       cl_object v8;
       cl_object v9;
       v8 = ecl_list1(ECL_NIL);
       v9 = v8;
L9:;
       if (!(ecl_endp(v7))) { goto L11; }
       goto L10;
L11:;
       v6method = ECL_CONS_CAR(v7);
       {
        cl_object v10;
        v10 = ECL_CONS_CDR(v7);
        if (ecl_unlikely(!ECL_LISTP(v10))) FEtype_error_list(v10);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v7 = v10;
       }
       if (Null((aux_closure.env=env0,cl_env_copy->function=(cl_object)&aux_closure,LC1596applicable_method_p(2, v6method, v2classes)))) { goto L19; }
       {
        cl_object v10;
        v10 = v9;
        if (ecl_unlikely(ECL_ATOM(v10))) FEtype_error_cons(v10);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        T0 = v10;
       }
       v9 = ecl_list1(v6method);
       (ECL_CONS_CDR(T0)=v9,T0);
L19:;
       goto L9;
L10:;
       v3methods = ecl_cdr(v8);
       goto L1;
      }
     }
L1:;
     v4sorted_methods = L1664sort_applicable_methods(v1gf, v3methods, v2classes);
     cl_env_copy->nvalues = 2;
     cl_env_copy->values[1] = ECL_T;
     cl_env_copy->values[0] = v4sorted_methods;
     value0 = cl_env_copy->values[0];
     ecl_frs_pop(cl_env_copy);
     return value0;
    }}
   }
  }
 }
}
/*      local function METHOD-SPECIALIZERS                            */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object LC1591method_specializers(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(2));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function EQL-SPECIALIZER-FLAG                           */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object LC1581eql_specializer_flag(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(0));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function EQL-SPECIALIZER-OBJECT                         */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object LC1577eql_specializer_object(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(2));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function GENERIC-FUNCTION-METHODS                       */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object LC1567generic_function_methods(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(7));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      closure APPLICABLE-METHOD-P                                   */
/*      optimize speed 3, debug 1, space 1, safety 2                  */
static cl_object LC1596applicable_method_p(cl_narg narg, cl_object v1method, cl_object v2classes, ...)
{
 cl_object CLV0;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV0 = env0;                                     /*  STD-COMPUTE-APPLICABLE-METHODS-USING-CLASSES */
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=2)) FEwrong_num_arguments_anonym();
 {
TTL:
  {
   cl_object v3eql_spec_p;
   v3eql_spec_p = ECL_NIL;
   {
    cl_object v4;
    cl_object v5spec;
    cl_object v6;
    v4 = ecl_instance_ref((v1method),(2));
    v5spec = ECL_NIL;
    {
     cl_object v7;
     v7 = v4;
     if (ecl_unlikely(!ECL_LISTP(v7))) FEtype_error_list(v7);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v6 = v7;
    }
    {
     cl_object v7class;
     cl_object v8;
     v7class = ECL_NIL;
     {
      cl_object v9;
      v9 = v2classes;
      if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v8 = v9;
     }
L11:;
     if (!(ecl_endp(v6))) { goto L13; }
     goto L12;
L13:;
     v5spec = ECL_CONS_CAR(v6);
     {
      cl_object v9;
      v9 = ECL_CONS_CDR(v6);
      if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v6 = v9;
     }
     if (!(ecl_endp(v8))) { goto L21; }
     goto L12;
L21:;
     v7class = ECL_CONS_CAR(v8);
     {
      cl_object v9;
      v9 = ECL_CONS_CDR(v8);
      if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v8 = v9;
     }
     if (Null(ecl_instance_ref((v5spec),(0)))) { goto L30; }
     {
      cl_object v9object;
      v9object = ecl_instance_ref((v5spec),(2));
      if (Null(si_of_class_p(2, v9object, v7class))) { goto L33; }
      v3eql_spec_p = ECL_T;
      goto L29;
L33:;
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 1;
      return value0;
     }
L30:;
     if ((si_subclassp(2, v7class, v5spec))!=ECL_NIL) { goto L29; }
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 1;
     return value0;
L29:;
     goto L11;
L12:;
     if (Null(v3eql_spec_p)) { goto L39; }
     cl_env_copy->nvalues = 2;
     cl_env_copy->values[1] = ECL_NIL;
     cl_env_copy->values[0] = ECL_NIL;
     cl_return_from(ECL_CONS_CAR(CLV0),VV[17]);
L39:;
     value0 = ECL_T;
     cl_env_copy->nvalues = 1;
     return value0;
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 1;
     return value0;
    }
   }
  }
 }
 }
}
/*      function definition for SORT-APPLICABLE-METHODS               */
/*      optimize speed 3, debug 1, space 1, safety 0                  */
static cl_object L1664sort_applicable_methods(cl_object v1gf, cl_object v2applicable_list, cl_object v3args_specializers)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
TTL:
 {
  cl_object v4;
  cl_object v5;
  cl_object v6args_classes;
  v4 = ecl_instance_ref((v1gf),(8));
  {
   cl_object v7arg_spec;
   cl_object v8;
   v7arg_spec = ECL_NIL;
   v8 = v3args_specializers;
   {
    cl_object v9;
    cl_object v10req_args;
    cl_object v11;
    v9 = ecl_instance_ref((v1gf),(4));
    v10req_args = ECL_NIL;
    v11 = v9;
    {
     cl_object v12;
     cl_object v13;
     v12 = ecl_list1(ECL_NIL);
     v13 = v12;
L10:;
     if (!(v8==ECL_NIL)) { goto L12; }
     goto L11;
L12:;
     v7arg_spec = ECL_CONS_CAR(v8);
     v8 = ECL_CONS_CDR(v8);
     if (!(v11==ECL_NIL)) { goto L18; }
     goto L11;
L18:;
     v10req_args = ECL_CONS_CAR(v11);
     v11 = ECL_CONS_CDR(v11);
     T0 = v13;
     if (Null(ecl_instance_ref((v7arg_spec),(0)))) { goto L27; }
     T2 = ecl_instance_ref((v7arg_spec),(2));
     T1 = cl_class_of(T2);
     goto L26;
L27:;
     T1 = v7arg_spec;
L26:;
     v13 = ecl_list1(T1);
     (ECL_CONS_CDR(T0)=v13,T0);
     goto L10;
L11:;
     v5 = _ecl_cdr(v12);
     goto L2;
    }
   }
  }
L2:;
  v6args_classes = v5;
  if (Null(v4)) { goto L33; }
  v6args_classes = ecl_function_dispatch(cl_env_copy,v4)(1, v6args_classes);
L33:;
  {
   cl_object v7scan;
   cl_object v8most_specific;
   cl_object v9ordered_list;
   v7scan = v2applicable_list;
   v8most_specific = _ecl_car(v7scan);
   v9ordered_list = ECL_NIL;
   goto L41;
L40:;
   {
    cl_object v10;
    v10 = _ecl_cdr(v7scan);
    goto L47;
L46:;
    {
     cl_object v11method;
     v11method = _ecl_car(v10);
     T0 = L1679compare_methods(v8most_specific, v11method, v6args_classes, v4);
     if (!((T0)==(ecl_make_fixnum(2)))) { goto L51; }
     v8most_specific = v11method;
L51:;
    }
    v10 = _ecl_cdr(v10);
L47:;
    if (Null(v10)) { goto L56; }
    goto L46;
L56:;
   }
   v7scan = cl_delete(2, v8most_specific, v7scan);
   v9ordered_list = CONS(v8most_specific,v9ordered_list);
   v8most_specific = _ecl_car(v7scan);
L41:;
   T0 = _ecl_cdr(v7scan);
   if (T0==ECL_NIL) { goto L64; }
   goto L40;
L64:;
   if (Null(v8most_specific)) { goto L66; }
   v9ordered_list = CONS(v8most_specific,v9ordered_list);
   value0 = cl_nreverse(v9ordered_list);
   return value0;
L66:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function GENERIC-FUNCTION-ARGUMENT-PRECEDENCE-ORDER     */
/*      optimize speed 3, debug 1, space 1, safety 0                  */
static cl_object LC1643generic_function_argument_precedence_order(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
TTL:
 value0 = ecl_instance_ref((v1object),(4));
 cl_env_copy->nvalues = 1;
 return value0;
}
/*      local function GENERIC-FUNCTION-A-P-O-FUNCTION                */
/*      optimize speed 3, debug 1, space 1, safety 0                  */
static cl_object LC1639generic_function_a_p_o_function(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
TTL:
 value0 = ecl_instance_ref((v1object),(8));
 cl_env_copy->nvalues = 1;
 return value0;
}
/*      local function EQL-SPECIALIZER-FLAG                           */
/*      optimize speed 3, debug 1, space 1, safety 0                  */
static cl_object LC1633eql_specializer_flag(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
TTL:
 value0 = ecl_instance_ref((v1object),(0));
 cl_env_copy->nvalues = 1;
 return value0;
}
/*      local function EQL-SPECIALIZER-OBJECT                         */
/*      optimize speed 3, debug 1, space 1, safety 0                  */
static cl_object LC1629eql_specializer_object(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
TTL:
 value0 = ecl_instance_ref((v1object),(2));
 cl_env_copy->nvalues = 1;
 return value0;
}
/*      function definition for COMPARE-METHODS                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1679compare_methods(cl_object v1method_1, cl_object v2method_2, cl_object v3args_classes, cl_object v4f)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v5;
   cl_object v6;
   cl_object v7specializers_list_1;
   cl_object v8specializers_list_2;
   v5 = ecl_instance_ref((v1method_1),(2));
   v6 = ecl_instance_ref((v2method_2),(2));
   v7specializers_list_1 = v5;
   v8specializers_list_2 = v6;
   if (Null(v4f)) { goto L5; }
   v7specializers_list_1 = ecl_function_dispatch(cl_env_copy,v4f)(1, v7specializers_list_1);
   v8specializers_list_2 = ecl_function_dispatch(cl_env_copy,v4f)(1, v8specializers_list_2);
L5:;
   value0 = L1680compare_specializers_lists(v7specializers_list_1, v8specializers_list_2, v3args_classes);
   return value0;
  }
 }
}
/*      local function METHOD-SPECIALIZERS                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1674method_specializers(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(2));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for COMPARE-SPECIALIZERS-LISTS            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1680compare_specializers_lists(cl_object v1spec_list_1, cl_object v2spec_list_2, cl_object v3args_classes)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if ((v1spec_list_1)!=ECL_NIL) { goto L3; }
  if (Null(v2spec_list_2)) { goto L1; }
  goto L2;
L3:;
L2:;
  {
   cl_object v4;
   T0 = ecl_car(v1spec_list_1);
   T1 = ecl_car(v2spec_list_2);
   T2 = ecl_car(v3args_classes);
   v4 = L1752compare_specializers(T0, T1, T2);
   if (!((v4)==(ecl_make_fixnum(1)))) { goto L6; }
   value0 = ecl_make_fixnum(1);
   cl_env_copy->nvalues = 1;
   return value0;
L6:;
   if (!((v4)==(ecl_make_fixnum(2)))) { goto L8; }
   value0 = ecl_make_fixnum(2);
   cl_env_copy->nvalues = 1;
   return value0;
L8:;
   if (!((v4)==(ECL_SYM("=",76)))) { goto L10; }
   v1spec_list_1 = ecl_cdr(v1spec_list_1);
   v2spec_list_2 = ecl_cdr(v2spec_list_2);
   v3args_classes = ecl_cdr(v3args_classes);
   goto TTL;
L10:;
   if (!((v4)==(ECL_NIL))) { goto L16; }
   value0 = ecl_car(v1spec_list_1);
   if ((value0)!=ECL_NIL) { goto L21; }
   T0 = ECL_T;
   goto L19;
L21:;
   T0 = value0;
   goto L19;
L19:;
   value0 = ecl_car(v2spec_list_2);
   if ((value0)!=ECL_NIL) { goto L25; }
   T1 = ECL_T;
   goto L23;
L25:;
   T1 = value0;
   goto L23;
L23:;
   T2 = ecl_car(v3args_classes);
   value0 = cl_error(4, VV[20], T0, T1, T2);
   return value0;
L16:;
   value0 = si_ecase_error(v4, VV[21]);
   return value0;
  }
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for FAST-SUBTYPEP                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1717fast_subtypep(cl_object v1spec1, cl_object v2spec2)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(ecl_instance_ref((v1spec1),(0)))) { goto L1; }
  if (Null(ecl_instance_ref((v2spec2),(0)))) { goto L3; }
  T0 = ecl_instance_ref((v1spec1),(2));
  T1 = ecl_instance_ref((v2spec2),(2));
  value0 = ecl_make_bool(ecl_eql(T0,T1));
  cl_env_copy->nvalues = 1;
  return value0;
L3:;
  T0 = ecl_instance_ref((v1spec1),(2));
  value0 = si_of_class_p(2, T0, v2spec2);
  return value0;
L1:;
  if (Null(ecl_instance_ref((v2spec2),(0)))) { goto L8; }
  T0 = ecl_instance_ref((v2spec2),(2));
  if (!(T0==ECL_NIL)) { goto L11; }
  T0 = (cl_env_copy->function=(ECL_SYM("CLASS-NAME",936)->symbol.gfdef))->cfun.entry(1, v1spec1) /*  CLASS-NAME */;
  value0 = ecl_make_bool((T0)==(ECL_SYM("NULL",607)));
  cl_env_copy->nvalues = 1;
  return value0;
L11:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
L8:;
  value0 = si_subclassp(2, v1spec1, v2spec2);
  return value0;
 }
}
/*      local function EQL-SPECIALIZER-FLAG                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1716eql_specializer_flag(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(0));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function EQL-SPECIALIZER-OBJECT                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1712eql_specializer_object(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(2));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for COMPARE-SPECIALIZERS                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1752compare_specializers(cl_object v1spec_1, cl_object v2spec_2, cl_object v3arg_class)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4cpl;
   v4cpl = ecl_instance_ref((v3arg_class),(7));
   if (!((v1spec_1)==(v2spec_2))) { goto L2; }
   value0 = ECL_SYM("=",76);
   cl_env_copy->nvalues = 1;
   return value0;
L2:;
   if (Null(L1717fast_subtypep(v1spec_1, v2spec_2))) { goto L4; }
   value0 = ecl_make_fixnum(1);
   cl_env_copy->nvalues = 1;
   return value0;
L4:;
   if (Null(L1717fast_subtypep(v2spec_2, v1spec_1))) { goto L6; }
   value0 = ecl_make_fixnum(2);
   cl_env_copy->nvalues = 1;
   return value0;
L6:;
   if (Null(ecl_instance_ref((v1spec_1),(0)))) { goto L8; }
   value0 = ecl_make_fixnum(1);
   cl_env_copy->nvalues = 1;
   return value0;
L8:;
   if (Null(ecl_instance_ref((v2spec_2),(0)))) { goto L10; }
   value0 = ecl_make_fixnum(2);
   cl_env_copy->nvalues = 1;
   return value0;
L10:;
   {
    cl_object v5;
    cl_object v6;
    cl_object v7;
    {
     cl_object v8;
     cl_object v9;
     v8 = v2spec_2;
     v9 = v4cpl;
     v5 = ecl_memql(v8,v9);
    }
    v6 = v1spec_1;
    v7 = v5;
    if (Null(ecl_memql(v6,v7))) { goto L12; }
   }
   value0 = ecl_make_fixnum(2);
   cl_env_copy->nvalues = 1;
   return value0;
L12:;
   {
    cl_object v5;
    cl_object v6;
    cl_object v7;
    {
     cl_object v8;
     cl_object v9;
     v8 = v1spec_1;
     v9 = v4cpl;
     v5 = ecl_memql(v8,v9);
    }
    v6 = v2spec_2;
    v7 = v5;
    if (Null(ecl_memql(v6,v7))) { goto L19; }
   }
   value0 = ecl_make_fixnum(1);
   cl_env_copy->nvalues = 1;
   return value0;
L19:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      local function EQL-SPECIALIZER-FLAG                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1751eql_specializer_flag(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(0));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function CLASS-PRECEDENCE-LIST                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1739class_precedence_list(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(7));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for COMPUTE-G-F-SPEC-LIST                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1790compute_g_f_spec_list(cl_object v1gf)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2;
   v2 = ecl_make_cfun((cl_objectfn_fixed)LC1762method_specializers,ECL_NIL,Cblock,1);
   {
    cl_object v3;
    v3 = ecl_make_cfun((cl_objectfn_fixed)LC1789nupdate_profile,ECL_NIL,Cblock,2);
    {
     cl_object v4;
     T0 = ecl_instance_ref((v1gf),(7));
     v4 = cl_reduce(6, v3, T0, ECL_SYM("KEY",1294), v2, VV[22], ECL_NIL);
     si_instance_set(v1gf, ecl_make_fixnum(1), v4);
    }
    {
     cl_object v4;
     cl_object v5;
     cl_object v6function;
     v4 = ecl_instance_ref((v1gf),(4));
     v5 = ecl_instance_ref((v1gf),(3));
     v6function = ECL_NIL;
     if (!(ECL_CONSP(v5))) { goto L8; }
     {
      cl_object v7required_arguments;
      T0 = si_process_lambda_list(v5, ECL_T);
      v7required_arguments = ecl_cdr(T0);
      if (ecl_equal(v4,v7required_arguments)) { goto L8; }
      T0 = CONS(ECL_SYM("LIST",483),v4);
      T1 = cl_list(4, ECL_SYM("DESTRUCTURING-BIND",302), v7required_arguments, VV[24], T0);
      T2 = cl_list(3, ECL_SYM("LAMBDA",454), VV[23], T1);
      v6function = si_coerce_to_function(T2);
     }
L8:;
     si_instance_set(v1gf, ecl_make_fixnum(8), v6function);
    }
    value0 = si_clear_gfun_hash(v1gf);
    return value0;
   }
  }
 }
}
/*      local function (SETF GENERIC-FUNCTION-SPEC-LIST)              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1787_setf_generic_function_spec_list_(cl_object v1value, cl_object v2object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = si_instance_set(v2object, ecl_make_fixnum(1), v1value);
  return value0;
 }
}
/*      local function GENERIC-FUNCTION-LAMBDA-LIST                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1784generic_function_lambda_list(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(3));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function GENERIC-FUNCTION-ARGUMENT-PRECEDENCE-ORDER     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1782generic_function_argument_precedence_order(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(4));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function GENERIC-FUNCTION-METHODS                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1780generic_function_methods(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(7));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function (SETF GENERIC-FUNCTION-A-P-O-FUNCTION)         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1777_setf_generic_function_a_p_o_function_(cl_object v1value, cl_object v2object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = si_instance_set(v2object, ecl_make_fixnum(8), v1value);
  return value0;
 }
}
/*      local function EQL-SPECIALIZER-FLAG                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1772eql_specializer_flag(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(0));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function EQL-SPECIALIZER-OBJECT                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1768eql_specializer_object(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(2));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function METHOD-SPECIALIZERS                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1762method_specializers(cl_object v1object)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_instance_ref((v1object),(2));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function NUPDATE-PROFILE                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC1789nupdate_profile(cl_object v1spec_how_list, cl_object v2specializers)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(v1spec_how_list==ECL_NIL)) { goto L1; }
  {
   cl_object v3spec;
   cl_object v4;
   v3spec = ECL_NIL;
   {
    cl_object v5;
    v5 = v2specializers;
    if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v4 = v5;
   }
   {
    cl_object v5;
    cl_object v6;
    v5 = ecl_list1(ECL_NIL);
    v6 = v5;
L9:;
    if (!(ecl_endp(v4))) { goto L11; }
    goto L10;
L11:;
    v3spec = ECL_CONS_CAR(v4);
    {
     cl_object v7;
     v7 = ECL_CONS_CDR(v4);
     if (ecl_unlikely(!ECL_LISTP(v7))) FEtype_error_list(v7);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v4 = v7;
    }
    {
     cl_object v7;
     v7 = v6;
     if (ecl_unlikely(ECL_ATOM(v7))) FEtype_error_cons(v7);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     T0 = v7;
    }
    if (Null(ecl_instance_ref((v3spec),(0)))) { goto L25; }
    T2 = ecl_instance_ref((v3spec),(2));
    T1 = cl_list(2, ECL_NIL, T2);
    goto L24;
L25:;
    T2 = cl_find_class(1, ECL_T);
    if (!((v3spec)==(T2))) { goto L28; }
    T1 = CONS(ECL_NIL,ECL_NIL);
    goto L24;
L28:;
    T1 = CONS(ECL_T,ECL_NIL);
L24:;
    v6 = ecl_list1(T1);
    (ECL_CONS_CDR(T0)=v6,T0);
    goto L9;
L10:;
    value0 = ecl_cdr(v5);
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
L1:;
  {
   cl_object v7spec;
   cl_object v8;
   v7spec = ECL_NIL;
   {
    cl_object v9;
    v9 = v2specializers;
    if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v8 = v9;
   }
   {
    cl_object v9;
    cl_object v10arg_profile;
    v9 = v1spec_how_list;
    v10arg_profile = ECL_NIL;
L38:;
    if (!(ecl_endp(v8))) { goto L40; }
    goto L39;
L40:;
    v7spec = ECL_CONS_CAR(v8);
    {
     cl_object v11;
     v11 = ECL_CONS_CDR(v8);
     if (ecl_unlikely(!ECL_LISTP(v11))) FEtype_error_list(v11);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v8 = v11;
    }
    if (!(ECL_ATOM(v9))) { goto L48; }
    goto L39;
L48:;
    v10arg_profile = ecl_car(v9);
    v9 = ECL_CONS_CDR(v9);
    if (Null(ecl_instance_ref((v7spec),(0)))) { goto L55; }
    {
     cl_object v11;
     cl_object v12;
     v11 = ecl_instance_ref((v7spec),(2));
     T0 = ecl_cdr(v10arg_profile);
     v12 = CONS(v11,T0);
     {
      cl_object v13;
      v13 = v10arg_profile;
      if (ecl_unlikely(ECL_ATOM(v13))) FEtype_error_cons(v13);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      T0 = v13;
     }
     (ECL_CONS_CDR(T0)=v12,T0);
     goto L54;
    }
L55:;
    if ((ecl_car(v10arg_profile))!=ECL_NIL) { goto L54; }
    T0 = cl_find_class(1, ECL_T);
    if ((v7spec)==(T0)) { goto L54; }
    {
     cl_object v13;
     v13 = ECL_T;
     {
      cl_object v14;
      v14 = v10arg_profile;
      if (ecl_unlikely(ECL_ATOM(v14))) FEtype_error_cons(v14);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      T0 = v14;
     }
     (ECL_CONS_CAR(T0)=v13,T0);
    }
L54:;
    goto L38;
L39:;
    value0 = v1spec_how_list;
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      function definition for PRINT-OBJECT                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L1791print_object(cl_object v1object, cl_object v2stream)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = si_print_unreadable_object_function(v1object, v2stream, ECL_NIL, ECL_NIL, ECL_NIL);
  return value0;
 }
}

#include "clos/kernel.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclfcsH3z4q37do9_QpYJpj61(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CLOS;KERNEL.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclfcsH3z4q37do9_QpYJpj61@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(VVtemp[0]);
  si_Xmake_special(VV[0]);
  cl_set(VV[0],ECL_NIL);
  ecl_cmp_defun(VV[27]);                          /*  SETF-FIND-CLASS */
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  {
   cl_object volatile v1;
   v1 = ecl_make_cfun_va((cl_objectfn)LC1465__lambda13,ECL_NIL,Cblock,1);
   T0 = v1;
  }
  si_do_defsetf(3, ECL_SYM("FIND-CLASS",945), T0, ecl_make_fixnum(1));
 }
  ecl_cmp_defun(VV[28]);                          /*  CLASSP          */
  ecl_cmp_defun(VV[29]);                          /*  INSTALL-METHOD  */
  ecl_cmp_defun(VV[30]);                          /*  WRAPPED-METHOD-FUNCTION */
  ecl_cmp_defun(VV[31]);                          /*  ENSURE-GENERIC-FUNCTION */
  ecl_cmp_defun(VV[33]);                          /*  (SETF GENERIC-FUNCTION-NAME) */
  ecl_cmp_defun(VV[35]);                          /*  STD-COMPUTE-DISCRIMINATING-FUNCTION */
  ecl_cmp_defun(VV[37]);                          /*  COMPUTE-DISCRIMINATING-FUNCTION */
  ecl_cmp_defun(VV[38]);                          /*  SET-GENERIC-FUNCTION-DISPATCH */
  (void)0; /* No entry created for STD-COMPUTE-APPLICABLE-METHODS */
  ecl_cmp_defun(VV[39]);                          /*  STD-COMPUTE-APPLICABLE-METHODS-USING-CLASSES */
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  T0 = (ECL_SYM("STD-COMPUTE-APPLICABLE-METHODS",1640)->symbol.gfdef);
  si_fset(2, ECL_SYM("COMPUTE-APPLICABLE-METHODS",938), T0);
 }
 {
  cl_object T0;
  cl_object volatile env0 = ECL_NIL;
  T0 = (VV[17]->symbol.gfdef);
  si_fset(2, ECL_SYM("COMPUTE-APPLICABLE-METHODS-USING-CLASSES",1566), T0);
 }
  ecl_cmp_defun(VV[40]);                          /*  SORT-APPLICABLE-METHODS */
  (void)0; /* No entry created for COMPARE-METHODS */
  (void)0; /* No entry created for COMPARE-SPECIALIZERS-LISTS */
  (void)0; /* No entry created for FAST-SUBTYPEP */
  (void)0; /* No entry created for COMPARE-SPECIALIZERS */
  ecl_cmp_defun(VV[41]);                          /*  COMPUTE-G-F-SPEC-LIST */
  ecl_cmp_defun(VV[42]);                          /*  PRINT-OBJECT    */
}
