/*      Compiler: ECL 23.9.9                                          */
/*      Source: /builddir/build/BUILD/ecl-23.9.9/src/cmp/cmpbackend-cxx/cmpc-inliner.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmpc-inliner.eclh"
/*      function definition for INLINED-ARG-LOC                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3635inlined_arg_loc(cl_object v1arg)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_cadr(v1arg);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for INLINED-ARG-TYPE                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3636inlined_arg_type(cl_object v1arg)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_car(v1arg);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for INLINED-ARG-REP-TYPE                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3637inlined_arg_rep_type(cl_object v1arg)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = ecl_cadr(v1arg);
  value0 = ecl_function_dispatch(cl_env_copy,VV[50])(1, T0) /*  LOC-REPRESENTATION-TYPE */;
  return value0;
 }
}
/*      local function DEFINE-C-INLINER                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3638define_c_inliner(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4fname;
   cl_object v5lambda_list;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[52])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4fname = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   ecl_function_dispatch(cl_env_copy,VV[52])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5lambda_list = v6;
   }
   T0 = cl_list(2, ECL_SYM("QUOTE",681), v4fname);
   T1 = cl_list(3, ECL_SYM("GETHASH",415), T0, VV[5]);
   T2 = cl_listX(3, ECL_SYM("BLOCK",139), ECL_NIL, v3);
   T3 = cl_list(3, ECL_SYM("LAMBDA",454), v5lambda_list, T2);
   T4 = cl_list(2, ECL_SYM("FUNCTION",398), T3);
   value0 = cl_list(3, ECL_SYM("SETF",752), T1, T4);
   return value0;
  }
 }
}
/*      function definition for APPLY-INLINER                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3639apply_inliner(cl_object v1fname, cl_object v2return_type, cl_object v3inlined_args)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4fd;
   v4fd = ecl_gethash_safe(v1fname,ecl_symbol_value(VV[5]),ECL_NIL);
   if (Null(v4fd)) { goto L2; }
   value0 = cl_apply(3, v4fd, v2return_type, v3inlined_args);
   return value0;
L2:;
   value0 = L3640default_c_inliner(v1fname, v2return_type, v3inlined_args);
   return value0;
  }
 }
}
/*      function definition for DEFAULT-C-INLINER                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3640default_c_inliner(cl_object v1fname, cl_object v2return_type, cl_object v3inlined_args)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4arg_types;
   cl_object v5ii;
   {
    cl_object v6;
    v6 = (ECL_SYM("FIRST",373)->symbol.gfdef);
    {
     cl_object v7;
     cl_object v8;
     v7 = ECL_NIL;
     {
      cl_object v9;
      v9 = v3inlined_args;
      if (ecl_unlikely(!ECL_LISTP(v9))) FEtype_error_list(v9);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v8 = v9;
     }
     {
      cl_object v9;
      cl_object v10;
      v9 = ecl_list1(ECL_NIL);
      v10 = v9;
L9:;
      if (!(ecl_endp(v8))) { goto L11; }
      goto L10;
L11:;
      v7 = ECL_CONS_CAR(v8);
      {
       cl_object v11;
       v11 = ECL_CONS_CDR(v8);
       if (ecl_unlikely(!ECL_LISTP(v11))) FEtype_error_list(v11);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v8 = v11;
      }
      {
       cl_object v11;
       v11 = v10;
       if (ecl_unlikely(ECL_ATOM(v11))) FEtype_error_cons(v11);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       T0 = v11;
      }
      T1 = ecl_function_dispatch(cl_env_copy,v6)(1, v7);
      v10 = ecl_list1(T1);
      (ECL_CONS_CDR(T0)=v10,T0);
      goto L9;
L10:;
      v4arg_types = ecl_cdr(v9);
      goto L1;
     }
    }
   }
L1:;
   v5ii = L3641inline_function(3, v1fname, v4arg_types, v2return_type);
   if (Null(v5ii)) { goto L29; }
   value0 = L3642apply_inline_info(v5ii, v3inlined_args);
   return value0;
L29:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for INLINE-FUNCTION                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3641inline_function(cl_narg narg, cl_object v1fname, cl_object v2arg_types, cl_object v3return_type, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<3)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>4)) FEwrong_num_arguments_anonym();
 {
  cl_object v4return_rep_type;
  va_list args; va_start(args,v3return_type);
  {
   int i = 3;
   if (i >= narg) {
    v4return_rep_type = VV[9];
   } else {
    i++;
    v4return_rep_type = va_arg(args,cl_object);
   }
  }
  va_end(args);
  if (Null(ecl_function_dispatch(cl_env_copy,VV[56])(1, v1fname) /*  INLINE-POSSIBLE */)) { goto L3; }
  if ((ecl_gethash_safe(v1fname,ecl_symbol_value(VV[10]),ECL_NIL))!=ECL_NIL) { goto L3; }
  {
   cl_object v5ii;
   v5ii = L3644get_inline_info(v1fname, v2arg_types, v3return_type, v4return_rep_type);
   value0 = v5ii;
   cl_env_copy->nvalues = 1;
   return value0;
  }
L3:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for APPLY-INLINE-INFO                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3642apply_inline_info(cl_object v1ii, cl_object v2inlined_locs)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3arg_types;
   cl_object v4out_rep_type;
   cl_object v5side_effects_p;
   cl_object v6fun;
   cl_object v7one_liner;
   v3arg_types = ecl_function_dispatch(cl_env_copy,VV[58])(1, v1ii) /*  INLINE-INFO-ARG-TYPES */;
   v4out_rep_type = ecl_function_dispatch(cl_env_copy,VV[59])(1, v1ii) /*  INLINE-INFO-RETURN-REP-TYPE */;
   T0 = ecl_function_dispatch(cl_env_copy,VV[60])(1, v1ii) /*  INLINE-INFO-NAME */;
   v5side_effects_p = ecl_function_dispatch(cl_env_copy,VV[61])(1, T0) /*  FUNCTION-MAY-HAVE-SIDE-EFFECTS */;
   v6fun = ecl_function_dispatch(cl_env_copy,VV[62])(1, v1ii) /*  INLINE-INFO-EXPANSION */;
   v7one_liner = ecl_function_dispatch(cl_env_copy,VV[63])(1, v1ii) /*  INLINE-INFO-ONE-LINER */;
   T0 = ecl_list1(v4out_rep_type);
   value0 = L3650produce_inline_loc(v2inlined_locs, v3arg_types, T0, v6fun, v5side_effects_p, v7one_liner);
   return value0;
  }
 }
}
/*      function definition for CHOOSE-INLINE-INFO                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3643choose_inline_info(cl_object v1ia, cl_object v2ib, cl_object v3return_type, cl_object v4return_rep_type)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if ((v4return_rep_type)==(VV[9])) { goto L1; }
  if ((v4return_rep_type)==(ECL_SYM("VOID",1421))) { goto L1; }
  {
   cl_object v5info_type;
   v5info_type = ecl_function_dispatch(cl_env_copy,VV[59])(1, v2ib) /*  INLINE-INFO-RETURN-REP-TYPE */;
   if ((v4return_rep_type)==(v5info_type)) { goto L1; }
   if ((v5info_type)==(VV[13])) { goto L1; }
  }
  value0 = v1ia;
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  if (!(v1ia==ECL_NIL)) { goto L7; }
  value0 = v2ib;
  cl_env_copy->nvalues = 1;
  return value0;
L7:;
  T0 = ecl_function_dispatch(cl_env_copy,VV[58])(1, v1ia) /*  INLINE-INFO-ARG-TYPES */;
  T1 = ecl_function_dispatch(cl_env_copy,VV[58])(1, v2ib) /*  INLINE-INFO-ARG-TYPES */;
  if (!(ecl_equal(T0,T1))) { goto L9; }
  value0 = v1ia;
  cl_env_copy->nvalues = 1;
  return value0;
L9:;
  T0 = ecl_fdefinition(VV[65]);
  T1 = ecl_function_dispatch(cl_env_copy,VV[58])(1, v1ia) /*  INLINE-INFO-ARG-TYPES */;
  T2 = ecl_function_dispatch(cl_env_copy,VV[58])(1, v2ib) /*  INLINE-INFO-ARG-TYPES */;
  if (Null(cl_every(3, T0, T1, T2))) { goto L11; }
  value0 = v2ib;
  cl_env_copy->nvalues = 1;
  return value0;
L11:;
  value0 = v1ia;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for GET-INLINE-INFO                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3644get_inline_info(cl_object v1fname, cl_object v2types, cl_object v3return_type, cl_object v4return_rep_type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v5output;
   v5output = ECL_NIL;
   if ((ecl_function_dispatch(cl_env_copy,VV[66])(0) /*  SAFE-COMPILE */)!=ECL_NIL) { goto L2; }
   {
    cl_object v6;
    v6 = ecl_function_dispatch(cl_env_copy,VV[67])(2, v1fname, VV[15]) /*  INLINE-INFORMATION */;
    goto L7;
L6:;
    {
     cl_object v7x;
     v7x = ecl_car(v6);
     {
      cl_object v8other;
      v8other = L3647inline_type_matches(v7x, v2types, v3return_type);
      if (Null(v8other)) { goto L11; }
      v5output = L3643choose_inline_info(v5output, v8other, v3return_type, v4return_rep_type);
     }
L11:;
    }
    v6 = ecl_cdr(v6);
L7:;
    if (Null(v6)) { goto L17; }
    goto L6;
L17:;
   }
L2:;
   {
    cl_object v6;
    v6 = ecl_function_dispatch(cl_env_copy,VV[67])(2, v1fname, VV[16]) /*  INLINE-INFORMATION */;
    goto L23;
L22:;
    {
     cl_object v7x;
     v7x = ecl_car(v6);
     {
      cl_object v8other;
      v8other = L3647inline_type_matches(v7x, v2types, v3return_type);
      if (Null(v8other)) { goto L27; }
      v5output = L3643choose_inline_info(v5output, v8other, v3return_type, v4return_rep_type);
     }
L27:;
    }
    v6 = ecl_cdr(v6);
L23:;
    if (Null(v6)) { goto L33; }
    goto L22;
L33:;
   }
   {
    cl_object v6;
    v6 = ecl_function_dispatch(cl_env_copy,VV[67])(2, v1fname, VV[17]) /*  INLINE-INFORMATION */;
    goto L39;
L38:;
    {
     cl_object v7x;
     v7x = ecl_car(v6);
     {
      cl_object v8other;
      v8other = L3647inline_type_matches(v7x, v2types, v3return_type);
      if (Null(v8other)) { goto L43; }
      v5output = L3643choose_inline_info(v5output, v8other, v3return_type, v4return_rep_type);
     }
L43:;
    }
    v6 = ecl_cdr(v6);
L39:;
    if (Null(v6)) { goto L49; }
    goto L38;
L49:;
   }
   if (!(v5output==ECL_NIL)) { goto L51; }
   if (Null(ecl_function_dispatch(cl_env_copy,VV[67])(2, v1fname, VV[18]) /*  INLINE-INFORMATION */)) { goto L51; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[68])(1, ECL_SYM("SPEED",793)) /*  CMP-ENV-OPTIMIZATION */;
   if (!(ecl_greatereq(T0,ecl_make_fixnum(1)))) { goto L51; }
   ecl_function_dispatch(cl_env_copy,VV[69])(3, VV[19], v1fname, v2types) /*  CMPWARN-STYLE */;
L51:;
   value0 = v5output;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for TO-FIXNUM-FLOAT-TYPE                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3645to_fixnum_float_type(cl_object v1type)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2;
   v2 = VV[20];
   goto L4;
L3:;
   {
    cl_object v3i;
    v3i = ecl_car(v2);
    if (Null(ecl_function_dispatch(cl_env_copy,VV[65])(2, v3i, v1type) /*  TYPE>= */)) { goto L8; }
    value0 = v3i;
    cl_env_copy->nvalues = 1;
    return value0;
L8:;
   }
   v2 = ecl_cdr(v2);
L4:;
   if (Null(v2)) { goto L12; }
   goto L3;
L12:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for MAXIMUM-FLOAT-TYPE                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3646maximum_float_type(cl_object v1t1, cl_object v2t2)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(v1t1==ECL_NIL)) { goto L1; }
  value0 = v2t2;
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  if ((v1t1)==(ECL_SYM("LONG-FLOAT",510))) { goto L5; }
  if (!((v2t2)==(ECL_SYM("LONG-FLOAT",510)))) { goto L3; }
  goto L4;
L5:;
L4:;
  value0 = ECL_SYM("LONG-FLOAT",510);
  cl_env_copy->nvalues = 1;
  return value0;
L3:;
  if ((v1t1)==(ECL_SYM("DOUBLE-FLOAT",317))) { goto L9; }
  if (!((v2t2)==(ECL_SYM("DOUBLE-FLOAT",317)))) { goto L7; }
  goto L8;
L9:;
L8:;
  value0 = ECL_SYM("DOUBLE-FLOAT",317);
  cl_env_copy->nvalues = 1;
  return value0;
L7:;
  if ((v1t1)==(ECL_SYM("SINGLE-FLOAT",780))) { goto L13; }
  if (!((v2t2)==(ECL_SYM("SINGLE-FLOAT",780)))) { goto L11; }
  goto L12;
L13:;
L12:;
  value0 = ECL_SYM("SINGLE-FLOAT",780);
  cl_env_copy->nvalues = 1;
  return value0;
L11:;
  value0 = ECL_SYM("FIXNUM",374);
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for INLINE-TYPE-MATCHES                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3647inline_type_matches(cl_object v1inline_info, cl_object v2arg_types, cl_object v3return_type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if ((ecl_function_dispatch(cl_env_copy,VV[73])(1, v1inline_info) /*  INLINE-INFO-MULTIPLE-VALUES */)!=ECL_NIL) { goto L1; }
  {
   cl_object v4;
   v4 = ecl_symbol_value(VV[23]);
   if (!((v4)==(ECL_SYM("VALUES",897)))) { goto L8; }
   goto L5;
   goto L6;
L8:;
   goto L6;
L6:;
   if (!((v4)==(ECL_SYM("RETURN",726)))) { goto L1; }
   goto L2;
L5:;
  }
L2:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  {
   cl_object v4rts;
   cl_object v5number_max;
   v4rts = ECL_NIL;
   v5number_max = ECL_NIL;
   {
    cl_object v6arg_types;
    cl_object v7types;
    v6arg_types = v2arg_types;
    v7types = ecl_function_dispatch(cl_env_copy,VV[58])(1, v1inline_info) /*  INLINE-INFO-ARG-TYPES */;
    goto L18;
L17:;
    {
     cl_object v8arg_type;
     cl_object v9type;
     v8arg_type = ecl_car(v6arg_types);
     v9type = ecl_car(v7types);
     if (!((v9type)==(VV[26]))) { goto L23; }
     {
      cl_object v10new_type;
      v10new_type = L3645to_fixnum_float_type(v8arg_type);
      if ((v10new_type)!=ECL_NIL) { goto L26; }
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 1;
      return value0;
L26:;
      v4rts = CONS(v10new_type,v4rts);
      v5number_max = L3646maximum_float_type(v5number_max, v10new_type);
      goto L20;
     }
L23:;
     if (Null(ecl_function_dispatch(cl_env_copy,VV[65])(2, v9type, v8arg_type) /*  TYPE>= */)) { goto L31; }
     v4rts = CONS(v9type,v4rts);
     goto L20;
L31:;
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 1;
     return value0;
    }
L20:;
    v6arg_types = ecl_cdr(v6arg_types);
    v7types = ecl_cdr(v7types);
L18:;
    if (ecl_endp(v6arg_types)) { goto L38; }
    if (ecl_endp(v7types)) { goto L38; }
    goto L17;
L38:;
    if ((v6arg_types)!=ECL_NIL) { goto L42; }
    if (Null(v7types)) { goto L13; }
    goto L41;
L42:;
L41:;
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 1;
    return value0;
   }
L13:;
   T0 = ecl_function_dispatch(cl_env_copy,VV[59])(1, v1inline_info) /*  INLINE-INFO-RETURN-REP-TYPE */;
   if ((T0)==(VV[13])) { goto L46; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[74])(1, v1inline_info) /*  INLINE-INFO-EXACT-RETURN-TYPE */;
   if (T0==ECL_NIL) { goto L46; }
   if (Null(ecl_function_dispatch(cl_env_copy,VV[75])(0) /*  POLICY-ASSUME-RIGHT-TYPE */)) { goto L44; }
   {
    cl_object v6inline_return_type;
    v6inline_return_type = ecl_function_dispatch(cl_env_copy,VV[76])(1, v1inline_info) /*  INLINE-INFO-RETURN-TYPE */;
    if (Null(v5number_max)) { goto L51; }
    if (!((v5number_max)==(ECL_SYM("FIXNUM",374)))) { goto L55; }
    v5number_max = ECL_SYM("INTEGER",439);
    goto L54;
L55:;
L54:;
    if (Null(v5number_max)) { goto L44; }
    if (Null(ecl_function_dispatch(cl_env_copy,VV[65])(2, v6inline_return_type, v5number_max) /*  TYPE>= */)) { goto L44; }
    if (Null(ecl_function_dispatch(cl_env_copy,VV[65])(2, v5number_max, v3return_type) /*  TYPE>= */)) { goto L44; }
    goto L45;
L51:;
    if (Null(ecl_function_dispatch(cl_env_copy,VV[65])(2, v6inline_return_type, v3return_type) /*  TYPE>= */)) { goto L44; }
    goto L45;
   }
L46:;
L45:;
   {
    cl_object v6inline_info;
    v6inline_info = cl_copy_structure(v1inline_info);
    {
     cl_object v7;
     v7 = cl_nreverse(v4rts);
     ecl_structure_set(v6inline_info,VV[27],3,v7);
    }
    value0 = v6inline_info;
    cl_env_copy->nvalues = 1;
    return value0;
   }
L44:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for C-INLINE-SAFE-STRING                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3648c_inline_safe_string(cl_object v1constant_string)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2c;
   cl_object v3;
   cl_fixnum v4;
   cl_fixnum v5;
   v2c = ECL_NIL;
   {
    cl_object v6;
    v6 = v1constant_string;
    if (ecl_unlikely(!ECL_VECTORP(v6))) FEtype_error_vector(v6);
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 0;
    v3 = v6;
   }
   v4 = 0;
   v5 = 0;
   {
    cl_object v6;
    cl_object v7;
    v6 = ecl_list1(ECL_NIL);
    v7 = v6;
    v5 = ecl_length(v3);
L10:;
    if (!((v4)>=(v5))) { goto L14; }
    goto L11;
L14:;
    {
     cl_object v8;
     v8 = v3;
     T1 = v8;
     {
      cl_fixnum v9;
      {
       cl_fixnum v10;
       v10 = v4;
       if (ecl_unlikely((v10)>=(v8)->vector.dim))
           FEwrong_index(ECL_NIL,v8,-1,ecl_make_fixnum(v10),(v8)->vector.dim);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v9 = v10;
      }
      v2c = ecl_aref_unsafe(T1,v9);
     }
    }
    {
     cl_object v8;
     v8 = ecl_make_integer((v4)+1);
     {
      bool v9;
      v9 = ECL_FIXNUMP(v8);
      if (ecl_unlikely(!(v9)))
         FEwrong_type_argument(ECL_SYM("FIXNUM",374),v8);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
     }
     v4 = ecl_fixnum(v8);
    }
    if (!(((v2c)==ECL_CODE_CHAR((ecl_character)(35))))) { goto L32; }
    goto L29;
    goto L30;
L32:;
    goto L30;
L30:;
    if (!(((v2c)==ECL_CODE_CHAR((ecl_character)(64))))) { goto L27; }
    goto L28;
L29:;
L28:;
    {
     cl_object v8;
     v8 = v7;
     if (ecl_unlikely(ECL_ATOM(v8))) FEtype_error_cons(v8);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     T1 = v8;
    }
    v7 = ecl_list1(v2c);
    (ECL_CONS_CDR(T1)=v7,T1);
L27:;
    {
     cl_object v8;
     v8 = v7;
     if (ecl_unlikely(ECL_ATOM(v8))) FEtype_error_cons(v8);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     T1 = v8;
    }
    v7 = ecl_list1(v2c);
    (ECL_CONS_CDR(T1)=v7,T1);
    goto L10;
L11:;
    T0 = ecl_cdr(v6);
    goto L1;
   }
  }
L1:;
  T1 = cl_concatenate(2, ECL_SYM("STRING",807), T0);
  value0 = ecl_function_dispatch(cl_env_copy,VV[78])(1, T1) /*  C-FILTERED-STRING */;
  return value0;
 }
}
/*      function definition for PRODUCE-INLINE-LOC                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3650produce_inline_loc(cl_object v1inlined_arguments, cl_object v2arg_types, cl_object v3output_rep_type, cl_object v4c_expression, cl_object v5side_effects, cl_object v6one_liner)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v7args_to_be_saved;
   cl_object v8coerced_arguments;
   v7args_to_be_saved = ECL_NIL;
   v8coerced_arguments = ECL_NIL;
   {
    cl_fixnum v9;
    v9 = ecl_length(v4c_expression);
    if (!((v9)>(1))) { goto L3; }
   }
   {
    ecl_character v9;
    v9 = ecl_char(v4c_expression,0);
    if (!((ECL_CODE_CHAR(v9))==(ECL_CODE_CHAR(64)))) { goto L3; }
   }
   {
    cl_object v9ndx;
    v9ndx = ecl_make_fixnum(1);
    goto L9;
L8:;
    {
     ecl_character v10c;
     v10c = ECL_CHAR_CODE(cl_char(v4c_expression, v9ndx));
     if (!((ECL_CODE_CHAR(v10c))==(ECL_CODE_CHAR(59)))) { goto L13; }
     T0 = ecl_one_plus(v9ndx);
     v4c_expression = cl_subseq(2, v4c_expression, T0);
     goto L3;
L13:;
     if (ecl_alphanumericp(v10c)) { goto L17; }
     v7args_to_be_saved = ECL_NIL;
     goto L3;
L17:;
     {
      cl_fixnum v11;
      v11 = v10c;
      {
       cl_fixnum v12;
       v12 = (ecl_character)(48);
       T0 = ecl_minus(ecl_make_fixnum(v11),ecl_make_fixnum(v12));
       v7args_to_be_saved = CONS(T0,v7args_to_be_saved);
      }
     }
    }
    v9ndx = ecl_one_plus(v9ndx);
L9:;
    {
     cl_fixnum v10;
     v10 = ecl_length(v4c_expression);
     if (ecl_greatereq(v9ndx,ecl_make_fixnum(v10))) { goto L24; }
    }
    goto L8;
L24:;
   }
L3:;
   v8coerced_arguments = L3651coerce_locs(3, v1inlined_arguments, v2arg_types, v7args_to_be_saved);
   if (!(v3output_rep_type==ECL_NIL)) { goto L28; }
   if (Null(v5side_effects)) { goto L31; }
   ecl_function_dispatch(cl_env_copy,VV[80])(0)   /*  WT-NL           */;
   ecl_function_dispatch(cl_env_copy,VV[81])(5, v3output_rep_type, v4c_expression, v8coerced_arguments, ECL_T, ECL_NIL) /*  WT-C-INLINE-LOC */;
   if (Null(v6one_liner)) { goto L30; }
   ecl_function_dispatch(cl_env_copy,VV[82])(1, VV[32]) /*  WT        */;
   goto L30;
L31:;
   ecl_function_dispatch(cl_env_copy,VV[83])(2, VV[33], v4c_expression) /*  CMPNOTE */;
L30:;
   ecl_function_dispatch(cl_env_copy,VV[80])(1, VV[34]) /*  WT-NL     */;
   ecl_function_dispatch(cl_env_copy,VV[80])(1, VV[35]) /*  WT-NL     */;
   value0 = ECL_SYM("RETURN",726);
   cl_env_copy->nvalues = 1;
   return value0;
L28:;
   if (Null(v6one_liner)) { goto L38; }
   if (!(ecl_equalp(v3output_rep_type,VV[36]))) { goto L41; }
   T0 = ECL_SYM("VALUES",897);
   goto L40;
L41:;
   T0 = ECL_NIL;
L40:;
   value0 = cl_list(6, ECL_SYM("C-INLINE",2092), v3output_rep_type, v4c_expression, v8coerced_arguments, v5side_effects, T0);
   return value0;
L38:;
   if (!(ecl_equalp(v3output_rep_type,VV[36]))) { goto L43; }
   ecl_function_dispatch(cl_env_copy,VV[81])(5, v3output_rep_type, v4c_expression, v8coerced_arguments, v5side_effects, ECL_SYM("VALUES",897)) /*  WT-C-INLINE-LOC */;
   value0 = ECL_SYM("VALUES",897);
   cl_env_copy->nvalues = 1;
   return value0;
L43:;
   {
    cl_object v9;
    v9 = ecl_make_cfun((cl_objectfn_fixed)LC3649make_output_var,ECL_NIL,Cblock,1);
    ecl_function_dispatch(cl_env_copy,VV[84])(0)  /*  OPEN-INLINE-BLOCK */;
    {
     cl_object v10output_vars;
     {
      cl_object v11;
      cl_object v12;
      v11 = ECL_NIL;
      {
       cl_object v13;
       v13 = v3output_rep_type;
       if (ecl_unlikely(!ECL_LISTP(v13))) FEtype_error_list(v13);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v12 = v13;
      }
      {
       cl_object v13;
       cl_object v14;
       v13 = ecl_list1(ECL_NIL);
       v14 = v13;
L54:;
       if (!(ecl_endp(v12))) { goto L56; }
       goto L55;
L56:;
       v11 = ECL_CONS_CAR(v12);
       {
        cl_object v15;
        v15 = ECL_CONS_CDR(v12);
        if (ecl_unlikely(!ECL_LISTP(v15))) FEtype_error_list(v15);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v12 = v15;
       }
       {
        cl_object v15;
        v15 = v14;
        if (ecl_unlikely(ECL_ATOM(v15))) FEtype_error_cons(v15);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        T0 = v15;
       }
       T1 = ecl_function_dispatch(cl_env_copy,v9)(1, v11);
       v14 = ecl_list1(T1);
       (ECL_CONS_CDR(T0)=v14,T0);
       goto L54;
L55:;
       v10output_vars = ecl_cdr(v13);
       goto L47;
      }
     }
L47:;
     ecl_function_dispatch(cl_env_copy,VV[81])(5, v3output_rep_type, v4c_expression, v8coerced_arguments, v5side_effects, v10output_vars) /*  WT-C-INLINE-LOC */;
     {
      cl_fixnum v11;
      v11 = ecl_length(v10output_vars);
      if (!((v11)==(1))) { goto L73; }
     }
     value0 = ecl_car(v10output_vars);
     cl_env_copy->nvalues = 1;
     return value0;
L73:;
     {
      cl_object v11v;
      cl_object v12;
      v11v = ECL_NIL;
      {
       cl_object v13;
       v13 = v10output_vars;
       if (ecl_unlikely(!ECL_LISTP(v13))) FEtype_error_list(v13);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v12 = v13;
      }
      {
       cl_object v13i;
       v13i = ecl_make_fixnum(0);
       if (!(ecl_endp(v12))) { goto L83; }
       goto L82;
L83:;
       v11v = ECL_CONS_CAR(v12);
       {
        cl_object v14;
        v14 = ECL_CONS_CDR(v12);
        if (ecl_unlikely(!ECL_LISTP(v14))) FEtype_error_list(v14);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v12 = v14;
       }
L81:;
       T0 = cl_list(2, VV[39], v13i);
       ecl_bds_bind(cl_env_copy,VV[23],T0);       /*  *DESTINATION*   */
       ecl_function_dispatch(cl_env_copy,VV[85])(1, v11v) /*  SET-LOC */;
       ecl_bds_unwind1(cl_env_copy);
       if (!(ecl_endp(v12))) { goto L92; }
       goto L82;
L92:;
       v11v = ECL_CONS_CAR(v12);
       {
        cl_object v14;
        v14 = ECL_CONS_CDR(v12);
        if (ecl_unlikely(!ECL_LISTP(v14))) FEtype_error_list(v14);
        value0 = ECL_NIL;
        cl_env_copy->nvalues = 0;
        v12 = v14;
       }
       v13i = ecl_one_plus(v13i);
       goto L81;
L82:;
      }
     }
     {
      cl_fixnum v11;
      v11 = ecl_length(v10output_vars);
      ecl_function_dispatch(cl_env_copy,VV[82])(3, VV[40], ecl_make_fixnum(v11), VV[32]) /*  WT */;
     }
     value0 = ECL_SYM("VALUES",897);
     cl_env_copy->nvalues = 1;
     return value0;
    }
   }
  }
 }
}
/*      local function MAKE-OUTPUT-VAR                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3649make_output_var(cl_object v1type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2var;
   v2var = ecl_function_dispatch(cl_env_copy,VV[86])(2, VV[37], v1type) /*  MAKE-LCL-VAR */;
   T0 = ecl_function_dispatch(cl_env_copy,VV[87])(1, v1type) /*  REP-TYPE->C-NAME */;
   ecl_function_dispatch(cl_env_copy,VV[80])(4, T0, VV[38], v2var, VV[32]) /*  WT-NL */;
   value0 = v2var;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for COERCE-LOCS                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3651coerce_locs(cl_narg narg, cl_object v1inlined_args, ...)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>3)) FEwrong_num_arguments_anonym();
 {
  cl_object v2types;
  cl_object v3args_to_be_saved;
  va_list args; va_start(args,v1inlined_args);
  {
   int i = 1;
   if (i >= narg) {
    v2types = ECL_NIL;
   } else {
    i++;
    v2types = va_arg(args,cl_object);
   }
   if (i >= narg) {
    v3args_to_be_saved = ECL_NIL;
   } else {
    i++;
    v3args_to_be_saved = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   cl_object v4block_opened;
   v4block_opened = ECL_NIL;
   {
    cl_object v5lisp_type;
    cl_object v6loc;
    cl_object v7;
    v5lisp_type = ECL_NIL;
    v6loc = ECL_NIL;
    {
     cl_object v8;
     v8 = v1inlined_args;
     if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v7 = v8;
    }
    {
     cl_object v8;
     cl_object v9type;
     cl_object v10;
     value0 = v2types;
     if ((value0)!=ECL_NIL) { goto L11; }
     v8 = VV[42];
     goto L9;
L11:;
     v8 = value0;
     goto L9;
L9:;
     v9type = ECL_NIL;
     {
      cl_object v11;
      v11 = v8;
      if (ecl_unlikely(!ECL_LISTP(v11))) FEtype_error_list(v11);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v10 = v11;
     }
     {
      cl_object v11i;
      v11i = ecl_make_fixnum(0);
      {
       cl_object v12rep_type;
       v12rep_type = ECL_NIL;
       {
        cl_object v13;
        cl_object v14;
        v13 = ecl_list1(ECL_NIL);
        v14 = v13;
        if (!(ecl_endp(v7))) { goto L23; }
        goto L22;
L23:;
        {
         cl_object v15;
         v15 = ECL_CONS_CAR(v7);
         v5lisp_type = ecl_car(v15);
         v15 = ecl_cdr(v15);
         v6loc = ecl_car(v15);
        }
        {
         cl_object v15;
         v15 = ECL_CONS_CDR(v7);
         if (ecl_unlikely(!ECL_LISTP(v15))) FEtype_error_list(v15);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         v7 = v15;
        }
        if (!(ecl_endp(v10))) { goto L36; }
        goto L22;
L36:;
        v9type = ECL_CONS_CAR(v10);
        {
         cl_object v15;
         v15 = ECL_CONS_CDR(v10);
         if (ecl_unlikely(!ECL_LISTP(v15))) FEtype_error_list(v15);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         v10 = v15;
        }
L21:;
        v12rep_type = ecl_function_dispatch(cl_env_copy,VV[89])(1, v9type) /*  LISP-TYPE->REP-TYPE */;
        {
         cl_object v15;
         v15 = v14;
         if (ecl_unlikely(ECL_ATOM(v15))) FEtype_error_cons(v15);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         T0 = v15;
        }
        if (Null(v3args_to_be_saved)) { goto L52; }
        {
         cl_object v15;
         cl_object v16;
         cl_object v17;
         v15 = (ECL_SYM("EQL",336)->symbol.gfdef);
         v16 = v11i;
         v17 = v3args_to_be_saved;
         if (Null(ecl_memql(v16,v17))) { goto L52; }
        }
        if ((ecl_function_dispatch(cl_env_copy,VV[90])(1, v6loc) /*  LOC-MOVABLE-P */)!=ECL_NIL) { goto L52; }
        {
         cl_object v15lcl;
         v15lcl = ecl_function_dispatch(cl_env_copy,VV[86])(2, VV[37], v12rep_type) /*  MAKE-LCL-VAR */;
         ecl_function_dispatch(cl_env_copy,VV[80])(0) /*  WT-NL       */;
         if ((v4block_opened)!=ECL_NIL) { goto L61; }
         v4block_opened = ECL_T;
         ecl_function_dispatch(cl_env_copy,VV[84])(0) /*  OPEN-INLINE-BLOCK */;
L61:;
         T2 = ecl_function_dispatch(cl_env_copy,VV[87])(1, v12rep_type) /*  REP-TYPE->C-NAME */;
         ecl_function_dispatch(cl_env_copy,VV[82])(4, T2, VV[38], v15lcl, VV[43]) /*  WT */;
         ecl_function_dispatch(cl_env_copy,VV[91])(2, v12rep_type, v6loc) /*  WT-COERCE-LOC */;
         ecl_function_dispatch(cl_env_copy,VV[82])(1, VV[32]) /*  WT  */;
         T1 = v15lcl;
         goto L51;
        }
L52:;
        T2 = ecl_function_dispatch(cl_env_copy,VV[50])(1, v6loc) /*  LOC-REPRESENTATION-TYPE */;
        if (!(ecl_equal(v12rep_type,T2))) { goto L68; }
        T1 = v6loc;
        goto L51;
L68:;
        T1 = cl_list(3, VV[44], v12rep_type, v6loc);
L51:;
        v14 = ecl_list1(T1);
        (ECL_CONS_CDR(T0)=v14,T0);
        if (!(ecl_endp(v7))) { goto L70; }
        goto L22;
L70:;
        {
         cl_object v15;
         v15 = ECL_CONS_CAR(v7);
         v5lisp_type = ecl_car(v15);
         v15 = ecl_cdr(v15);
         v6loc = ecl_car(v15);
        }
        {
         cl_object v15;
         v15 = ECL_CONS_CDR(v7);
         if (ecl_unlikely(!ECL_LISTP(v15))) FEtype_error_list(v15);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         v7 = v15;
        }
        if (!(ecl_endp(v10))) { goto L83; }
        goto L22;
L83:;
        v9type = ECL_CONS_CAR(v10);
        {
         cl_object v15;
         v15 = ECL_CONS_CDR(v10);
         if (ecl_unlikely(!ECL_LISTP(v15))) FEtype_error_list(v15);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         v10 = v15;
        }
        v11i = ecl_one_plus(v11i);
        goto L21;
L22:;
        value0 = ecl_cdr(v13);
        cl_env_copy->nvalues = 1;
        return value0;
       }
      }
     }
    }
   }
  }
 }
}

#include "cmp/cmpc-inliner.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclnWL9Qg2BrwKr9_xAqJpj61(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPBACKEND-CXX;CMPC-INLINER.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclnWL9Qg2BrwKr9_xAqJpj61@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(VVtemp[0]);
  {
   cl_object v1;
   v1 = ecl_symbol_value(VV[0]);
   {
    cl_object v2;
    v2 = ecl_function_dispatch(cl_env_copy,VV[46])(1, ecl_symbol_value(VV[0])) /*  MAKE-INLINE-INFORMATION */;
    ecl_structure_set(v1,VV[1],3,v2);
   }
  }
  ecl_cmp_defun(VV[47]);                          /*  INLINED-ARG-LOC */
  ecl_cmp_defun(VV[48]);                          /*  INLINED-ARG-TYPE */
  ecl_cmp_defun(VV[49]);                          /*  INLINED-ARG-REP-TYPE */
  ecl_cmp_defmacro(VV[51]);                       /*  DEFINE-C-INLINER */
  ecl_cmp_defun(VV[53]);                          /*  APPLY-INLINER   */
  ecl_cmp_defun(VV[54]);                          /*  DEFAULT-C-INLINER */
  ecl_cmp_defun(VV[55]);                          /*  INLINE-FUNCTION */
  ecl_cmp_defun(VV[57]);                          /*  APPLY-INLINE-INFO */
  ecl_cmp_defun(VV[64]);                          /*  CHOOSE-INLINE-INFO */
  (void)0; /* No entry created for GET-INLINE-INFO */
  ecl_cmp_defun(VV[70]);                          /*  TO-FIXNUM-FLOAT-TYPE */
  ecl_cmp_defun(VV[71]);                          /*  MAXIMUM-FLOAT-TYPE */
  ecl_cmp_defun(VV[72]);                          /*  INLINE-TYPE-MATCHES */
  ecl_cmp_defun(VV[77]);                          /*  C-INLINE-SAFE-STRING */
  ecl_cmp_defun(VV[79]);                          /*  PRODUCE-INLINE-LOC */
  ecl_cmp_defun(VV[88]);                          /*  COERCE-LOCS     */
}
