/*      Compiler: ECL 23.9.9                                          */
/*      Source: /builddir/build/BUILD/ecl-23.9.9/src/cmp/cmpbackend-cxx/cmppass2-call.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmppass2-call.eclh"
/*      function definition for MAYBE-SAVE-VALUE                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3760maybe_save_value(cl_narg narg, cl_object v1value, ...)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2other_forms;
  cl_object v3other_forms_flag;
  va_list args; va_start(args,v1value);
  {
   int i = 1;
   if (i >= narg) {
    v2other_forms = ECL_NIL;
    v3other_forms_flag = ECL_NIL;
   } else {
    i++;
    v2other_forms = va_arg(args,cl_object);
    v3other_forms_flag = ECL_T;
   }
  }
  va_end(args);
  {
   cl_object v4name;
   v4name = ecl_function_dispatch(cl_env_copy,VV[51])(1, v1value) /*  C1FORM-NAME */;
   if (!((v4name)==(VV[0]))) { goto L3; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[52])(1, v1value) /*  C1FORM-ARGS */;
   value0 = ecl_car(T0);
   cl_env_copy->nvalues = 1;
   return value0;
L3:;
   if (!((v4name)==(VV[1]))) { goto L5; }
   if (Null(v3other_forms_flag)) { goto L5; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[52])(1, v1value) /*  C1FORM-ARGS */;
   T1 = ecl_car(T0);
   if ((ecl_function_dispatch(cl_env_copy,VV[53])(2, T1, v2other_forms) /*  VAR-CHANGED-IN-FORM-LIST */)!=ECL_NIL) { goto L5; }
   T0 = ecl_function_dispatch(cl_env_copy,VV[52])(1, v1value) /*  C1FORM-ARGS */;
   value0 = ecl_car(T0);
   cl_env_copy->nvalues = 1;
   return value0;
L5:;
   {
    cl_object v5temp;
    v5temp = ecl_function_dispatch(cl_env_copy,VV[54])(0) /*  MAKE-TEMP-VAR */;
    ecl_bds_bind(cl_env_copy,VV[2],v5temp);       /*  *DESTINATION*   */
    ecl_function_dispatch(cl_env_copy,VV[55])(1, v1value) /*  C2EXPR* */;
    value0 = v5temp;
    cl_env_copy->nvalues = 1;
    ecl_bds_unwind1(cl_env_copy);
    return value0;
   }
  }
 }
}
/*      function definition for C2FUNCALL                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3761c2funcall(cl_object v1c1form, cl_object v2form, cl_object v3args)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4form_type;
   cl_object v5function_p;
   cl_object v6loc;
   ecl_bds_bind(cl_env_copy,VV[4],ecl_make_fixnum(0)); /*  *INLINE-BLOCKS* */
   ecl_bds_push(cl_env_copy,VV[5]);               /*  *TEMP*          */
   v4form_type = ecl_function_dispatch(cl_env_copy,VV[57])(1, v2form) /*  C1FORM-PRIMARY-TYPE */;
   if (Null(cl_subtypep(2, v4form_type, ECL_SYM("FUNCTION",398)))) { goto L4; }
   v5function_p = ecl_function_dispatch(cl_env_copy,VV[58])(0) /*  POLICY-ASSUME-RIGHT-TYPE */;
   goto L2;
L4:;
   v5function_p = ECL_NIL;
   goto L2;
L2:;
   v6loc = L3760maybe_save_value(2, v2form, v3args);
   T0 = ecl_function_dispatch(cl_env_copy,VV[59])(1, v3args) /*  INLINE-ARGS */;
   T1 = L3770call_unknown_global_loc(4, ECL_NIL, v6loc, T0, v5function_p);
   ecl_function_dispatch(cl_env_copy,VV[60])(1, T1) /*  UNWIND-EXIT   */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[61])(0) /*  CLOSE-INLINE-BLOCKS */;
   ecl_bds_unwind1(cl_env_copy);
   ecl_bds_unwind1(cl_env_copy);
   return value0;
  }
 }
}
/*      function definition for C2CALL-GLOBAL                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3762c2call_global(cl_object v1c1form, cl_object v2fname, cl_object v3args)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v4fun;
   {
    cl_object v5;
    cl_object v6;
    cl_object v7;
    v5 = ecl_symbol_value(VV[7]);
    v6 = ecl_fdefinition(VV[63]);
    v7 = ecl_fdefinition(VV[64]);
    {
     cl_object v8;
     v8 = ecl_function_dispatch(cl_env_copy,VV[65])(2, v5, ecl_make_fixnum(0)) /*  MAKE-SEQ-ITERATOR */;
L6:;
     if ((v8)!=ECL_NIL) { goto L8; }
     v4fun = ECL_NIL;
     goto L1;
L8:;
     {
      cl_object v9;
      v9 = ecl_function_dispatch(cl_env_copy,VV[66])(2, v5, v8) /*  SEQ-ITERATOR-REF */;
      T0 = ecl_function_dispatch(cl_env_copy,VV[63])(1, v9) /*  FUN-NAME */;
      if (Null(ecl_function_dispatch(cl_env_copy,VV[64])(2, v2fname, T0) /*  SAME-FNAME-P */)) { goto L10; }
      v4fun = v9;
      goto L1;
     }
L10:;
     v8 = ecl_function_dispatch(cl_env_copy,VV[67])(2, v5, v8) /*  SEQ-ITERATOR-NEXT */;
     goto L6;
    }
   }
L1:;
   if (Null(v4fun)) { goto L16; }
   if (Null(L3765c2try_tail_recursive_call(v4fun, v3args))) { goto L16; }
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
L16:;
   ecl_bds_bind(cl_env_copy,VV[4],ecl_make_fixnum(0)); /*  *INLINE-BLOCKS* */
   ecl_bds_push(cl_env_copy,VV[5]);               /*  *TEMP*          */
   T0 = ecl_function_dispatch(cl_env_copy,VV[57])(1, v1c1form) /*  C1FORM-PRIMARY-TYPE */;
   T1 = ecl_function_dispatch(cl_env_copy,VV[68])(1, ecl_symbol_value(VV[2])) /*  LOC-TYPE */;
   T2 = L3767call_global_loc(v2fname, v4fun, v3args, T0, T1);
   ecl_function_dispatch(cl_env_copy,VV[60])(1, T2) /*  UNWIND-EXIT   */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[61])(0) /*  CLOSE-INLINE-BLOCKS */;
   ecl_bds_unwind1(cl_env_copy);
   ecl_bds_unwind1(cl_env_copy);
   return value0;
  }
 }
}
/*      function definition for TAIL-RECURSION-POSSIBLE               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3763tail_recursion_possible()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v1;
   v1 = ecl_symbol_value(VV[9]);
   goto L4;
L3:;
   {
    cl_object v2ue;
    v2ue = ecl_car(v1);
    if (!((v2ue)==(VV[10]))) { goto L9; }
    value0 = ECL_T;
    cl_env_copy->nvalues = 1;
    return value0;
L9:;
    if (ecl_numberp(v2ue)) { goto L13; }
    if ((v2ue)==(VV[11])) { goto L13; }
    if (!((v2ue)==(VV[12]))) { goto L11; }
    goto L12;
L13:;
L12:;
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 1;
    return value0;
L11:;
    {
     cl_object v3;
     value0 = ecl_make_bool(ECL_CONSP(v2ue));
     if ((value0)!=ECL_NIL) { goto L18; }
     value0 = ecl_make_bool((v2ue)==(VV[13]));
     if ((value0)!=ECL_NIL) { goto L18; }
     v3 = ecl_make_bool((v2ue)==(VV[14]));
     goto L16;
L18:;
     v3 = value0;
     goto L16;
L16:;
     if (Null(v3)) { goto L21; }
     goto L8;
L21:;
     ecl_function_dispatch(cl_env_copy,VV[70])(2, ECL_SYM("FORMAT-CONTROL",1269), VV[15]) /*  BABOON */;
    }
L8:;
   }
   v1 = ecl_cdr(v1);
L4:;
   if (Null(v1)) { goto L25; }
   goto L3;
L25:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[70])(2, ECL_SYM("FORMAT-CONTROL",1269), VV[16]) /*  BABOON */;
   return value0;
  }
 }
}
/*      function definition for LAST-CALL-P                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3764last_call_p()
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v1;
   cl_object v2;
   cl_object v3;
   v1 = ecl_symbol_value(VV[18]);
   v2 = v1;
   v3 = VV[19];
   value0 = ecl_memql(v2,v3);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for C2TRY-TAIL-RECURSIVE-CALL             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3765c2try_tail_recursive_call(cl_object v1fun, cl_object v2args)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(ecl_symbol_value(VV[21]))) { goto L1; }
  T0 = ecl_car(ecl_symbol_value(VV[21]));
  if (!((v1fun)==(T0))) { goto L1; }
  if (Null(L3764last_call_p())) { goto L1; }
  if (Null(L3763tail_recursion_possible())) { goto L1; }
  T0 = ecl_function_dispatch(cl_env_copy,VV[63])(1, v1fun) /*  FUN-NAME */;
  if (Null(ecl_function_dispatch(cl_env_copy,VV[73])(1, T0) /*  INLINE-POSSIBLE */)) { goto L1; }
  {
   cl_fixnum v3;
   v3 = ecl_length(v2args);
   T0 = ecl_cdr(ecl_symbol_value(VV[21]));
   {
    cl_fixnum v4;
    v4 = ecl_length(T0);
    if (!((v3)==(v4))) { goto L1; }
   }
  }
  ecl_bds_bind(cl_env_copy,VV[2],VV[22]);         /*  *DESTINATION*   */
  T0 = ecl_function_dispatch(cl_env_copy,VV[74])(0) /*  NEXT-LABEL    */;
  ecl_bds_bind(cl_env_copy,VV[18],T0);            /*  *EXIT*          */
  T0 = CONS(ecl_symbol_value(VV[18]),ecl_symbol_value(VV[9]));
  ecl_bds_bind(cl_env_copy,VV[9],T0);             /*  *UNWIND-EXIT*   */
  T0 = ecl_cdr(ecl_symbol_value(VV[21]));
  ecl_function_dispatch(cl_env_copy,VV[75])(3, ECL_NIL, T0, v2args) /*  C2PSETQ */;
  ecl_function_dispatch(cl_env_copy,VV[76])(1, ecl_symbol_value(VV[18])) /*  WT-LABEL */;
  ecl_bds_unwind1(cl_env_copy);
  ecl_bds_unwind1(cl_env_copy);
  ecl_bds_unwind1(cl_env_copy);
  ecl_function_dispatch(cl_env_copy,VV[77])(1, VV[10]) /*  UNWIND-NO-EXIT */;
  ecl_function_dispatch(cl_env_copy,VV[78])(1, VV[23]) /*  WT-NL      */;
  T0 = ecl_function_dispatch(cl_env_copy,VV[63])(1, v1fun) /*  FUN-NAME */;
  ecl_function_dispatch(cl_env_copy,VV[79])(2, VV[24], T0) /*  CMPDEBUG */;
  value0 = ECL_T;
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for C2CALL-LOCAL                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3766c2call_local(cl_object v1c1form, cl_object v2fun, cl_object v3args)
{
 cl_object T0, T1, T2, T3;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if ((L3765c2try_tail_recursive_call(v2fun, v3args))!=ECL_NIL) { goto L1; }
  {
   cl_object v4;
   v4 = ecl_symbol_value(VV[5]);
   ecl_bds_bind(cl_env_copy,VV[4],ecl_make_fixnum(0)); /*  *INLINE-BLOCKS* */
   ecl_bds_bind(cl_env_copy,VV[5],v4);            /*  *TEMP*          */
   T0 = ecl_function_dispatch(cl_env_copy,VV[63])(1, v2fun) /*  FUN-NAME */;
   T1 = ecl_function_dispatch(cl_env_copy,VV[59])(1, v3args) /*  INLINE-ARGS */;
   T2 = ecl_function_dispatch(cl_env_copy,VV[57])(1, v1c1form) /*  C1FORM-PRIMARY-TYPE */;
   T3 = L3768call_loc(T0, v2fun, T1, T2);
   ecl_function_dispatch(cl_env_copy,VV[60])(1, T3) /*  UNWIND-EXIT   */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[61])(0) /*  CLOSE-INLINE-BLOCKS */;
   ecl_bds_unwind1(cl_env_copy);
   ecl_bds_unwind1(cl_env_copy);
   return value0;
  }
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for CALL-GLOBAL-LOC                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3767call_global_loc(cl_object v1fname, cl_object v2fun, cl_object v3args, cl_object v4return_type, cl_object v5expected_type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (v2fun==ECL_NIL) { goto L4; }
  if (Null(ecl_function_dispatch(cl_env_copy,VV[82])(1, v2fun) /*  FUN-GLOBAL */)) { goto L1; }
  goto L3;
L4:;
L3:;
  if ((ecl_function_dispatch(cl_env_copy,VV[73])(1, v1fname) /*  INLINE-POSSIBLE */)!=ECL_NIL) { goto L1; }
  T0 = ecl_function_dispatch(cl_env_copy,VV[59])(1, v3args) /*  INLINE-ARGS */;
  value0 = L3770call_unknown_global_loc(3, v1fname, ECL_NIL, T0);
  return value0;
L1:;
  v3args = ecl_function_dispatch(cl_env_copy,VV[59])(1, v3args) /*  INLINE-ARGS */;
  {
   cl_object v6inline_loc;
   T0 = ecl_function_dispatch(cl_env_copy,VV[83])(2, v4return_type, v5expected_type) /*  TYPE-AND */;
   v6inline_loc = ecl_function_dispatch(cl_env_copy,VV[84])(3, v1fname, T0, v3args) /*  APPLY-INLINER */;
   if (Null(v6inline_loc)) { goto L8; }
   value0 = v6inline_loc;
   cl_env_copy->nvalues = 1;
   return value0;
  }
L8:;
  if (Null(ecl_function_dispatch(cl_env_copy,VV[85])(0) /*  POLICY-USE-DIRECT-C-CALL */)) { goto L11; }
  if ((ecl_function_dispatch(cl_env_copy,VV[86])(1, v2fun) /*  FUN-P  */)!=ECL_NIL) { goto L14; }
  if (!(v2fun==ECL_NIL)) { goto L11; }
  {
   cl_object v6;
   cl_object v7;
   cl_object v8;
   v6 = ecl_symbol_value(VV[7]);
   v7 = ecl_fdefinition(VV[64]);
   v8 = ecl_fdefinition(VV[63]);
   {
    cl_object v9;
    v9 = ecl_function_dispatch(cl_env_copy,VV[65])(2, v6, ecl_make_fixnum(0)) /*  MAKE-SEQ-ITERATOR */;
L22:;
    if ((v9)!=ECL_NIL) { goto L24; }
    v2fun = ECL_NIL;
    goto L17;
L24:;
    {
     cl_object v10;
     v10 = ecl_function_dispatch(cl_env_copy,VV[66])(2, v6, v9) /*  SEQ-ITERATOR-REF */;
     T0 = ecl_function_dispatch(cl_env_copy,VV[63])(1, v10) /*  FUN-NAME */;
     if (Null(ecl_function_dispatch(cl_env_copy,VV[64])(2, v1fname, T0) /*  SAME-FNAME-P */)) { goto L26; }
     v2fun = v10;
     goto L17;
    }
L26:;
    v9 = ecl_function_dispatch(cl_env_copy,VV[67])(2, v6, v9) /*  SEQ-ITERATOR-NEXT */;
    goto L22;
   }
  }
L17:;
  if (Null(v2fun)) { goto L11; }
  goto L12;
L14:;
L12:;
  value0 = L3768call_loc(v1fname, v2fun, v3args, v4return_type);
  return value0;
L11:;
  if (ECL_SYMBOLP(v1fname)) { goto L32; }
  value0 = L3770call_unknown_global_loc(3, v1fname, ECL_NIL, v3args);
  return value0;
L32:;
  {
   cl_object v7;                                  /*  FOUND           */
   cl_object v8;                                  /*  FD              */
   cl_object v9;                                  /*  MINARG          */
   cl_object v10;                                 /*  MAXARG          */
   value0 = si_mangle_name(2, v1fname, ECL_T);
   {
    const int v11 = cl_env_copy->nvalues;
    v7 = value0;
    cl_object v12;
    v12 = (v11<=1)? ECL_NIL : cl_env_copy->values[1];
    v8 = v12;
    v12 = (v11<=2)? ECL_NIL : cl_env_copy->values[2];
    v9 = v12;
    v12 = (v11<=3)? ECL_NIL : cl_env_copy->values[3];
    v10 = v12;
   }
   if (Null(v7)) { goto L34; }
   value0 = L3769call_exported_function_loc(v1fname, v3args, v8, v9, v10, ECL_T, v4return_type);
   return value0;
  }
L34:;
  if (Null(ecl_function_dispatch(cl_env_copy,VV[85])(0) /*  POLICY-USE-DIRECT-C-CALL */)) { goto L37; }
  {
   cl_object v6fd;
   v6fd = si_get_sysprop(v1fname, VV[27]);
   if (Null(v6fd)) { goto L37; }
   {
    cl_object v8;                                 /*  MINARG          */
    cl_object v9;                                 /*  MAXARG          */
    cl_object v10;                                /*  FOUND           */
    value0 = ecl_function_dispatch(cl_env_copy,VV[87])(1, v1fname) /*  GET-PROCLAIMED-NARG */;
    {
     const int v11 = cl_env_copy->nvalues;
     v8 = value0;
     cl_object v12;
     v12 = (v11<=1)? ECL_NIL : cl_env_copy->values[1];
     v9 = v12;
     v12 = (v11<=2)? ECL_NIL : cl_env_copy->values[2];
     v10 = v12;
    }
    if ((v10)!=ECL_NIL) { goto L42; }
    if ((v10)!=ECL_NIL) { goto L42; }
    ecl_function_dispatch(cl_env_copy,VV[88])(3, VV[28], v1fname, v6fd) /*  CMPERR */;
L42:;
    T0 = si_mangle_name(1, v1fname);
    value0 = L3769call_exported_function_loc(v1fname, v3args, v6fd, v8, v9, T0, v4return_type);
    return value0;
   }
  }
L37:;
  value0 = L3770call_unknown_global_loc(3, v1fname, ECL_NIL, v3args);
  return value0;
 }
}
/*      function definition for CALL-LOC                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3768call_loc(cl_object v1fname, cl_object v2fun, cl_object v3args, cl_object v4type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = ecl_function_dispatch(cl_env_copy,VV[90])(1, v3args) /*  COERCE-LOCS */;
  value0 = cl_list(4, VV[30], v2fun, T0, v4type);
  return value0;
 }
}
/*      function definition for CALL-EXPORTED-FUNCTION-LOC            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3769call_exported_function_loc(cl_object v1fname, cl_object v2args, cl_object v3fun_c_name, cl_object v4minarg, cl_object v5maxarg, cl_object v6in_core, cl_object v7return_type)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if ((v6in_core)!=ECL_NIL) { goto L1; }
  {
   cl_object v9;                                  /*  DECLARED        */
   value0 = cl_gethash(2, v3fun_c_name, ecl_symbol_value(VV[32]));
   {
    v9 = cl_env_copy->values[1];
   }
   if ((v9)!=ECL_NIL) { goto L1; }
   if (!(ecl_number_equalp(v5maxarg,v4minarg))) { goto L6; }
   ecl_function_dispatch(cl_env_copy,VV[92])(3, VV[33], v3fun_c_name, VV[34]) /*  WT-NL-H */;
   {
    cl_object v10i;
    v10i = ecl_make_fixnum(0);
    goto L12;
L11:;
    if (!(ecl_greater(v10i,ecl_make_fixnum(0)))) { goto L14; }
    ecl_function_dispatch(cl_env_copy,VV[93])(1, VV[35]) /*  WT-H1    */;
L14:;
    ecl_function_dispatch(cl_env_copy,VV[93])(1, VV[36]) /*  WT-H1    */;
    v10i = ecl_one_plus(v10i);
L12:;
    if (!(ecl_lower(v10i,v5maxarg))) { goto L19; }
    goto L11;
L19:;
   }
   ecl_function_dispatch(cl_env_copy,VV[93])(1, VV[37]) /*  WT-H1     */;
   goto L5;
L6:;
   ecl_function_dispatch(cl_env_copy,VV[92])(3, VV[33], v3fun_c_name, VV[38]) /*  WT-NL-H */;
   {
    cl_object v10;
    v10 = ((ecl_float_nan_p(ecl_make_fixnum(63)) || ecl_lowereq(v4minarg,ecl_make_fixnum(63)))?v4minarg:ecl_make_fixnum(63));
    {
     cl_object v11i;
     v11i = ecl_make_fixnum(0);
     goto L26;
L25:;
     ecl_function_dispatch(cl_env_copy,VV[93])(1, VV[39]) /*  WT-H1   */;
     v11i = ecl_one_plus(v11i);
L26:;
     if (!(ecl_lower(v11i,v10))) { goto L31; }
     goto L25;
L31:;
    }
   }
   ecl_function_dispatch(cl_env_copy,VV[93])(1, VV[40]) /*  WT-H1     */;
L5:;
   si_hash_set(v3fun_c_name, ecl_symbol_value(VV[32]), ecl_make_fixnum(1));
  }
L1:;
  {
   cl_object v8fun;
   v8fun = ecl_function_dispatch(cl_env_copy,VV[94])(12, ECL_SYM("NAME",1306), v1fname, VV[41], ECL_T, VV[42], v3fun_c_name, VV[43], ECL_NIL, VV[44], v4minarg, VV[45], v5maxarg) /*  MAKE-FUN */;
   value0 = L3768call_loc(v1fname, v8fun, v2args, v7return_type);
   return value0;
  }
 }
}
/*      function definition for CALL-UNKNOWN-GLOBAL-LOC               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3770call_unknown_global_loc(cl_narg narg, cl_object v1fname, cl_object v2loc, cl_object v3args, ...)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<3)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>4)) FEwrong_num_arguments_anonym();
 {
  cl_object v4function_p;
  va_list args; va_start(args,v3args);
  {
   int i = 3;
   if (i >= narg) {
    v4function_p = ECL_NIL;
   } else {
    i++;
    v4function_p = va_arg(args,cl_object);
   }
  }
  va_end(args);
  if ((v2loc)!=ECL_NIL) { goto L2; }
  if (!(ECL_SYMBOLP(v1fname))) { goto L4; }
  T0 = cl_symbol_package(v1fname);
  T1 = cl_find_package(VV[47]);
  if ((T0)==(T1)) { goto L4; }
  v2loc = ecl_function_dispatch(cl_env_copy,VV[96])(1, v1fname) /*  ADD-SYMBOL */;
  v4function_p = ECL_NIL;
  goto L2;
L4:;
  v2loc = cl_list(2, ECL_SYM("FDEFINITION",351), v1fname);
  v4function_p = ECL_T;
L2:;
  T0 = ecl_function_dispatch(cl_env_copy,VV[90])(1, v3args) /*  COERCE-LOCS */;
  value0 = cl_list(5, VV[48], v2loc, T0, v1fname, v4function_p);
  return value0;
 }
}

#include "cmp/cmppass2-call.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _ecle1cTlCFf3SBq9_n6sJpj61(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPBACKEND-CXX;CMPPASS2-CALL.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_ecle1cTlCFf3SBq9_n6sJpj61@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(_ecl_static_0);
  ecl_cmp_defun(VV[50]);                          /*  MAYBE-SAVE-VALUE */
  ecl_cmp_defun(VV[56]);                          /*  C2FUNCALL       */
  ecl_cmp_defun(VV[62]);                          /*  C2CALL-GLOBAL   */
  ecl_cmp_defun(VV[69]);                          /*  TAIL-RECURSION-POSSIBLE */
  ecl_cmp_defun(VV[71]);                          /*  LAST-CALL-P     */
  ecl_cmp_defun(VV[72]);                          /*  C2TRY-TAIL-RECURSIVE-CALL */
  ecl_cmp_defun(VV[80]);                          /*  C2CALL-LOCAL    */
  ecl_cmp_defun(VV[81]);                          /*  CALL-GLOBAL-LOC */
  ecl_cmp_defun(VV[89]);                          /*  CALL-LOC        */
  ecl_cmp_defun(VV[91]);                          /*  CALL-EXPORTED-FUNCTION-LOC */
  ecl_cmp_defun(VV[95]);                          /*  CALL-UNKNOWN-GLOBAL-LOC */
}
