/*      Compiler: ECL 23.9.9                                          */
/*      Source: /builddir/build/BUILD/ecl-23.9.9/src/cmp/cmpbackend-cxx/cmppass2-loc.lsp */
#include <ecl/ecl-cmp.h>
#include "cmp/cmppass2-loc.eclh"
/*      function definition for WT-LOC                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3789wt_loc(cl_object v1loc)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(ECL_CONSP(v1loc))) { goto L1; }
  {
   cl_object v2fd;
   T0 = ecl_car(v1loc);
   v2fd = ecl_gethash_safe(T0,ecl_symbol_value(VV[0]),ECL_NIL);
   if (Null(v2fd)) { goto L4; }
   T0 = ecl_cdr(v1loc);
   value0 = cl_apply(2, v2fd, T0);
   return value0;
L4:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[125])(2, VV[1], v1loc) /*  UNKNOWN-LOCATION */;
   return value0;
  }
L1:;
  if (!(ECL_SYMBOLP(v1loc))) { goto L6; }
  {
   cl_object v3txt;
   v3txt = ecl_gethash_safe(v1loc,ecl_symbol_value(VV[0]),VV[2]);
   if (!((v3txt)==(VV[2]))) { goto L9; }
   ecl_function_dispatch(cl_env_copy,VV[125])(2, VV[1], v1loc) /*  UNKNOWN-LOCATION */;
L9:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[126])(1, v3txt) /*  WT */;
   return value0;
  }
L6:;
  if (!(ECL_STRINGP(v1loc))) { goto L11; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(1, v1loc) /*  WT */;
  return value0;
L11:;
  if (Null(ecl_function_dispatch(cl_env_copy,VV[127])(1, v1loc) /*  VAR-P */)) { goto L13; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[128])(1, v1loc) /*  WT-VAR */;
  return value0;
L13:;
  if (Null(ecl_function_dispatch(cl_env_copy,VV[129])(1, v1loc) /*  VV-P */)) { goto L15; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[130])(1, v1loc) /*  WT-VV */;
  return value0;
L15:;
  value0 = ecl_function_dispatch(cl_env_copy,VV[125])(2, VV[1], v1loc) /*  UNKNOWN-LOCATION */;
  return value0;
 }
}
/*      function definition for WT-LCL                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3790wt_lcl(cl_object v1lcl)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (ecl_numberp(v1lcl)) { goto L1; }
  T0 = ecl_list1(v1lcl);
  ecl_function_dispatch(cl_env_copy,VV[132])(4, ECL_SYM("FORMAT-CONTROL",1269), VV[3], ECL_SYM("FORMAT-ARGUMENTS",1268), T0) /*  BABOON */;
L1:;
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(2, VV[4], v1lcl) /*  WT */;
  return value0;
 }
}
/*      function definition for WT-LCL-LOC                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3791wt_lcl_loc(cl_narg narg, cl_object v1lcl, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>3)) FEwrong_num_arguments_anonym();
 {
  cl_object v2type;
  cl_object v3name;
  va_list args; va_start(args,v1lcl);
  {
   int i = 1;
   if (i >= narg) {
    v2type = ECL_NIL;
   } else {
    i++;
    v2type = va_arg(args,cl_object);
   }
   if (i >= narg) {
    v3name = ECL_NIL;
   } else {
    i++;
    v3name = va_arg(args,cl_object);
   }
  }
  va_end(args);
  if (ecl_numberp(v1lcl)) { goto L3; }
  T0 = ecl_list1(v1lcl);
  ecl_function_dispatch(cl_env_copy,VV[132])(4, ECL_SYM("FORMAT-CONTROL",1269), VV[6], ECL_SYM("FORMAT-ARGUMENTS",1268), T0) /*  BABOON */;
L3:;
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[4], v1lcl, v3name) /*  WT */;
  return value0;
 }
}
/*      function definition for WT-TEMP                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3792wt_temp(cl_object v1temp)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(2, VV[8], v1temp) /*  WT */;
  return value0;
 }
}
/*      function definition for WT-FIXNUM                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3793wt_fixnum(cl_narg narg, cl_object v1value, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2vv;
  va_list args; va_start(args,v1value);
  {
   int i = 1;
   if (i >= narg) {
    v2vv = ECL_NIL;
   } else {
    i++;
    v2vv = va_arg(args,cl_object);
   }
  }
  va_end(args);
  value0 = ecl_princ(v1value,ecl_symbol_value(VV[10]));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for WT-NUMBER                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3794wt_number(cl_narg narg, cl_object v1value, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2vv;
  va_list args; va_start(args,v1value);
  {
   int i = 1;
   if (i >= narg) {
    v2vv = ECL_NIL;
   } else {
    i++;
    v2vv = va_arg(args,cl_object);
   }
  }
  va_end(args);
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(1, v1value) /*  WT */;
  return value0;
 }
}
/*      function definition for WT-CHARACTER                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3795wt_character(cl_narg narg, cl_object v1value, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object v2vv;
  va_list args; va_start(args,v1value);
  {
   int i = 1;
   if (i >= narg) {
    v2vv = ECL_NIL;
   } else {
    i++;
    v2vv = va_arg(args,cl_object);
   }
  }
  va_end(args);
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(1, v1value) /*  WT */;
  return value0;
 }
}
/*      function definition for WT-VALUE                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3796wt_value(cl_object v1i)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[14], v1i, VV[15]) /*  WT */;
  return value0;
 }
}
/*      function definition for WT-KEYVARS                            */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3797wt_keyvars(cl_object v1i)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[17], v1i, VV[15]) /*  WT */;
  return value0;
 }
}
/*      function definition for WT-THE                                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3798wt_the(cl_object v1type, cl_object v2loc)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = L3789wt_loc(v2loc);
  return value0;
 }
}
/*      function definition for WT-CALL                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3799wt_call(cl_narg narg, cl_object v1fun, cl_object v2args, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<2)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>4)) FEwrong_num_arguments_anonym();
 {
  cl_object v3fname;
  cl_object v4env;
  va_list args; va_start(args,v2args);
  {
   int i = 2;
   if (i >= narg) {
    v3fname = ECL_NIL;
   } else {
    i++;
    v3fname = va_arg(args,cl_object);
   }
   if (i >= narg) {
    v4env = ECL_NIL;
   } else {
    i++;
    v4env = va_arg(args,cl_object);
   }
  }
  va_end(args);
  if (Null(v4env)) { goto L4; }
  cl_set(VV[20],ECL_T);
  ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[21], v4env, VV[22]) /*  WT */;
  L3799wt_call(2, v1fun, v2args);
  ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[23]) /*  WT        */;
  goto L3;
L4:;
  ecl_function_dispatch(cl_env_copy,VV[126])(2, v1fun, VV[24]) /*  WT */;
  {
   cl_object v5comma;
   v5comma = VV[25];
   {
    cl_object v6;
    v6 = v2args;
    goto L16;
L15:;
    {
     cl_object v7arg;
     v7arg = ecl_car(v6);
     ecl_function_dispatch(cl_env_copy,VV[126])(2, v5comma, v7arg) /*  WT */;
     v5comma = VV[26];
    }
    v6 = ecl_cdr(v6);
L16:;
    if (Null(v6)) { goto L25; }
    goto L15;
L25:;
   }
  }
  ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[23]) /*  WT        */;
L3:;
  if (Null(v3fname)) { goto L27; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[142])(1, v3fname) /*  WT-COMMENT */;
  return value0;
L27:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for WT-CALL-INDIRECT                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3800wt_call_indirect(cl_object v1fun_loc, cl_object v2args, cl_object v3fname, cl_object v4function_p)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_fixnum v5narg;
   v5narg = ecl_length(v2args);
   if (Null(v4function_p)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[126])(4, VV[28], v1fun_loc, VV[29], ecl_make_fixnum(v5narg)) /*  WT */;
   goto L2;
L3:;
   ecl_function_dispatch(cl_env_copy,VV[126])(4, VV[30], v1fun_loc, VV[31], ecl_make_fixnum(v5narg)) /*  WT */;
L2:;
   {
    cl_object v6;
    v6 = v2args;
    goto L9;
L8:;
    {
     cl_object v7arg;
     v7arg = ecl_car(v6);
     ecl_function_dispatch(cl_env_copy,VV[126])(2, VV[26], v7arg) /*  WT */;
    }
    v6 = ecl_cdr(v6);
L9:;
    if (Null(v6)) { goto L16; }
    goto L8;
L16:;
   }
   ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[23]) /*  WT       */;
   if (Null(v3fname)) { goto L19; }
   value0 = ecl_function_dispatch(cl_env_copy,VV[142])(1, v3fname) /*  WT-COMMENT */;
   return value0;
L19:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for WT-CALL-NORMAL                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3801wt_call_normal(cl_object v1fun, cl_object v2args, cl_object v3type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if ((ecl_function_dispatch(cl_env_copy,VV[145])(1, v1fun) /*  FUN-CFUN */)!=ECL_NIL) { goto L1; }
  T0 = ecl_function_dispatch(cl_env_copy,VV[146])(1, v1fun) /*  FUN-NAME */;
  ecl_function_dispatch(cl_env_copy,VV[132])(2, VV[33], T0) /*  BABOON */;
L1:;
  {
   cl_object v4minarg;
   cl_object v5maxarg;
   cl_object v6fun_c_name;
   cl_object v7fun_lisp_name;
   cl_fixnum v8narg;
   cl_object v9env;
   v4minarg = ecl_function_dispatch(cl_env_copy,VV[147])(1, v1fun) /*  FUN-MINARG */;
   v5maxarg = ecl_function_dispatch(cl_env_copy,VV[148])(1, v1fun) /*  FUN-MAXARG */;
   v6fun_c_name = ecl_function_dispatch(cl_env_copy,VV[145])(1, v1fun) /*  FUN-CFUN */;
   v7fun_lisp_name = ecl_function_dispatch(cl_env_copy,VV[146])(1, v1fun) /*  FUN-NAME */;
   v8narg = ecl_length(v2args);
   v9env = ECL_NIL;
   {
    cl_object v10;
    v10 = ecl_function_dispatch(cl_env_copy,VV[149])(1, v1fun) /*  FUN-CLOSURE */;
    if (!((v10)==(VV[34]))) { goto L11; }
    if (!(ecl_plusp(ecl_symbol_value(VV[35])))) { goto L9; }
    v9env = L3803environment_accessor(v1fun);
    goto L9;
L11:;
    if (!((v10)==(VV[36]))) { goto L9; }
    {
     cl_object v11lex_lvl;
     v11lex_lvl = ecl_function_dispatch(cl_env_copy,VV[150])(1, v1fun) /*  FUN-LEVEL */;
     {
      cl_object v12n;
      v12n = ecl_make_fixnum(0);
      goto L19;
L18:;
      {
       cl_object v13j;
       cl_object v14x;
       T0 = ecl_minus(v11lex_lvl,v12n);
       v13j = ecl_minus(T0,ecl_make_fixnum(1));
       v14x = ecl_function_dispatch(cl_env_copy,VV[151])(1, v13j) /*  LEX-ENV-VAR-NAME */;
       v2args = CONS(v14x,v2args);
      }
      v12n = ecl_one_plus(v12n);
L19:;
      if (!(ecl_lower(v12n,v11lex_lvl))) { goto L27; }
      goto L18;
L27:;
     }
    }
   }
L9:;
   if ((cl_LE(3, v4minarg, ecl_make_fixnum(v8narg), v5maxarg))!=ECL_NIL) { goto L29; }
   value0 = v7fun_lisp_name;
   if ((value0)!=ECL_NIL) { goto L33; }
   T0 = VV[38];
   goto L31;
L33:;
   T0 = value0;
   goto L31;
L31:;
   ecl_function_dispatch(cl_env_copy,VV[152])(2, VV[37], T0) /*  CMPERR */;
L29:;
   if (Null(ecl_function_dispatch(cl_env_copy,VV[153])(1, v1fun) /*  FUN-NEEDS-NARG */)) { goto L35; }
   v2args = CONS(ecl_make_fixnum(v8narg),v2args);
L35:;
   value0 = L3799wt_call(4, v6fun_c_name, v2args, ECL_NIL, v9env);
   return value0;
  }
 }
}
/*      function definition for WT-FDEFINITION                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3802wt_fdefinition(cl_object v1fun_name)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2name;
   cl_object v3package;
   cl_object v4safe;
   v2name = si_function_block_name(v1fun_name);
   v3package = cl_symbol_package(v2name);
   T0 = ecl_function_dispatch(cl_env_copy,VV[155])(0) /*  SAFE-COMPILE */;
   value0 = Null(T0)?ECL_T:ECL_NIL;
   if ((value0)!=ECL_NIL) { goto L5; }
   T0 = cl_find_package(VV[40]);
   if ((v3package)==(T0)) { goto L10; }
   T0 = cl_find_package(VV[41]);
   if ((v3package)==(T0)) { goto L10; }
   T0 = cl_find_package(VV[42]);
   if (!((v3package)==(T0))) { goto L8; }
   goto L9;
L10:;
L9:;
   if (Null(cl_fboundp(v1fun_name))) { goto L8; }
   T0 = cl_fdefinition(v1fun_name);
   v4safe = cl_functionp(T0);
   goto L3;
L8:;
   v4safe = ECL_NIL;
   goto L3;
L5:;
   v4safe = value0;
   goto L3;
L3:;
   if (!((v2name)==(v1fun_name))) { goto L14; }
   {
    cl_object v5vv;
    v5vv = ecl_function_dispatch(cl_env_copy,VV[156])(1, v2name) /*  ADD-SYMBOL */;
    if (Null(v4safe)) { goto L17; }
    value0 = ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[24], v5vv, VV[43]) /*  WT */;
    return value0;
L17:;
    value0 = ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[44], v5vv, VV[23]) /*  WT */;
    return value0;
   }
L14:;
   if (Null(v4safe)) { goto L19; }
   {
    cl_object v6set_loc;
    {
     cl_object v7;
     cl_object v8;
     cl_object v9;
     v7 = ecl_symbol_value(VV[45]);
     v8 = v2name;
     v9 = v7;
     v6set_loc = ecl_assql(v8,v9);
    }
    if ((v6set_loc)!=ECL_NIL) { goto L25; }
    {
     cl_object v7setf_vv;
     cl_object v8name_vv;
     v7setf_vv = ecl_function_dispatch(cl_env_copy,VV[157])(0) /*  DATA-EMPTY-LOC */;
     v8name_vv = ecl_function_dispatch(cl_env_copy,VV[156])(1, v2name) /*  ADD-SYMBOL */;
     v6set_loc = cl_list(3, v2name, v7setf_vv, v8name_vv);
     cl_set(VV[45],CONS(v6set_loc,ecl_symbol_value(VV[45])));
    }
L25:;
    T0 = ecl_cadr(v6set_loc);
    value0 = ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[46], T0, VV[23]) /*  WT */;
    return value0;
   }
L19:;
   {
    cl_object v7vv;
    v7vv = ecl_function_dispatch(cl_env_copy,VV[156])(1, v1fun_name) /*  ADD-SYMBOL */;
    value0 = ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[44], v7vv, VV[23]) /*  WT */;
    return value0;
   }
  }
 }
}
/*      function definition for ENVIRONMENT-ACCESSOR                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3803environment_accessor(cl_object v1fun)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2env_var;
   cl_object v3expected_env_size;
   v2env_var = ecl_function_dispatch(cl_env_copy,VV[159])(1, ecl_symbol_value(VV[48])) /*  ENV-VAR-NAME */;
   v3expected_env_size = ecl_function_dispatch(cl_env_copy,VV[160])(1, v1fun) /*  FUN-ENV */;
   if (!(ecl_lower(v3expected_env_size,ecl_symbol_value(VV[49])))) { goto L3; }
   T0 = ecl_minus(ecl_symbol_value(VV[49]),v3expected_env_size);
   value0 = cl_format(4, ECL_NIL, VV[50], T0, v2env_var);
   return value0;
L3:;
   value0 = v2env_var;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for WT-MAKE-CLOSURE                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3804wt_make_closure(cl_object v1fun)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2cfun;
   v2cfun = ecl_function_dispatch(cl_env_copy,VV[145])(1, v1fun) /*  FUN-CFUN */;
   {
    cl_object v3closure;
    cl_object v4narg;
    v3closure = ecl_function_dispatch(cl_env_copy,VV[149])(1, v1fun) /*  FUN-CLOSURE */;
    v4narg = ECL_NIL;
    if (!((v3closure)==(VV[34]))) { goto L4; }
    T0 = L3803environment_accessor(v1fun);
    T1 = ecl_function_dispatch(cl_env_copy,VV[147])(1, v1fun) /*  FUN-MINARG */;
    T2 = ((ecl_float_nan_p(ecl_make_fixnum(63)) || ecl_lowereq(T1,ecl_make_fixnum(63)))?T1:ecl_make_fixnum(63));
    value0 = ecl_function_dispatch(cl_env_copy,VV[126])(7, VV[52], v2cfun, VV[53], T0, VV[54], T2, VV[23]) /*  WT */;
    return value0;
L4:;
    if (!((v3closure)==(VV[36]))) { goto L6; }
    value0 = ecl_function_dispatch(cl_env_copy,VV[132])(2, ECL_SYM("FORMAT-CONTROL",1269), VV[55]) /*  BABOON */;
    return value0;
L6:;
    v4narg = ecl_function_dispatch(cl_env_copy,VV[162])(1, v1fun) /*  FUN-FIXED-NARG */;
    if (Null(v4narg)) { goto L8; }
    value0 = ecl_function_dispatch(cl_env_copy,VV[126])(5, VV[56], v2cfun, VV[57], v4narg, VV[23]) /*  WT */;
    return value0;
L8:;
    T0 = ecl_function_dispatch(cl_env_copy,VV[147])(1, v1fun) /*  FUN-MINARG */;
    T1 = ((ecl_float_nan_p(ecl_make_fixnum(63)) || ecl_lowereq(T0,ecl_make_fixnum(63)))?T0:ecl_make_fixnum(63));
    value0 = ecl_function_dispatch(cl_env_copy,VV[126])(5, VV[58], v2cfun, VV[57], T1, VV[23]) /*  WT */;
    return value0;
   }
  }
 }
}
/*      function definition for WT-TO-OBJECT-CONVERSION               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3805wt_to_object_conversion(cl_object v1loc_rep_type, cl_object v2loc)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(ECL_CONSP(v2loc))) { goto L1; }
  {
   cl_object v3;
   cl_object v4;
   cl_object v5;
   v3 = ecl_car(v2loc);
   v4 = v3;
   v5 = VV[60];
   if (Null(ecl_memql(v4,v5))) { goto L1; }
  }
  T0 = ecl_caddr(v2loc);
  ecl_function_dispatch(cl_env_copy,VV[126])(1, T0) /*  WT            */;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  {
   cl_object v3record;
   cl_object v4coercer;
   v3record = ecl_function_dispatch(cl_env_copy,VV[164])(1, v1loc_rep_type) /*  REP-TYPE-RECORD */;
   if (Null(v3record)) { goto L11; }
   v4coercer = ecl_function_dispatch(cl_env_copy,VV[165])(1, v3record) /*  REP-TYPE-TO-LISP */;
   goto L9;
L11:;
   v4coercer = ECL_NIL;
   goto L9;
L9:;
   if ((v4coercer)!=ECL_NIL) { goto L13; }
   ecl_function_dispatch(cl_env_copy,VV[152])(2, VV[61], v1loc_rep_type) /*  CMPERR */;
L13:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[126])(4, v4coercer, VV[24], v2loc, VV[23]) /*  WT */;
   return value0;
  }
 }
}
/*      function definition for WT-FROM-OBJECT-CONVERSION             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3806wt_from_object_conversion(cl_object v1dest_type, cl_object v2loc_type, cl_object v3rep_type, cl_object v4loc)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v5record;
   cl_object v6coercer;
   v5record = ecl_function_dispatch(cl_env_copy,VV[164])(1, v3rep_type) /*  REP-TYPE-RECORD */;
   if (Null(v5record)) { goto L4; }
   v6coercer = ecl_function_dispatch(cl_env_copy,VV[167])(1, v5record) /*  REP-TYPE-FROM-LISP */;
   goto L2;
L4:;
   v6coercer = ECL_NIL;
   goto L2;
L2:;
   if ((v6coercer)!=ECL_NIL) { goto L6; }
   ecl_function_dispatch(cl_env_copy,VV[152])(2, VV[63], v3rep_type) /*  CMPERR */;
L6:;
   if ((ecl_function_dispatch(cl_env_copy,VV[168])(0) /*  POLICY-ASSUME-NO-ERRORS */)!=ECL_NIL) { goto L11; }
   if (Null(cl_subtypep(2, v2loc_type, v1dest_type))) { goto L9; }
   goto L10;
L11:;
L10:;
   T0 = ecl_function_dispatch(cl_env_copy,VV[169])(1, v5record) /*  REP-TYPE-FROM-LISP-UNSAFE */;
   goto L8;
L9:;
   T0 = v6coercer;
L8:;
   value0 = ecl_function_dispatch(cl_env_copy,VV[126])(4, T0, VV[24], v4loc, VV[23]) /*  WT */;
   return value0;
  }
 }
}
/*      function definition for WT-COERCE-LOC                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3809wt_coerce_loc(cl_object v1dest_rep_type, cl_object v2loc)
{
 cl_object T0;
 volatile cl_object lex0[4];
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  lex0[0] = v1dest_rep_type;                      /*  DEST-REP-TYPE   */
TTL:
  lex0[0] = ecl_function_dispatch(cl_env_copy,VV[171])(1, lex0[0]) /*  LISP-TYPE->REP-TYPE */;
  T0 = ecl_function_dispatch(cl_env_copy,VV[172])(1, lex0[0]) /*  REP-TYPE->LISP-TYPE */;
  lex0[1] = T0;                                   /*  DEST-TYPE       */
  T0 = ecl_function_dispatch(cl_env_copy,VV[173])(1, v2loc) /*  LOC-TYPE */;
  lex0[2] = T0;                                   /*  LOC-TYPE        */
  T0 = ecl_function_dispatch(cl_env_copy,VV[174])(1, v2loc) /*  LOC-REPRESENTATION-TYPE */;
  lex0[3] = T0;                                   /*  LOC-REP-TYPE    */
  if (!((lex0[0])==(lex0[3]))) { goto L3; }
  ecl_function_dispatch(cl_env_copy,VV[126])(1, v2loc) /*  WT         */;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
L3:;
  if (!((lex0[0])==(ECL_SYM("CHAR",1400)))) { goto L11; }
  goto L8;
  goto L9;
L11:;
  goto L9;
L9:;
  if (!((lex0[0])==(ECL_SYM("UNSIGNED-CHAR",1427)))) { goto L15; }
  goto L8;
  goto L13;
L15:;
  goto L13;
L13:;
  if (!((lex0[0])==(VV[69]))) { goto L6; }
  goto L7;
L8:;
L7:;
  if (!((lex0[3])==(ECL_SYM("CHAR",1400)))) { goto L23; }
  goto L20;
  goto L21;
L23:;
  goto L21;
L21:;
  if (!((lex0[3])==(ECL_SYM("UNSIGNED-CHAR",1427)))) { goto L27; }
  goto L20;
  goto L25;
L27:;
  goto L25;
L25:;
  if (!((lex0[3])==(VV[69]))) { goto L18; }
  goto L19;
L20:;
L19:;
  T0 = ecl_function_dispatch(cl_env_copy,VV[175])(1, lex0[0]) /*  REP-TYPE->C-NAME */;
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(5, VV[24], T0, VV[31], v2loc, VV[23]) /*  WT */;
  return value0;
L18:;
  if (!((lex0[3])==(ECL_SYM("OBJECT",1312)))) { goto L30; }
  LC3808ensure_valid_object_type(lex0, lex0[1]);
  value0 = L3806wt_from_object_conversion(lex0[1], lex0[2], lex0[0], v2loc);
  return value0;
L30:;
  value0 = LC3807coercion_error(0, lex0);
  return value0;
L6:;
  if (!((lex0[0])==(ECL_SYM("FLOAT",1407)))) { goto L39; }
  goto L36;
  goto L37;
L39:;
  goto L37;
L37:;
  if (!((lex0[0])==(ECL_SYM("DOUBLE",1405)))) { goto L43; }
  goto L36;
  goto L41;
L43:;
  goto L41;
L41:;
  if (!((lex0[0])==(ECL_SYM("LONG-DOUBLE",1414)))) { goto L34; }
  goto L35;
L36:;
L35:;
  if (Null(ecl_function_dispatch(cl_env_copy,VV[176])(1, lex0[3]) /*  C-NUMBER-REP-TYPE-P */)) { goto L46; }
  T0 = ecl_function_dispatch(cl_env_copy,VV[175])(1, lex0[0]) /*  REP-TYPE->C-NAME */;
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(5, VV[24], T0, VV[31], v2loc, VV[23]) /*  WT */;
  return value0;
L46:;
  if (!((lex0[3])==(ECL_SYM("OBJECT",1312)))) { goto L48; }
  LC3808ensure_valid_object_type(lex0, ECL_SYM("FLOAT",376));
  value0 = L3806wt_from_object_conversion(lex0[1], lex0[2], lex0[0], v2loc);
  return value0;
L48:;
  value0 = LC3807coercion_error(0, lex0);
  return value0;
L34:;
  if (!((lex0[0])==(ECL_SYM("CSFLOAT",1401)))) { goto L56; }
  goto L53;
  goto L54;
L56:;
  goto L54;
L54:;
  if (!((lex0[0])==(ECL_SYM("CDFLOAT",1402)))) { goto L60; }
  goto L53;
  goto L58;
L60:;
  goto L58;
L58:;
  if (!((lex0[0])==(ECL_SYM("CLFLOAT",1403)))) { goto L51; }
  goto L52;
L53:;
L52:;
  if (Null(ecl_function_dispatch(cl_env_copy,VV[176])(1, lex0[3]) /*  C-NUMBER-REP-TYPE-P */)) { goto L63; }
  T0 = ecl_function_dispatch(cl_env_copy,VV[175])(1, lex0[0]) /*  REP-TYPE->C-NAME */;
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(5, VV[24], T0, VV[31], v2loc, VV[23]) /*  WT */;
  return value0;
L63:;
  if (!((lex0[3])==(ECL_SYM("OBJECT",1312)))) { goto L65; }
  LC3808ensure_valid_object_type(lex0, ECL_SYM("COMPLEX-FLOAT",1886));
  value0 = L3806wt_from_object_conversion(lex0[1], lex0[2], lex0[0], v2loc);
  return value0;
L65:;
  value0 = LC3807coercion_error(0, lex0);
  return value0;
L51:;
  if (!((lex0[0])==(VV[79]))) { goto L68; }
  if (Null(ecl_function_dispatch(cl_env_copy,VV[176])(1, lex0[3]) /*  C-NUMBER-REP-TYPE-P */)) { goto L71; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[80]) /*  WT */;
  return value0;
L71:;
  if (!((lex0[3])==(ECL_SYM("OBJECT",1312)))) { goto L73; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[24], v2loc, VV[81]) /*  WT */;
  return value0;
L73:;
  value0 = LC3807coercion_error(0, lex0);
  return value0;
L68:;
  if (!((lex0[0])==(ECL_SYM("OBJECT",1312)))) { goto L75; }
  if (!((lex0[3])==(VV[83]))) { goto L83; }
  goto L80;
  goto L81;
L83:;
  goto L81;
L81:;
  if (!((lex0[3])==(VV[84]))) { goto L87; }
  goto L80;
  goto L85;
L87:;
  goto L85;
L85:;
  if (!((lex0[3])==(VV[86]))) { goto L78; }
  goto L79;
L80:;
L79:;
  T0 = ecl_function_dispatch(cl_env_copy,VV[177])(1, ECL_SYM("SPEED",793)) /*  CMP-ENV-OPTIMIZATION */;
  if (!(ecl_greatereq(T0,ecl_make_fixnum(1)))) { goto L78; }
  ecl_function_dispatch(cl_env_copy,VV[178])(2, VV[88], lex0[3]) /*  CMPWARN-STYLE */;
L78:;
  value0 = L3805wt_to_object_conversion(lex0[3], v2loc);
  return value0;
L75:;
  if (!((lex0[0])==(ECL_SYM("POINTER-VOID",1417)))) { goto L91; }
  if (!((lex0[3])==(ECL_SYM("OBJECT",1312)))) { goto L94; }
  value0 = L3806wt_from_object_conversion(lex0[1], lex0[2], lex0[0], v2loc);
  return value0;
L94:;
  if (!((lex0[3])==(ECL_SYM("CSTRING",1404)))) { goto L97; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[91], v2loc, VV[23]) /*  WT */;
  return value0;
L97:;
  value0 = LC3807coercion_error(0, lex0);
  return value0;
L91:;
  if (!((lex0[0])==(ECL_SYM("CSTRING",1404)))) { goto L100; }
  value0 = LC3807coercion_error(0, lex0);
  return value0;
L100:;
  if (!((lex0[0])==(VV[93]))) { goto L103; }
  if (!((lex0[3])==(ECL_SYM("OBJECT",1312)))) { goto L106; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[94], v2loc, VV[23]) /*  WT */;
  return value0;
L106:;
  if (!((lex0[3])==(ECL_SYM("POINTER-VOID",1417)))) { goto L109; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(3, VV[91], v2loc, VV[23]) /*  WT */;
  return value0;
L109:;
  value0 = LC3807coercion_error(0, lex0);
  return value0;
L103:;
  if (!((lex0[0])==(VV[83]))) { goto L117; }
  goto L114;
  goto L115;
L117:;
  goto L115;
L115:;
  if (!((lex0[0])==(VV[84]))) { goto L121; }
  goto L114;
  goto L119;
L121:;
  goto L119;
L119:;
  if (!((lex0[0])==(VV[86]))) { goto L112; }
  goto L113;
L114:;
L113:;
  if (!((lex0[3])==(ECL_SYM("OBJECT",1312)))) { goto L124; }
  value0 = L3806wt_from_object_conversion(ECL_SYM("SSE-PACK",1890), lex0[2], lex0[0], v2loc);
  return value0;
L124:;
  if (!((lex0[3])==(VV[83]))) { goto L132; }
  goto L129;
  goto L130;
L132:;
  goto L130;
L130:;
  if (!((lex0[3])==(VV[84]))) { goto L136; }
  goto L129;
  goto L134;
L136:;
  goto L134;
L134:;
  if (!((lex0[3])==(VV[86]))) { goto L127; }
  goto L128;
L129:;
L128:;
  if (!((lex0[0])==(VV[83]))) { goto L140; }
  if (!((lex0[3])==(VV[84]))) { goto L142; }
  T0 = VV[95];
  goto L139;
L142:;
  if (!((lex0[3])==(VV[86]))) { goto L144; }
  T0 = VV[96];
  goto L139;
L144:;
  T0 = si_ecase_error(lex0[3], VV[85]);
  goto L139;
L140:;
  if (!((lex0[0])==(VV[84]))) { goto L146; }
  if (!((lex0[3])==(VV[83]))) { goto L148; }
  T0 = VV[97];
  goto L139;
L148:;
  if (!((lex0[3])==(VV[86]))) { goto L150; }
  T0 = VV[98];
  goto L139;
L150:;
  T0 = si_ecase_error(lex0[3], VV[99]);
  goto L139;
L146:;
  if (!((lex0[0])==(VV[86]))) { goto L152; }
  if (!((lex0[3])==(VV[83]))) { goto L154; }
  T0 = VV[100];
  goto L139;
L154:;
  if (!((lex0[3])==(VV[84]))) { goto L156; }
  T0 = VV[101];
  goto L139;
L156:;
  T0 = si_ecase_error(lex0[3], VV[102]);
  goto L139;
L152:;
  T0 = si_ecase_error(lex0[0], VV[82]);
L139:;
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(4, T0, VV[24], v2loc, VV[23]) /*  WT */;
  return value0;
L127:;
  value0 = LC3807coercion_error(0, lex0);
  return value0;
L112:;
  if ((ecl_function_dispatch(cl_env_copy,VV[179])(1, lex0[0]) /*  C-INTEGER-REP-TYPE-P */)!=ECL_NIL) { goto L158; }
  value0 = LC3807coercion_error(0, lex0);
  return value0;
L158:;
  if (Null(ecl_function_dispatch(cl_env_copy,VV[176])(1, lex0[3]) /*  C-NUMBER-REP-TYPE-P */)) { goto L160; }
  T0 = ecl_function_dispatch(cl_env_copy,VV[175])(1, lex0[0]) /*  REP-TYPE->C-NAME */;
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(5, VV[24], T0, VV[31], v2loc, VV[23]) /*  WT */;
  return value0;
L160:;
  if (!((ECL_SYM("OBJECT",1312))==(lex0[3]))) { goto L162; }
  LC3808ensure_valid_object_type(lex0, lex0[1]);
  value0 = L3806wt_from_object_conversion(lex0[1], lex0[2], lex0[0], v2loc);
  return value0;
L162:;
  value0 = LC3807coercion_error(0, lex0);
  return value0;
 }
}
/*      local function ENSURE-VALID-OBJECT-TYPE                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3808ensure_valid_object_type(volatile cl_object *lex0, cl_object v1a_lisp_type)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = cl_list(3, ECL_SYM("AND",89), lex0[2], v1a_lisp_type);
  if (Null(cl_subtypep(2, T0, ECL_NIL))) { goto L1; }
  value0 = LC3807coercion_error(1, lex0, ECL_NIL);
  return value0;
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function COERCION-ERROR                                 */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC3807coercion_error(cl_narg narg, volatile cl_object *lex0, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg>1)) FEwrong_num_arguments_anonym();
 {
  cl_object v1write_zero;
  va_list args; va_start(args,lex0);
  {
   int i = 0;
   if (i >= narg) {
    v1write_zero = ECL_T;
   } else {
    i++;
    v1write_zero = va_arg(args,cl_object);
   }
  }
  va_end(args);
  ecl_function_dispatch(cl_env_copy,VV[180])(5, VV[65], lex0[2], lex0[3], lex0[1], lex0[0]) /*  CMPWARN */;
  if (Null(v1write_zero)) { goto L3; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[66]) /*  WT */;
  return value0;
L3:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for WT-C-INLINE-LOC                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3810wt_c_inline_loc(cl_object volatile v1output_rep_type, cl_object volatile v2c_expression, cl_object volatile v3coerced_arguments, cl_object volatile v4side_effects, cl_object volatile v5output_vars)
{
 cl_object T0;
 cl_object volatile env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   volatile cl_object v6s;
   v6s = cl_make_string_input_stream(3, v2c_expression, ecl_make_fixnum(0), ECL_NIL);
   {
    volatile bool unwinding = FALSE;
    cl_index v7=ECL_STACK_INDEX(cl_env_copy),v8;
    ecl_frame_ptr next_fr;
    ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
    if (__ecl_frs_push_result) {
      unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
    } else {
    if (Null(v5output_vars)) { goto L3; }
    if ((v5output_vars)==(ECL_SYM("VALUES",897))) { goto L3; }
    ecl_function_dispatch(cl_env_copy,VV[182])(0) /*  WT-NL           */;
L3:;
    {
     cl_object v9c;
     v9c = cl_read_char(3, v6s, ECL_NIL, ECL_NIL);
     goto L9;
L8:;
     if (!(((v9c)==ECL_CODE_CHAR((ecl_character)(64))))) { goto L12; }
     {
      cl_object v10object;
      v10object = cl_read(1, v6s);
      if (!(ECL_CONSP(v10object))) { goto L15; }
      T0 = ecl_car(v10object);
      if (!(ecl_equal(T0,ECL_SYM("RETURN",726)))) { goto L15; }
      if (!((v5output_vars)==(ECL_SYM("VALUES",897)))) { goto L18; }
      ecl_function_dispatch(cl_env_copy,VV[152])(1, VV[104]) /*  CMPERR */;
      goto L11;
L18:;
      {
       cl_object v11;
       cl_fixnum v12;
       value0 = ecl_cadr(v10object);
       if ((value0)!=ECL_NIL) { goto L22; }
       v11 = ecl_make_fixnum(0);
       goto L20;
L22:;
       v11 = value0;
       goto L20;
L20:;
       v12 = ecl_length(v5output_vars);
       if (!(ecl_lower(v11,ecl_make_fixnum(v12)))) { goto L25; }
       T0 = ecl_nth(ecl_to_size(v11),v5output_vars);
       ecl_function_dispatch(cl_env_copy,VV[126])(1, T0) /*  WT       */;
       goto L11;
L25:;
       ecl_function_dispatch(cl_env_copy,VV[152])(3, VV[105], v11, ecl_make_fixnum(v12)) /*  CMPERR */;
       goto L11;
      }
L15:;
      if (!(ECL_CONSP(v10object))) { goto L27; }
      T0 = ecl_car(v10object);
      if (!((T0)==(ECL_SYM("QUOTE",681)))) { goto L27; }
      v10object = ecl_cadr(v10object);
L27:;
      T0 = ecl_function_dispatch(cl_env_copy,VV[183])(3, v10object, VV[106], ECL_T) /*  ADD-OBJECT */;
      ecl_function_dispatch(cl_env_copy,VV[126])(1, T0) /*  WT        */;
      goto L11;
     }
L12:;
     if (!(((v9c)==ECL_CODE_CHAR((ecl_character)(35))))) { goto L31; }
     {
      cl_object v13k;
      cl_object v14next_char;
      cl_object v15index;
      v13k = cl_read_char(1, v6s);
      v14next_char = cl_peek_char(4, ECL_NIL, v6s, ECL_NIL, ECL_NIL);
      v15index = cl_digit_char_p(2, v13k, ecl_make_fixnum(36));
      if (!((v13k)==(ECL_CODE_CHAR(35)))) { goto L36; }
      ecl_function_dispatch(cl_env_copy,VV[126])(1, ECL_CODE_CHAR(35)) /*  WT */;
      goto L11;
L36:;
      if (v15index==ECL_NIL) { goto L40; }
      if (Null(v14next_char)) { goto L38; }
      if (Null(cl_alphanumericp(v14next_char))) { goto L38; }
      goto L39;
L40:;
L39:;
      ecl_function_dispatch(cl_env_copy,VV[126])(2, ECL_CODE_CHAR(35), v13k) /*  WT */;
      goto L11;
L38:;
      {
       cl_fixnum v16;
       v16 = ecl_length(v3coerced_arguments);
       if (!(ecl_lower(v15index,ecl_make_fixnum(v16)))) { goto L43; }
      }
      T0 = ecl_nth(ecl_to_size(v15index),v3coerced_arguments);
      ecl_function_dispatch(cl_env_copy,VV[126])(1, T0) /*  WT        */;
      goto L11;
L43:;
      ecl_function_dispatch(cl_env_copy,VV[152])(1, VV[107]) /*  CMPERR */;
      goto L11;
     }
L31:;
     cl_write_char(2, v9c, ecl_symbol_value(VV[10]));
L11:;
     v9c = cl_read_char(3, v6s, ECL_NIL, ECL_NIL);
L9:;
     if (v9c==ECL_NIL) { goto L47; }
     goto L8;
L47:;
     cl_env_copy->values[0] = ECL_NIL;
     cl_env_copy->nvalues = 1;
    }
      next_fr = NULL;
    }
    ecl_frs_pop(cl_env_copy);
    v8=ecl_stack_push_values(cl_env_copy);
    cl_close(1, v6s);
    ecl_stack_pop_values(cl_env_copy,v8);
    if (unwinding) ecl_unwind(cl_env_copy,next_fr);
    ECL_STACK_SET_INDEX(cl_env_copy,v7);
    return cl_env_copy->values[0];
   }
  }
 }
}
/*      function definition for SET-UNKNOWN-LOC                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3811set_unknown_loc(cl_object v1loc)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_function_dispatch(cl_env_copy,VV[125])(2, VV[109], ecl_symbol_value(VV[110])) /*  UNKNOWN-LOCATION */;
  return value0;
 }
}
/*      function definition for SET-LOC                               */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3812set_loc(cl_object v1loc)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2destination;
   v2destination = ecl_symbol_value(VV[110]);
   {
    cl_object v3;
    v3 = ecl_make_bool((v2destination)==(v1loc));
    if (Null(v3)) { goto L3; }
    value0 = v3;
    cl_env_copy->nvalues = 1;
    return value0;
L3:;
    if (!(ECL_SYMBOLP(v2destination))) { goto L5; }
    T0 = ecl_gethash_safe(v2destination,ecl_symbol_value(VV[112]),VV[111]);
    value0 = ecl_function_dispatch(cl_env_copy,T0)(1, v1loc);
    return value0;
L5:;
    if (Null(ecl_function_dispatch(cl_env_copy,VV[127])(1, v2destination) /*  VAR-P */)) { goto L8; }
    value0 = ecl_function_dispatch(cl_env_copy,VV[186])(2, v1loc, v2destination) /*  SET-VAR */;
    return value0;
L8:;
    if (Null(ecl_function_dispatch(cl_env_copy,VV[129])(1, v2destination) /*  VV-P */)) { goto L10; }
    value0 = ecl_function_dispatch(cl_env_copy,VV[187])(2, v1loc, v2destination) /*  SET-VV */;
    return value0;
L10:;
    if (!(ECL_ATOM(v2destination))) { goto L12; }
    value0 = ecl_function_dispatch(cl_env_copy,VV[125])(2, VV[109], v2destination) /*  UNKNOWN-LOCATION */;
    return value0;
L12:;
    {
     cl_object v4fd;
     T0 = ecl_car(v2destination);
     v4fd = ecl_gethash_safe(T0,ecl_symbol_value(VV[112]),ECL_NIL);
     if (Null(v4fd)) { goto L15; }
     T0 = ecl_cdr(v2destination);
     value0 = cl_apply(3, v4fd, v1loc, T0);
     return value0;
L15:;
     ecl_function_dispatch(cl_env_copy,VV[182])(0) /*  WT-NL          */;
     L3789wt_loc(v2destination);
     ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[113]) /*  WT    */;
     T0 = ecl_function_dispatch(cl_env_copy,VV[174])(1, ecl_symbol_value(VV[110])) /*  LOC-REPRESENTATION-TYPE */;
     L3809wt_coerce_loc(T0, v1loc);
     value0 = ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[114]) /*  WT */;
     return value0;
    }
   }
  }
 }
}
/*      function definition for SET-THE-LOC                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3813set_the_loc(cl_object v1loc, cl_object v2type, cl_object v3orig_loc)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  ecl_bds_bind(cl_env_copy,VV[110],v3orig_loc);   /*  *DESTINATION*   */
  value0 = L3812set_loc(v1loc);
  ecl_bds_unwind1(cl_env_copy);
  return value0;
 }
}
/*      function definition for SET-VALUES-LOC                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3814set_values_loc(cl_object v1loc)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2;
   v2 = ecl_make_bool((v1loc)==(ECL_SYM("VALUES",897)));
   if (Null(v2)) { goto L2; }
   value0 = v2;
   cl_env_copy->nvalues = 1;
   return value0;
L2:;
   if (Null(ecl_function_dispatch(cl_env_copy,VV[190])(1, v1loc) /*  USES-VALUES */)) { goto L4; }
   ecl_function_dispatch(cl_env_copy,VV[182])(1, VV[116]) /*  WT-NL   */;
   L3809wt_coerce_loc(ECL_SYM("OBJECT",1312), v1loc);
   value0 = ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[114]) /*  WT */;
   return value0;
L4:;
   ecl_function_dispatch(cl_env_copy,VV[182])(1, VV[116]) /*  WT-NL   */;
   L3809wt_coerce_loc(ECL_SYM("OBJECT",1312), v1loc);
   ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[114]) /*  WT      */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[182])(1, VV[117]) /*  WT-NL */;
   return value0;
  }
 }
}
/*      function definition for SET-VALUE0-LOC                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3815set_value0_loc(cl_object v1loc)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  ecl_function_dispatch(cl_env_copy,VV[182])(1, VV[119]) /*  WT-NL    */;
  L3809wt_coerce_loc(ECL_SYM("OBJECT",1312), v1loc);
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[114]) /*  WT */;
  return value0;
 }
}
/*      function definition for SET-RETURN-LOC                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3816set_return_loc(cl_object v1loc)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if ((v1loc)==(ECL_SYM("VALUES",897))) { goto L3; }
  if (Null(ecl_function_dispatch(cl_env_copy,VV[190])(1, v1loc) /*  USES-VALUES */)) { goto L1; }
  goto L2;
L3:;
L2:;
  ecl_function_dispatch(cl_env_copy,VV[182])(1, VV[119]) /*  WT-NL    */;
  L3809wt_coerce_loc(ECL_SYM("OBJECT",1312), v1loc);
  value0 = ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[114]) /*  WT */;
  return value0;
L1:;
  if (!((v1loc)==(VV[121]))) { goto L7; }
  value0 = ecl_function_dispatch(cl_env_copy,VV[182])(1, VV[117]) /*  WT-NL */;
  return value0;
L7:;
  {
   cl_object v2;
   v2 = ecl_make_bool((v1loc)==(ECL_SYM("RETURN",726)));
   if (Null(v2)) { goto L10; }
   value0 = v2;
   cl_env_copy->nvalues = 1;
   return value0;
L10:;
   ecl_function_dispatch(cl_env_copy,VV[182])(1, VV[119]) /*  WT-NL   */;
   L3809wt_coerce_loc(ECL_SYM("OBJECT",1312), v1loc);
   ecl_function_dispatch(cl_env_copy,VV[126])(1, VV[114]) /*  WT      */;
   value0 = ecl_function_dispatch(cl_env_copy,VV[182])(1, VV[117]) /*  WT-NL */;
   return value0;
  }
 }
}
/*      function definition for SET-TRASH-LOC                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L3817set_trash_loc(cl_object v1loc)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(ecl_function_dispatch(cl_env_copy,VV[194])(1, v1loc) /*  LOC-WITH-SIDE-EFFECTS-P */)) { goto L1; }
  ecl_function_dispatch(cl_env_copy,VV[182])(2, v1loc, VV[114]) /*  WT-NL */;
  value0 = ECL_T;
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}

#include "cmp/cmppass2-loc.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclZjloU0oQAPwo9_aXsJpj61(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPBACKEND-CXX;CMPPASS2-LOC.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclZjloU0oQAPwo9_aXsJpj61@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(VVtemp[0]);
  ecl_cmp_defun(VV[124]);                         /*  WT-LOC          */
  ecl_cmp_defun(VV[131]);                         /*  WT-LCL          */
  ecl_cmp_defun(VV[133]);                         /*  WT-LCL-LOC      */
  ecl_cmp_defun(VV[134]);                         /*  WT-TEMP         */
  ecl_cmp_defun(VV[135]);                         /*  WT-FIXNUM       */
  ecl_cmp_defun(VV[136]);                         /*  WT-NUMBER       */
  ecl_cmp_defun(VV[137]);                         /*  WT-CHARACTER    */
  ecl_cmp_defun(VV[138]);                         /*  WT-VALUE        */
  ecl_cmp_defun(VV[139]);                         /*  WT-KEYVARS      */
  ecl_cmp_defun(VV[140]);                         /*  WT-THE          */
  ecl_cmp_defun(VV[141]);                         /*  WT-CALL         */
  ecl_cmp_defun(VV[143]);                         /*  WT-CALL-INDIRECT */
  ecl_cmp_defun(VV[144]);                         /*  WT-CALL-NORMAL  */
  ecl_cmp_defun(VV[154]);                         /*  WT-FDEFINITION  */
  ecl_cmp_defun(VV[158]);                         /*  ENVIRONMENT-ACCESSOR */
  ecl_cmp_defun(VV[161]);                         /*  WT-MAKE-CLOSURE */
  ecl_cmp_defun(VV[163]);                         /*  WT-TO-OBJECT-CONVERSION */
  ecl_cmp_defun(VV[166]);                         /*  WT-FROM-OBJECT-CONVERSION */
  ecl_cmp_defun(VV[170]);                         /*  WT-COERCE-LOC   */
  ecl_cmp_defun(VV[181]);                         /*  WT-C-INLINE-LOC */
  ecl_cmp_defun(VV[184]);                         /*  SET-UNKNOWN-LOC */
  ecl_cmp_defun(VV[185]);                         /*  SET-LOC         */
  ecl_cmp_defun(VV[188]);                         /*  SET-THE-LOC     */
  ecl_cmp_defun(VV[189]);                         /*  SET-VALUES-LOC  */
  ecl_cmp_defun(VV[191]);                         /*  SET-VALUE0-LOC  */
  ecl_cmp_defun(VV[192]);                         /*  SET-RETURN-LOC  */
  ecl_cmp_defun(VV[193]);                         /*  SET-TRASH-LOC   */
}
