/*      Compiler: ECL 23.9.9                                          */
/*      Source: /builddir/build/BUILD/ecl-23.9.9/src/cmp/cmputil.lsp  */
#include <ecl/ecl-cmp.h>
#include "cmp/cmputil.eclh"
/*      function definition for BRIEF-NAMESTRING                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2964brief_namestring(cl_object v1path)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(cl_wild_pathname_p(1, v1path))) { goto L1; }
  cl_error(2, VV[0], v1path);
L1:;
  T0 = si_coerce_to_file_pathname(v1path);
  value0 = cl_enough_namestring(1, T0);
  return value0;
 }
}
/*      function definition for NORMALIZE-BUILD-TARGET-NAME           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2965normalize_build_target_name(cl_object v1target)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!((v1target)==(VV[3]))) { goto L6; }
  goto L3;
  goto L4;
L6:;
  goto L4;
L4:;
  if (!((v1target)==(VV[4]))) { goto L10; }
  goto L3;
  goto L8;
L10:;
  goto L8;
L8:;
  if (!((v1target)==(VV[6]))) { goto L14; }
  goto L3;
  goto L12;
L14:;
  goto L12;
L12:;
  if (!((v1target)==(VV[8]))) { goto L1; }
  goto L2;
L3:;
L2:;
  value0 = VV[3];
  cl_env_copy->nvalues = 1;
  return value0;
L1:;
  if (!((v1target)==(VV[11]))) { goto L22; }
  goto L19;
  goto L20;
L22:;
  goto L20;
L20:;
  if (!((v1target)==(VV[12]))) { goto L26; }
  goto L19;
  goto L24;
L26:;
  goto L24;
L24:;
  if (!((v1target)==(VV[14]))) { goto L30; }
  goto L19;
  goto L28;
L30:;
  goto L28;
L28:;
  if (!((v1target)==(VV[16]))) { goto L17; }
  goto L18;
L19:;
L18:;
  value0 = VV[11];
  cl_env_copy->nvalues = 1;
  return value0;
L17:;
  if (!((v1target)==(VV[19]))) { goto L38; }
  goto L35;
  goto L36;
L38:;
  goto L36;
L36:;
  if (!((v1target)==(VV[20]))) { goto L33; }
  goto L34;
L35:;
L34:;
  value0 = VV[19];
  cl_env_copy->nvalues = 1;
  return value0;
L33:;
  if (!((v1target)==(VV[22]))) { goto L41; }
  value0 = VV[22];
  cl_env_copy->nvalues = 1;
  return value0;
L41:;
  value0 = si_ecase_error(v1target, VV[23]);
  return value0;
 }
}
/*      function definition for INNERMOST-NON-EXPANDED-FORM           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2966innermost_non_expanded_form(cl_object v1form)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (!(ECL_LISTP(v1form))) { goto L1; }
  {
   cl_object v2output;
   v2output = ECL_NIL;
   {
    cl_object v3f;
    cl_object v4;
    v3f = ECL_NIL;
    {
     cl_object v5;
     v5 = v1form;
     if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v4 = v5;
    }
L8:;
    if (!(ecl_endp(v4))) { goto L10; }
    goto L9;
L10:;
    v3f = ECL_CONS_CAR(v4);
    {
     cl_object v5;
     v5 = ECL_CONS_CDR(v4);
     if (ecl_unlikely(!ECL_LISTP(v5))) FEtype_error_list(v5);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v4 = v5;
    }
    if (!((v3f)==(ECL_SYM("MACROEXPAND",521)))) { goto L19; }
    v2output = ECL_NIL;
    goto L18;
L19:;
    if (!(v2output==ECL_NIL)) { goto L18; }
    v2output = v3f;
L18:;
    goto L8;
L9:;
    value0 = v2output;
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for DO-COMPILATION-UNIT                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2967do_compilation_unit(volatile cl_narg narg, cl_object volatile v1closure, ...)
{
 cl_object volatile env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 {
  cl_object volatile v2override;
  ecl_va_list args; ecl_va_start(args,v1closure,narg,1);
  {
   cl_object keyvars[2];
   cl_parse_key(args,1,L2967do_compilation_unitkeys,keyvars,NULL,FALSE);
   ecl_va_end(args);
   v2override = keyvars[0];
  }
  if (Null(v2override)) { goto L1; }
  ecl_bds_bind(cl_env_copy,VV[26],ECL_NIL);       /*  *ACTIVE-PROTECTION* */
  value0 = L2967do_compilation_unit(1, v1closure);
  ecl_bds_unwind1(cl_env_copy);
  return value0;
L1:;
  if (!(ecl_symbol_value(VV[26])==ECL_NIL)) { goto L3; }
  ecl_bds_bind(cl_env_copy,VV[26],ECL_T);         /*  *ACTIVE-PROTECTION* */
  ecl_bds_bind(cl_env_copy,VV[27],ECL_NIL);       /*  *PENDING-ACTIONS* */
  {
   volatile bool unwinding = FALSE;
   cl_index v3=ECL_STACK_INDEX(cl_env_copy),v4;
   ecl_frame_ptr next_fr;
   ecl_frs_push(cl_env_copy,ECL_PROTECT_TAG);
   if (__ecl_frs_push_result) {
     unwinding = TRUE; next_fr=cl_env_copy->nlj_fr;
   } else {
   cl_env_copy->values[0] = L2967do_compilation_unit(1, v1closure);
     next_fr = NULL;
   }
   ecl_frs_pop(cl_env_copy);
   v4=ecl_stack_push_values(cl_env_copy);
   {
    cl_object v5;
    cl_object v6action;
    cl_object v7;
    v5 = ecl_symbol_value(VV[27]);
    v6action = ECL_NIL;
    {
     cl_object v8;
     v8 = v5;
     if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v7 = v8;
    }
L12:;
    if (!(ecl_endp(v7))) { goto L14; }
    goto L13;
L14:;
    v6action = ECL_CONS_CAR(v7);
    {
     cl_object v8;
     v8 = ECL_CONS_CDR(v7);
     if (ecl_unlikely(!ECL_LISTP(v8))) FEtype_error_list(v8);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     v7 = v8;
    }
    ecl_function_dispatch(cl_env_copy,v6action)(0);
    goto L12;
L13:;
   }
   ecl_stack_pop_values(cl_env_copy,v4);
   if (unwinding) ecl_unwind(cl_env_copy,next_fr);
   ECL_STACK_SET_INDEX(cl_env_copy,v3);
   ecl_bds_unwind1(cl_env_copy);
   ecl_bds_unwind1(cl_env_copy);
   return cl_env_copy->values[0];
  }
L3:;
  value0 = ecl_function_dispatch(cl_env_copy,v1closure)(0);
  return value0;
 }
}
/*      local function WITH-COMPILATION-UNIT                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2968with_compilation_unit(cl_object v1, cl_object v2)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[91])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4 = v5;
   }
   T0 = cl_listX(3, ECL_SYM("LAMBDA",454), ECL_NIL, v3);
   T1 = cl_list(2, ECL_SYM("FUNCTION",398), T0);
   value0 = cl_listX(3, VV[28], T1, v4);
   return value0;
  }
 }
}
/*      local function WITH-COMPILER-ENV                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2969with_compiler_env(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4;
   cl_object v5;
   cl_object v6compiler_conditions;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[91])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4 = v7;
   }
   v5 = v4;
   if (!(v5==ECL_NIL)) { goto L10; }
   ecl_function_dispatch(cl_env_copy,VV[91])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L10:;
   {
    cl_object v7;
    v7 = ecl_car(v5);
    v5 = ecl_cdr(v5);
    v6compiler_conditions = v7;
   }
   if (Null(v5)) { goto L15; }
   ecl_function_dispatch(cl_env_copy,VV[93])(1, v1) /*  DM-TOO-MANY-ARGUMENTS */;
L15:;
   T0 = cl_listX(3, VV[29], ECL_NIL, v3);
   T1 = cl_list(3, ECL_SYM("LET",479), ecl_symbol_value(VV[34]), T0);
   T2 = cl_list(3, ECL_SYM("WITH-LOCK",1470), VV[33], T1);
   T3 = cl_list(3, ECL_SYM("HANDLER-BIND",419), VV[32], T2);
   T4 = cl_list(3, ECL_SYM("RESTART-CASE",724), T3, VV[35]);
   T5 = cl_list(3, ECL_SYM("SETF",752), v6compiler_conditions, VV[36]);
   value0 = cl_list(5, ECL_SYM("LET",479), VV[30], VV[31], T4, T5);
   return value0;
  }
 }
}
/*      function definition for SAFE-LIST-LENGTH                      */
/*      optimize speed 3, debug 1, space 1, safety 0                  */
static cl_object L2970safe_list_length(cl_object v1l)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
TTL:
 {
  cl_object v2slow;
  v2slow = v1l;
  {
   cl_object v3fast;
   v3fast = v1l;
   {
    cl_object v4flag;
    v4flag = ECL_T;
    {
     cl_fixnum v5l;
     v5l = 0;
L5:;
     if (!(v3fast==ECL_NIL)) { goto L8; }
     value0 = ecl_make_fixnum(v5l);
     cl_env_copy->nvalues = 1;
     return value0;
L8:;
     if (ECL_CONSP(v3fast)) { goto L10; }
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 1;
     return value0;
L10:;
     if (Null(v4flag)) { goto L12; }
     v4flag = ECL_NIL;
     v3fast = ECL_CONS_CDR(v3fast);
     goto L7;
L12:;
     if (!((v2slow)==(v3fast))) { goto L17; }
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 1;
     return value0;
L17:;
     v4flag = ECL_T;
     v2slow = ECL_CONS_CDR(v2slow);
     v3fast = ECL_CONS_CDR(v3fast);
L7:;
     v5l = (v5l)+1;
     goto L5;
     value0 = ecl_make_fixnum(v5l);
     cl_env_copy->nvalues = 1;
     return value0;
    }
   }
  }
 }
}
/*      function definition for CHECK-ARGS-NUMBER                     */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2971check_args_number(cl_narg narg, cl_object v1operator, cl_object v2args, ...)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<2)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>4)) FEwrong_num_arguments_anonym();
 {
  cl_object v3min;
  cl_object v4max;
  va_list args; va_start(args,v2args);
  {
   int i = 2;
   if (i >= narg) {
    v3min = ecl_make_fixnum(0);
   } else {
    i++;
    v3min = va_arg(args,cl_object);
   }
   if (i >= narg) {
    v4max = ecl_make_fixnum(2305843009213693951);
   } else {
    i++;
    v4max = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   cl_object v5l;
   v5l = L2970safe_list_length(v2args);
   if (!(v5l==ECL_NIL)) { goto L4; }
   ecl_bds_bind(cl_env_copy,ECL_SYM("*PRINT-CIRCLE*",49),ECL_T); /*  *PRINT-CIRCLE* */
   ecl_function_dispatch(cl_env_copy,VV[96])(3, VV[39], v1operator, v2args) /*  CMPERR */;
   ecl_bds_unwind1(cl_env_copy);
L4:;
   if (!(ecl_lower(v5l,v3min))) { goto L6; }
   ecl_function_dispatch(cl_env_copy,VV[97])(3, v1operator, v3min, v5l) /*  TOO-FEW-ARGS */;
L6:;
   if (Null(v4max)) { goto L8; }
   if (!(ecl_greater(v5l,v4max))) { goto L8; }
   value0 = ecl_function_dispatch(cl_env_copy,VV[98])(3, v1operator, v4max, v5l) /*  TOO-MANY-ARGS */;
   return value0;
L8:;
   value0 = ECL_NIL;
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for PRINT-CURRENT-FORM                    */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2972print_current_form()
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(ecl_symbol_value(ECL_SYM("*COMPILE-PRINT*",30)))) { goto L1; }
  ecl_bds_bind(cl_env_copy,ECL_SYM("*PRINT-LENGTH*",52),ecl_make_fixnum(2)); /*  *PRINT-LENGTH* */
  ecl_bds_bind(cl_env_copy,ECL_SYM("*PRINT-LEVEL*",53),ecl_make_fixnum(2)); /*  *PRINT-LEVEL* */
  T0 = L2966innermost_non_expanded_form(ecl_symbol_value(VV[42]));
  cl_format(3, ECL_T, VV[41], T0);
  ecl_bds_unwind1(cl_env_copy);
  ecl_bds_unwind1(cl_env_copy);
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for CMPPROGRESS                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2973cmpprogress(cl_narg narg, ...)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
  cl_object v1args;
  ecl_va_list args; ecl_va_start(args,narg,narg,0);
  v1args = cl_grab_rest_args(args);
  ecl_va_end(args);
  if (Null(ecl_symbol_value(ECL_SYM("*COMPILE-VERBOSE*",31)))) { goto L1; }
  T0 = (ECL_SYM("FORMAT",389)->symbol.gfdef);
  value0 = cl_apply(3, T0, ECL_T, v1args);
  return value0;
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      function definition for CMP-EVAL                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2975cmp_eval(volatile cl_narg narg, cl_object volatile v1form, ...)
{
 cl_object T0, T1, T2, T3;
 cl_object volatile env0 = ECL_NIL;
 cl_object volatile CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<1)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>2)) FEwrong_num_arguments_anonym();
 {
  cl_object volatile v2env;
  va_list args; va_start(args,v1form);
  {
   int i = 1;
   if (i >= narg) {
    v2env = ecl_symbol_value(VV[45]);
   } else {
    i++;
    v2env = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   volatile cl_object env1 = env0;
   env1 = ECL_NIL;
   CLV0 = env1 = CONS(ECL_NIL,env1);
   CLV1 = env1 = CONS(ECL_NEW_FRAME_ID(cl_env_copy),env1); /*  TAGBODY */
   {
    ecl_frs_push(cl_env_copy,ECL_CONS_CAR(CLV1));
    if (__ecl_frs_push_result) {
    if (cl_env_copy->values[0]==ecl_make_fixnum(0))goto L2;
    ecl_internal_error("GO found an inexistent tag");
    }
   }
   {
    cl_object v3;
    v3 = ecl_make_cclosure_va((cl_objectfn)LC2974__lambda73,env1,Cblock,1);
    T0 = v3;
   }
   T1 = CONS(ECL_SYM("SERIOUS-CONDITION",744),T0);
   T2 = ecl_list1(T1);
   T3 = CONS(T2,ecl_symbol_value(ECL_SYM("*HANDLER-CLUSTERS*",6)));
   ecl_bds_bind(cl_env_copy,ECL_SYM("*HANDLER-CLUSTERS*",6),T3); /*  *HANDLER-CLUSTERS* */
   value0 = si_eval_with_env(5, v1form, v2env, ECL_NIL, ECL_T, ECL_SYM("EXECUTE",1259));
   ecl_frs_pop(cl_env_copy);
   ecl_bds_unwind1(cl_env_copy);
   return value0;
L2:;
   {
    cl_object v3c;
    v3c = ECL_CONS_CAR(CLV0);
    if (Null(ecl_symbol_value(VV[46]))) { goto L7; }
    (cl_env_copy->function=(ECL_SYM("INVOKE-DEBUGGER",447)->symbol.gfdef))->cfun.entry(1, v3c) /*  INVOKE-DEBUGGER */;
L7:;
    ecl_function_dispatch(cl_env_copy,VV[96])(3, VV[47], v1form, v3c) /*  CMPERR */;
    value0 = ECL_NIL;
    cl_env_copy->nvalues = 1;
    ecl_frs_pop(cl_env_copy);
    return value0;
   }
  }
 }
}
/*      closure LAMBDA73                                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2974__lambda73(cl_narg narg, cl_object v1si__temp, ...)
{
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;                                     /*  TAGBODY         */
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  ECL_CONS_CAR(CLV0) = v1si__temp;
  cl_go(ECL_CONS_CAR(CLV1),ecl_make_fixnum(0));
 }
 }
}
/*      function definition for CMP-EXPAND-MACRO                      */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2977cmp_expand_macro(volatile cl_narg narg, cl_object volatile v1fd, cl_object volatile v2form, ...)
{
 cl_object T0, T1, T2, T3;
 cl_object volatile env0 = ECL_NIL;
 cl_object volatile CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<2)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>3)) FEwrong_num_arguments_anonym();
 {
  cl_object volatile v3env;
  va_list args; va_start(args,v2form);
  {
   int i = 2;
   if (i >= narg) {
    v3env = ecl_symbol_value(VV[45]);
   } else {
    i++;
    v3env = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   volatile cl_object env1 = env0;
   env1 = ECL_NIL;
   CLV0 = env1 = CONS(ECL_NIL,env1);
   CLV1 = env1 = CONS(ECL_NEW_FRAME_ID(cl_env_copy),env1); /*  TAGBODY */
   {
    ecl_frs_push(cl_env_copy,ECL_CONS_CAR(CLV1));
    if (__ecl_frs_push_result) {
    if (cl_env_copy->values[0]==ecl_make_fixnum(0))goto L2;
    ecl_internal_error("GO found an inexistent tag");
    }
   }
   {
    cl_object v4;
    v4 = ecl_make_cclosure_va((cl_objectfn)LC2976__lambda77,env1,Cblock,1);
    T0 = v4;
   }
   T1 = CONS(ECL_SYM("SERIOUS-CONDITION",744),T0);
   T2 = ecl_list1(T1);
   T3 = CONS(T2,ecl_symbol_value(ECL_SYM("*HANDLER-CLUSTERS*",6)));
   ecl_bds_bind(cl_env_copy,ECL_SYM("*HANDLER-CLUSTERS*",6),T3); /*  *HANDLER-CLUSTERS* */
   {
    cl_object v4new_form;
    v4new_form = ecl_function_dispatch(cl_env_copy,ecl_symbol_value(ECL_SYM("*MACROEXPAND-HOOK*",42)))(3, v1fd, v2form, v3env);
    {
     bool v5;
     v5 = ecl_eql(v4new_form,v2form);
     T0 = (v5)?ECL_NIL:ECL_T;
    }
    cl_env_copy->nvalues = 2;
    cl_env_copy->values[1] = T0;
    cl_env_copy->values[0] = v4new_form;
    value0 = cl_env_copy->values[0];
    ecl_frs_pop(cl_env_copy);
    ecl_bds_unwind1(cl_env_copy);
    return value0;
   }
L2:;
   {
    cl_object v4c;
    v4c = ECL_CONS_CAR(CLV0);
    if (Null(ecl_symbol_value(VV[46]))) { goto L9; }
    (cl_env_copy->function=(ECL_SYM("INVOKE-DEBUGGER",447)->symbol.gfdef))->cfun.entry(1, v4c) /*  INVOKE-DEBUGGER */;
L9:;
    ecl_function_dispatch(cl_env_copy,VV[96])(3, VV[49], v2form, v4c) /*  CMPERR */;
    cl_env_copy->nvalues = 2;
    cl_env_copy->values[1] = ECL_NIL;
    cl_env_copy->values[0] = ECL_NIL;
    value0 = cl_env_copy->values[0];
    ecl_frs_pop(cl_env_copy);
    return value0;
   }
  }
 }
}
/*      closure LAMBDA77                                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2976__lambda77(cl_narg narg, cl_object v1si__temp, ...)
{
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;                                     /*  TAGBODY         */
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  ECL_CONS_CAR(CLV0) = v1si__temp;
  cl_go(ECL_CONS_CAR(CLV1),ecl_make_fixnum(0));
 }
 }
}
/*      function definition for CMP-EXPAND-COMPILER-MACRO             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2979cmp_expand_compiler_macro(volatile cl_narg narg, cl_object volatile v1fd, cl_object volatile v2fname, cl_object volatile v3args, ...)
{
 cl_object T0, T1, T2, T3;
 cl_object volatile env0 = ECL_NIL;
 cl_object volatile CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object volatile value0;
 ecl_cs_check(cl_env_copy,value0);
 if (ecl_unlikely(narg<3)) FEwrong_num_arguments_anonym();
 if (ecl_unlikely(narg>4)) FEwrong_num_arguments_anonym();
 {
  cl_object volatile v4env;
  va_list args; va_start(args,v3args);
  {
   int i = 3;
   if (i >= narg) {
    v4env = ecl_symbol_value(VV[45]);
   } else {
    i++;
    v4env = va_arg(args,cl_object);
   }
  }
  va_end(args);
  {
   volatile cl_object env1 = env0;
   env1 = ECL_NIL;
   CLV0 = env1 = CONS(ECL_NIL,env1);
   CLV1 = env1 = CONS(ECL_NEW_FRAME_ID(cl_env_copy),env1); /*  TAGBODY */
   {
    ecl_frs_push(cl_env_copy,ECL_CONS_CAR(CLV1));
    if (__ecl_frs_push_result) {
    if (cl_env_copy->values[0]==ecl_make_fixnum(0))goto L2;
    ecl_internal_error("GO found an inexistent tag");
    }
   }
   {
    cl_object v5;
    v5 = ecl_make_cclosure_va((cl_objectfn)LC2978__lambda81,env1,Cblock,1);
    T0 = v5;
   }
   T1 = CONS(ECL_SYM("SERIOUS-CONDITION",744),T0);
   T2 = ecl_list1(T1);
   T3 = CONS(T2,ecl_symbol_value(ECL_SYM("*HANDLER-CLUSTERS*",6)));
   ecl_bds_bind(cl_env_copy,ECL_SYM("*HANDLER-CLUSTERS*",6),T3); /*  *HANDLER-CLUSTERS* */
   T0 = CONS(v2fname,v3args);
   value0 = L2977cmp_expand_macro(3, v1fd, T0, v4env);
   ecl_frs_pop(cl_env_copy);
   ecl_bds_unwind1(cl_env_copy);
   return value0;
L2:;
   {
    cl_object v5c;
    v5c = ECL_CONS_CAR(CLV0);
    T0 = cl_list(2, v2fname, v5c);
    ecl_function_dispatch(cl_env_copy,VV[104])(5, VV[51], ECL_SYM("FORMAT-CONTROL",1269), VV[52], ECL_SYM("FORMAT-ARGUMENTS",1268), T0) /*  DO-CMPWARN */;
    cl_env_copy->nvalues = 2;
    cl_env_copy->values[1] = ECL_NIL;
    cl_env_copy->values[0] = ECL_NIL;
    value0 = cl_env_copy->values[0];
    ecl_frs_pop(cl_env_copy);
    return value0;
   }
  }
 }
}
/*      closure LAMBDA81                                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2978__lambda81(cl_narg narg, cl_object v1si__temp, ...)
{
 cl_object CLV0, CLV1;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV1 = env0;                                     /*  TAGBODY         */
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  ECL_CONS_CAR(CLV0) = v1si__temp;
  cl_go(ECL_CONS_CAR(CLV1),ecl_make_fixnum(0));
 }
 }
}
/*      function definition for LISP-TO-C-NAME                        */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2981lisp_to_c_name(cl_object v1obj)
{
 cl_object T0, T1, T2;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  if (Null(v1obj)) { goto L2; }
  {
   cl_object v2;
   v2 = ecl_make_cfun((cl_objectfn_fixed)LC2980__lambda82,ECL_NIL,Cblock,1);
   T0 = v2;
  }
  T1 = cl_prin1_to_string(v1obj);
  T2 = cl_string_downcase(1, T1);
  value0 = cl_map(3, ECL_SYM("STRING",807), T0, T2);
  return value0;
L2:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
}
/*      local function LAMBDA82                                       */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2980__lambda82(cl_object v1c)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_fixnum v2cc;
   v2cc = ecl_fixnum(cl_char_code(v1c));
   if (((97)<=(v2cc) && (v2cc)<=(122))) { goto L4; }
   if (!(((48)<=(v2cc) && (v2cc)<=(57)))) { goto L2; }
   goto L3;
L4:;
L3:;
   value0 = v1c;
   cl_env_copy->nvalues = 1;
   return value0;
L2:;
   value0 = ECL_CODE_CHAR(95);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
}
/*      function definition for COLLECT-LINES                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2982collect_lines(cl_object v1stream)
{
 cl_object T0;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v2line;
   v2line = ECL_NIL;
   {
    cl_object v3;
    cl_object v4;
    v3 = ecl_list1(ECL_NIL);
    v4 = v3;
L4:;
    v2line = cl_read_line(3, v1stream, ECL_NIL, ECL_NIL);
    if ((v2line)!=ECL_NIL) { goto L8; }
    goto L5;
L8:;
    {
     cl_object v5;
     v5 = v4;
     if (ecl_unlikely(ECL_ATOM(v5))) FEtype_error_cons(v5);
     value0 = ECL_NIL;
     cl_env_copy->nvalues = 0;
     T0 = v5;
    }
    v4 = ecl_list1(v2line);
    (ECL_CONS_CDR(T0)=v4,T0);
    goto L4;
L5:;
    value0 = ecl_cdr(v3);
    cl_env_copy->nvalues = 1;
    return value0;
   }
  }
 }
}
/*      local function DEFINE-COMPILER-MACRO*                         */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2988define_compiler_macro_(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19;
 cl_object env0 = ECL_NIL;
 volatile struct ecl_cclosure aux_closure;
 cl_object CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6, CLV7, CLV8, CLV9, CLV10, CLV11, CLV12, CLV13, CLV14, CLV15;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4lambda_list;
   cl_object env1 = env0;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L2; }
   ecl_function_dispatch(cl_env_copy,VV[91])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L2:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    T0 = v5;
   }
   env1 = ECL_NIL;
   CLV0 = env1 = CONS(T0,env1);                   /*  NAME            */
   if (!(v3==ECL_NIL)) { goto L9; }
   ecl_function_dispatch(cl_env_copy,VV[91])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L9:;
   {
    cl_object v5;
    v5 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4lambda_list = v5;
   }
   {
    cl_object v5output;
    cl_object env2 = env1;
    T0 = cl_gensym(1, _ecl_static_0);
    CLV1 = env2 = CONS(T0,env2);                  /*  GIVEN-KEYWORD   */
    T0 = cl_gensym(1, _ecl_static_1);
    CLV2 = env2 = CONS(T0,env2);                  /*  GIVEN-ARG       */
    T0 = cl_gensym(1, _ecl_static_2);
    CLV3 = env2 = CONS(T0,env2);                  /*  SOME-KEYWORD-FOUND */
    v5output = cl_gensym(1, _ecl_static_3);
    T0 = cl_gensym(1, _ecl_static_4);
    CLV4 = env2 = CONS(T0,env2);                  /*  ALL-FOUND-KEYWORDS */
    T0 = cl_gensym(1, _ecl_static_5);
    CLV5 = env2 = CONS(T0,env2);                  /*  BINDINGS-FOR-EXPANSION */
    {
     cl_object v6aux_setf_forms;
     cl_object env3 = env2;
     T0 = cl_gensym(0);
     CLV6 = env3 = CONS(T0,env3);                 /*  WHOLE           */
     T0 = cl_list(2, ECL_CONS_CAR(CLV6), ECL_SYM("&WHOLE",15));
     CLV7 = env3 = CONS(T0,env3);                 /*  NEW-LAMBDA-LIST */
     v6aux_setf_forms = ECL_NIL;
     CLV8 = env3 = CONS(ECL_NIL,env3);            /*  PARSE-FORMS-PASS1 */
     CLV9 = env3 = CONS(ECL_NIL,env3);            /*  PARSE-FORMS-PASS2 */
     CLV10 = env3 = CONS(ECL_NIL,env3);           /*  PARSE-FORMS-PASS3 */
     CLV11 = env3 = CONS(ECL_NIL,env3);           /*  KEYWORD-PARSE-FORMS-PASS2 */
     T0 = cl_list(2, ECL_CONS_CAR(CLV4), ECL_CONS_CAR(CLV5));
     CLV12 = env3 = CONS(T0,env3);                /*  BINDINGS-FOR-BODY */
     T0 = ecl_car(v4lambda_list);
     if (!((T0)==(ECL_SYM("&WHOLE",15)))) { goto L16; }
     T0 = ecl_cadr(v4lambda_list);
     T1 = cl_list(2, T0, ECL_CONS_CAR(CLV6));
     ECL_CONS_CAR(CLV12) = CONS(T1,ECL_CONS_CAR(CLV12));
     v4lambda_list = ecl_cddr(v4lambda_list);
L16:;
     {
      cl_object v7env;
      {
       cl_object v8;
       cl_object v9;
       v8 = ECL_SYM("&ENVIRONMENT",11);
       v9 = v4lambda_list;
       v7env = ecl_memql(v8,v9);
      }
      if (Null(v7env)) { goto L21; }
      ECL_CONS_CAR(CLV7) = CONS(ECL_SYM("&ENVIRONMENT",11),ECL_CONS_CAR(CLV7));
      T0 = ecl_cadr(v7env);
      ECL_CONS_CAR(CLV7) = CONS(T0,ECL_CONS_CAR(CLV7));
      T0 = cl_ldiff(v4lambda_list, v7env);
      T1 = ecl_cddr(v7env);
      v4lambda_list = ecl_nconc(T0,T1);
     }
L21:;
     {
      cl_object v8;                               /*  REQS            */
      cl_object v9;                               /*  OPTS            */
      cl_object v10;                              /*  KEYWORDS        */
      cl_object v11;                              /*  AUXS            */
      volatile cl_object env4 = env3;
      value0 = si_process_lambda_list(v4lambda_list, ECL_SYM("MACRO",1108));
      {
       const int v12 = cl_env_copy->nvalues;
       v8 = value0;
       cl_object v13;
       v13 = (v12<=1)? ECL_NIL : cl_env_copy->values[1];
       v9 = v13;
       v13 = (v12<=2)? ECL_NIL : cl_env_copy->values[2];
       CLV13 = env4 = CONS(v13,env4);             /*  REST            */
       v13 = (v12<=3)? ECL_NIL : cl_env_copy->values[3];
       CLV14 = env4 = CONS(v13,env4);             /*  KEY-FLAG        */
       v13 = (v12<=4)? ECL_NIL : cl_env_copy->values[4];
       v10 = v13;
       v13 = (v12<=5)? ECL_NIL : cl_env_copy->values[5];
       CLV15 = env4 = CONS(v13,env4);             /*  ALLOW-OTHER-KEYS */
       v13 = (v12<=6)? ECL_NIL : cl_env_copy->values[6];
       v11 = v13;
      }
      if (Null(ECL_CONS_CAR(CLV13))) { goto L32; }
      if ((ECL_CONS_CAR(CLV14))!=ECL_NIL) { goto L35; }
      if (Null(ECL_CONS_CAR(CLV15))) { goto L32; }
      goto L33;
L35:;
L33:;
      cl_error(1, VV[56]);
L32:;
      {
       cl_object v12;
       v12 = ecl_make_cclosure_va((cl_objectfn)LC2985handle_required_parameter,env4,Cblock,1);
       {
        cl_object v13;
        cl_object v14;
        cl_object v15;
        v13 = ecl_cdr(v8);
        v14 = ECL_NIL;
        {
         cl_object v16;
         v16 = v13;
         if (ecl_unlikely(!ECL_LISTP(v16))) FEtype_error_list(v16);
         value0 = ECL_NIL;
         cl_env_copy->nvalues = 0;
         v15 = v16;
        }
        {
         cl_object v16;
         cl_object v17;
         v16 = ecl_list1(ECL_NIL);
         v17 = v16;
L45:;
         if (!(ecl_endp(v15))) { goto L47; }
         goto L46;
L47:;
         v14 = ECL_CONS_CAR(v15);
         {
          cl_object v18;
          v18 = ECL_CONS_CDR(v15);
          if (ecl_unlikely(!ECL_LISTP(v18))) FEtype_error_list(v18);
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
          v15 = v18;
         }
         {
          cl_object v18;
          v18 = v17;
          if (ecl_unlikely(ECL_ATOM(v18))) FEtype_error_cons(v18);
          value0 = ECL_NIL;
          cl_env_copy->nvalues = 0;
          T0 = v18;
         }
         T1 = ecl_function_dispatch(cl_env_copy,v12)(1, v14);
         v17 = ecl_list1(T1);
         (ECL_CONS_CDR(T0)=v17,T0);
         goto L45;
L46:;
         goto L37;
        }
       }
L37:;
       T0 = ecl_car(v9);
       if (!(ecl_greater(T0,ecl_make_fixnum(0)))) { goto L63; }
       ECL_CONS_CAR(CLV7) = CONS(ECL_SYM("&OPTIONAL",13),ECL_CONS_CAR(CLV7));
       {
        cl_object v13o;
        v13o = ecl_cdr(v9);
L68:;
        if (!(ECL_ATOM(v13o))) { goto L70; }
        goto L69;
L70:;
        (aux_closure.env=env4,cl_env_copy->function=(cl_object)&aux_closure,LC2986handle_optional_parameter(1, v13o));
        v13o = ecl_cdddr(v13o);
        goto L68;
L69:;
       }
L63:;
       if (Null(ECL_CONS_CAR(CLV13))) { goto L76; }
       {
        cl_object v13_rest;
        v13_rest = LC2983prefix_symbol(ECL_CONS_CAR(CLV13));
        T0 = cl_list(2, v13_rest, VV[63]);
        ECL_CONS_CAR(CLV12) = CONS(T0,ECL_CONS_CAR(CLV12));
        T0 = cl_list(3, ECL_SYM("LIST",483), v13_rest, ECL_CONS_CAR(CLV13));
        T1 = cl_list(3, ECL_SYM("PUSH",679), T0, ECL_CONS_CAR(CLV5));
        ECL_CONS_CAR(CLV9) = CONS(T1,ECL_CONS_CAR(CLV9));
        ECL_CONS_CAR(CLV7) = CONS(ECL_SYM("&REST",14),ECL_CONS_CAR(CLV7));
        ECL_CONS_CAR(CLV7) = CONS(ECL_CONS_CAR(CLV13),ECL_CONS_CAR(CLV7));
       }
L76:;
       if ((ECL_CONS_CAR(CLV14))!=ECL_NIL) { goto L88; }
       if (Null(ECL_CONS_CAR(CLV15))) { goto L86; }
       goto L87;
L88:;
L87:;
       if ((ECL_CONS_CAR(CLV13))!=ECL_NIL) { goto L90; }
       ECL_CONS_CAR(CLV13) = cl_gensym(0);
       ECL_CONS_CAR(CLV7) = CONS(ECL_SYM("&REST",14),ECL_CONS_CAR(CLV7));
       ECL_CONS_CAR(CLV7) = CONS(ECL_CONS_CAR(CLV13),ECL_CONS_CAR(CLV7));
L90:;
       {
        cl_object v13key_spec;
        v13key_spec = ecl_cdr(v10);
L99:;
        if (!(ECL_ATOM(v13key_spec))) { goto L101; }
        goto L100;
L101:;
        (aux_closure.env=env4,cl_env_copy->function=(cl_object)&aux_closure,LC2987handle_keyword_parameter(1, v13key_spec));
        v13key_spec = ecl_cddddr(v13key_spec);
        goto L99;
L100:;
       }
       T0 = cl_list(2, ECL_SYM("NREVERSE",591), ECL_CONS_CAR(CLV4));
       T1 = cl_listX(7, ECL_SYM("LOOP",514), VV[58], ECL_CONS_CAR(CLV1), VV[59], T0, ECL_SYM("DO",309), ECL_CONS_CAR(CLV11));
       ECL_CONS_CAR(CLV9) = CONS(T1,ECL_CONS_CAR(CLV9));
L86:;
       {
        cl_object v13a;
        v13a = ecl_cdr(v11);
L110:;
        if (!(ECL_ATOM(v13a))) { goto L112; }
        goto L111;
L112:;
        T0 = ecl_car(v13a);
        ECL_CONS_CAR(CLV12) = CONS(T0,ECL_CONS_CAR(CLV12));
        T0 = ecl_car(v13a);
        T1 = ecl_cadr(v13a);
        T2 = cl_list(3, ECL_SYM("SETF",752), T0, T1);
        v6aux_setf_forms = CONS(T2,v6aux_setf_forms);
        v13a = ecl_cddr(v13a);
        goto L110;
L111:;
       }
       T0 = cl_nreverse(ECL_CONS_CAR(CLV7));
       T1 = cl_nreverse(ECL_CONS_CAR(CLV12));
       T2 = (aux_closure.env=env4,cl_env_copy->function=(cl_object)&aux_closure,LC2984pass1_parse(0));
       T3 = CONS(ECL_SYM("LOCALLY",492),v3);
       T4 = cl_list(3, ECL_SYM("BLOCK",139), ECL_CONS_CAR(CLV0), T3);
       T5 = cl_list(2, v5output, T4);
       T6 = ecl_list1(T5);
       T7 = cl_list(3, ECL_SYM("EQ",335), v5output, ECL_CONS_CAR(CLV6));
       T8 = cl_nreverse(ECL_CONS_CAR(CLV9));
       T9 = cl_nreverse(ECL_CONS_CAR(CLV10));
       T10 = cl_list(2, ECL_SYM("NREVERSE",591), ECL_CONS_CAR(CLV5));
       T11 = cl_list(4, ECL_SYM("LIST",483), VV[64], T10, v5output);
       T12 = ecl_list1(T11);
       T13 = cl_append(3, T8, T9, T12);
       T14 = CONS(ECL_SYM("PROGN",673),T13);
       T15 = cl_list(4, ECL_SYM("IF",948), T7, ECL_CONS_CAR(CLV6), T14);
       T16 = cl_list(3, ECL_SYM("LET",479), T6, T15);
       T17 = ecl_list1(T16);
       T18 = ecl_append(v6aux_setf_forms,T17);
       T19 = cl_listX(4, ECL_SYM("LET*",480), T1, T2, T18);
       value0 = cl_list(4, ECL_SYM("DEFINE-COMPILER-MACRO",281), ECL_CONS_CAR(CLV0), T0, T19);
       return value0;
      }
     }
    }
   }
  }
 }
}
/*      closure HANDLE-KEYWORD-PARAMETER                              */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2987handle_keyword_parameter(cl_narg narg, cl_object v1key_spec, ...)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7;
 cl_object CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6, CLV7, CLV8, CLV9, CLV10, CLV11, CLV12, CLV13, CLV14, CLV15;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV15 = env0;
 CLV14 = _ecl_cdr(CLV15);
 CLV13 = _ecl_cdr(CLV14);
 CLV12 = _ecl_cdr(CLV13);                         /*  BINDINGS-FOR-BODY */
 CLV11 = _ecl_cdr(CLV12);
 CLV10 = _ecl_cdr(CLV11);
 CLV9 = _ecl_cdr(CLV10);
 CLV8 = _ecl_cdr(CLV9);
 CLV7 = _ecl_cdr(CLV8);
 CLV6 = _ecl_cdr(CLV7);
 CLV5 = _ecl_cdr(CLV6);
 CLV4 = _ecl_cdr(CLV5);
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  {
   cl_object v2keyword;
   cl_object v3symbol;
   cl_object v4init;
   cl_object v5supplied_p;
   cl_object v6_symbol;
   v2keyword = ecl_car(v1key_spec);
   v3symbol = ecl_cadr(v1key_spec);
   v4init = ecl_caddr(v1key_spec);
   value0 = ecl_cadddr(v1key_spec);
   if ((value0)!=ECL_NIL) { goto L6; }
   v5supplied_p = cl_gensym(0);
   goto L4;
L6:;
   v5supplied_p = value0;
   goto L4;
L4:;
   v6_symbol = LC2983prefix_symbol(v3symbol);
   T0 = cl_list(2, v6_symbol, VV[63]);
   ECL_CONS_CAR(CLV12) = CONS(T0,ECL_CONS_CAR(CLV12));
   T0 = cl_list(2, v3symbol, v4init);
   ECL_CONS_CAR(CLV12) = CONS(T0,ECL_CONS_CAR(CLV12));
   T0 = cl_list(2, v5supplied_p, ECL_NIL);
   ECL_CONS_CAR(CLV12) = CONS(T0,ECL_CONS_CAR(CLV12));
   T0 = cl_list(3, ECL_SYM("EQ",335), ECL_CONS_CAR(CLV1), v2keyword);
   T1 = cl_list(2, ECL_SYM("NOT",586), v5supplied_p);
   T2 = cl_list(3, ECL_SYM("AND",89), T0, T1);
   T3 = cl_list(3, ECL_SYM("SETF",752), ECL_CONS_CAR(CLV3), ECL_T);
   T4 = cl_list(3, ECL_SYM("SETF",752), v3symbol, ECL_CONS_CAR(CLV2));
   T5 = cl_list(3, ECL_SYM("SETF",752), v5supplied_p, ECL_T);
   T6 = cl_list(3, ECL_SYM("PUSH",679), v2keyword, ECL_CONS_CAR(CLV4));
   T7 = cl_list(6, ECL_SYM("WHEN",907), T2, T3, T4, T5, T6);
   ECL_CONS_CAR(CLV8) = CONS(T7,ECL_CONS_CAR(CLV8));
   T0 = cl_list(3, ECL_SYM("EQ",335), ECL_CONS_CAR(CLV1), v2keyword);
   T1 = cl_list(3, ECL_SYM("LIST",483), v6_symbol, v3symbol);
   T2 = cl_list(3, ECL_SYM("PUSH",679), T1, ECL_CONS_CAR(CLV5));
   T3 = cl_list(3, ECL_SYM("WHEN",907), T0, T2);
   ECL_CONS_CAR(CLV11) = CONS(T3,ECL_CONS_CAR(CLV11));
   T0 = cl_list(3, ECL_SYM("LIST",483), v6_symbol, v3symbol);
   T1 = cl_list(3, ECL_SYM("PUSH",679), T0, ECL_CONS_CAR(CLV5));
   T2 = cl_list(3, ECL_SYM("UNLESS",885), v5supplied_p, T1);
   ECL_CONS_CAR(CLV10) = CONS(T2,ECL_CONS_CAR(CLV10));
   value0 = ECL_CONS_CAR(CLV10);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
 }
}
/*      closure HANDLE-OPTIONAL-PARAMETER                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2986handle_optional_parameter(cl_narg narg, cl_object v1opt_spec, ...)
{
 cl_object T0, T1, T2;
 cl_object CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6, CLV7, CLV8, CLV9, CLV10, CLV11, CLV12, CLV13, CLV14, CLV15;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV15 = env0;
 CLV14 = _ecl_cdr(CLV15);
 CLV13 = _ecl_cdr(CLV14);
 CLV12 = _ecl_cdr(CLV13);                         /*  BINDINGS-FOR-BODY */
 CLV11 = _ecl_cdr(CLV12);
 CLV10 = _ecl_cdr(CLV11);
 CLV9 = _ecl_cdr(CLV10);
 CLV8 = _ecl_cdr(CLV9);
 CLV7 = _ecl_cdr(CLV8);
 CLV6 = _ecl_cdr(CLV7);
 CLV5 = _ecl_cdr(CLV6);
 CLV4 = _ecl_cdr(CLV5);
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  {
   cl_object v2symbol;
   cl_object v3init;
   cl_object v4supplied_p;
   cl_object v5_symbol;
   v2symbol = ecl_car(v1opt_spec);
   v3init = ecl_cadr(v1opt_spec);
   value0 = ecl_caddr(v1opt_spec);
   if ((value0)!=ECL_NIL) { goto L5; }
   v4supplied_p = cl_gensym(0);
   goto L3;
L5:;
   v4supplied_p = value0;
   goto L3;
L3:;
   v5_symbol = LC2983prefix_symbol(v2symbol);
   T0 = cl_list(2, v5_symbol, VV[63]);
   ECL_CONS_CAR(CLV12) = CONS(T0,ECL_CONS_CAR(CLV12));
   T0 = cl_list(3, v2symbol, v3init, v4supplied_p);
   ECL_CONS_CAR(CLV7) = CONS(T0,ECL_CONS_CAR(CLV7));
   T0 = cl_list(3, ECL_SYM("LIST",483), v5_symbol, v2symbol);
   T1 = cl_list(3, ECL_SYM("PUSH",679), T0, ECL_CONS_CAR(CLV5));
   T2 = cl_list(3, ECL_SYM("WHEN",907), v4supplied_p, T1);
   ECL_CONS_CAR(CLV9) = CONS(T2,ECL_CONS_CAR(CLV9));
   T0 = cl_list(3, ECL_SYM("LIST",483), v5_symbol, v2symbol);
   T1 = cl_list(3, ECL_SYM("PUSH",679), T0, ECL_CONS_CAR(CLV5));
   T2 = cl_list(3, ECL_SYM("UNLESS",885), v4supplied_p, T1);
   ECL_CONS_CAR(CLV10) = CONS(T2,ECL_CONS_CAR(CLV10));
   value0 = ECL_CONS_CAR(CLV10);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
 }
}
/*      closure HANDLE-REQUIRED-PARAMETER                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2985handle_required_parameter(cl_narg narg, cl_object v1symbol, ...)
{
 cl_object T0, T1;
 cl_object CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6, CLV7, CLV8, CLV9, CLV10, CLV11, CLV12, CLV13, CLV14, CLV15;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV15 = env0;
 CLV14 = _ecl_cdr(CLV15);
 CLV13 = _ecl_cdr(CLV14);
 CLV12 = _ecl_cdr(CLV13);                         /*  BINDINGS-FOR-BODY */
 CLV11 = _ecl_cdr(CLV12);
 CLV10 = _ecl_cdr(CLV11);
 CLV9 = _ecl_cdr(CLV10);
 CLV8 = _ecl_cdr(CLV9);
 CLV7 = _ecl_cdr(CLV8);
 CLV6 = _ecl_cdr(CLV7);
 CLV5 = _ecl_cdr(CLV6);
 CLV4 = _ecl_cdr(CLV5);
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=1)) FEwrong_num_arguments_anonym();
 {
TTL:
  {
   cl_object v2_symbol;
   v2_symbol = LC2983prefix_symbol(v1symbol);
   T0 = cl_list(2, v2_symbol, VV[63]);
   ECL_CONS_CAR(CLV12) = CONS(T0,ECL_CONS_CAR(CLV12));
   ECL_CONS_CAR(CLV7) = CONS(v1symbol,ECL_CONS_CAR(CLV7));
   T0 = cl_list(3, ECL_SYM("LIST",483), v2_symbol, v1symbol);
   T1 = cl_list(3, ECL_SYM("PUSH",679), T0, ECL_CONS_CAR(CLV5));
   ECL_CONS_CAR(CLV9) = CONS(T1,ECL_CONS_CAR(CLV9));
   value0 = ECL_CONS_CAR(CLV9);
   cl_env_copy->nvalues = 1;
   return value0;
  }
 }
 }
}
/*      closure PASS1-PARSE                                           */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2984pass1_parse(cl_narg narg, ...)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21;
 cl_object CLV0, CLV1, CLV2, CLV3, CLV4, CLV5, CLV6, CLV7, CLV8, CLV9, CLV10, CLV11, CLV12, CLV13, CLV14, CLV15;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object env0 = cl_env_copy->function->cclosure.env;
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 /* Scanning closure data ... */
 CLV15 = env0;                                    /*  ALLOW-OTHER-KEYS */
 CLV14 = _ecl_cdr(CLV15);
 CLV13 = _ecl_cdr(CLV14);
 CLV12 = _ecl_cdr(CLV13);
 CLV11 = _ecl_cdr(CLV12);
 CLV10 = _ecl_cdr(CLV11);
 CLV9 = _ecl_cdr(CLV10);
 CLV8 = _ecl_cdr(CLV9);
 CLV7 = _ecl_cdr(CLV8);
 CLV6 = _ecl_cdr(CLV7);
 CLV5 = _ecl_cdr(CLV6);
 CLV4 = _ecl_cdr(CLV5);
 CLV3 = _ecl_cdr(CLV4);
 CLV2 = _ecl_cdr(CLV3);
 CLV1 = _ecl_cdr(CLV2);
 CLV0 = _ecl_cdr(CLV1);
 { /* ... closure scanning finished */
 if (ecl_unlikely(narg!=0)) FEwrong_num_arguments_anonym();
 {
TTL:
  if (Null(ECL_CONS_CAR(CLV14))) { goto L1; }
  T0 = cl_list(2, ECL_SYM("LENGTH",478), ECL_CONS_CAR(CLV13));
  T1 = cl_list(3, ECL_SYM("MOD",562), T0, ecl_make_fixnum(2));
  T2 = cl_list(2, ECL_SYM("ZEROP",928), T1);
  T3 = cl_list(3, ECL_SYM("RETURN-FROM",727), ECL_CONS_CAR(CLV0), ECL_CONS_CAR(CLV6));
  T4 = cl_list(3, ECL_SYM("UNLESS",885), T2, T3);
  T5 = cl_list(2, ECL_SYM("REST",721), ECL_CONS_CAR(CLV13));
  T6 = cl_list(2, ECL_SYM("KEYWORDP",452), ECL_CONS_CAR(CLV1));
  T7 = cl_list(2, ECL_SYM("NOT",586), T6);
  T8 = cl_list(3, ECL_SYM("EQ",335), ECL_CONS_CAR(CLV1), ECL_SYM("ALLOW-OTHER-KEYS",1224));
  T9 = cl_list(3, ECL_SYM("OR",616), T7, T8);
  T10 = cl_list(3, ECL_SYM("RETURN-FROM",727), ECL_CONS_CAR(CLV0), ECL_CONS_CAR(CLV6));
  T11 = cl_list(3, ECL_SYM("WHEN",907), T9, T10);
  T12 = ECL_CONS_CAR(CLV8);
  T13 = cl_list(2, ECL_SYM("NOT",586), ECL_CONS_CAR(CLV3));
  T14 = cl_list(4, ECL_SYM("LIST",483), VV[62], VV[63], ECL_CONS_CAR(CLV2));
  T15 = cl_list(3, ECL_SYM("PUSH",679), T14, ECL_CONS_CAR(CLV5));
  T16 = cl_list(3, ECL_SYM("RETURN-FROM",727), ECL_CONS_CAR(CLV0), ECL_CONS_CAR(CLV6));
  T17 = cl_list(4, ECL_SYM("IF",948), ECL_CONS_CAR(CLV15), T15, T16);
  T18 = cl_list(3, ECL_SYM("WHEN",907), T13, T17);
  T19 = ecl_list1(T18);
  T20 = ecl_append(T12,T19);
  T21 = cl_listX(20, ECL_SYM("LOOP",514), VV[58], ECL_CONS_CAR(CLV1), VV[59], ECL_CONS_CAR(CLV13), VV[60], VV[61], VV[58], ECL_CONS_CAR(CLV2), VV[59], T5, VV[60], VV[61], VV[58], ECL_CONS_CAR(CLV3), ECL_SYM("=",76), ECL_NIL, ECL_SYM("DO",309), T11, T20);
  value0 = cl_list(3, ECL_SYM("PROGN",673), T4, T21);
  return value0;
L1:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
 }
}
/*      local function PREFIX-SYMBOL                                  */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2983prefix_symbol(cl_object v1s)
{
 cl_object T0, T1;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  T0 = ecl_symbol_name(v1s);
  T1 = cl_concatenate(3, ECL_SYM("STRING",807), VV[57], T0);
  value0 = cl_intern(1, T1);
  return value0;
 }
}
/*      function definition for EQUAL-WITH-CIRCULARITY                */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2990equal_with_circularity(cl_object v1x, cl_object v2y)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = LC2989equal_recursive(v1x, v2y, ECL_NIL, ECL_NIL, ECL_T, ecl_make_fixnum(0), ecl_make_fixnum(-1));
  return value0;
 }
}
/*      local function EQUAL-RECURSIVE                                */
/*      optimize speed 1, debug 1, space 1, safety 0                  */
static cl_object LC2989equal_recursive(cl_object v1x, cl_object v2y, cl_object v3x0, cl_object v4y0, cl_object v5switch, cl_object v6path_spec, cl_object v7n)
{
 cl_object T0, T1, T2, T3, T4;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 cl_fixnum v8n;
 v8n = ecl_fixnum(v7n);
TTL:
 if (!(ECL_CONSP(v1x))) { goto L3; }
 if (ECL_CONSP(v2y)) { goto L1; }
 goto L2;
L3:;
L2:;
 value0 = ecl_make_bool(ecl_equal(v1x,v2y));
 cl_env_copy->nvalues = 1;
 return value0;
L1:;
 if (!((v1x)==(v2y))) { goto L5; }
 value0 = ECL_T;
 cl_env_copy->nvalues = 1;
 return value0;
L5:;
 if (!((v1x)==(v3x0))) { goto L7; }
 if (!((v2y)==(v4y0))) { goto L7; }
 value0 = ECL_T;
 cl_env_copy->nvalues = 1;
 return value0;
L7:;
 if ((v1x)==(v3x0)) { goto L12; }
 if (!((v2y)==(v4y0))) { goto L10; }
 goto L11;
L12:;
L11:;
 value0 = ECL_NIL;
 cl_env_copy->nvalues = 1;
 return value0;
L10:;
 if (!((v8n)==(-1))) { goto L14; }
 T0 = _ecl_car(v1x);
 T1 = _ecl_car(v2y);
 if (Null(LC2989equal_recursive(T0, T1, v1x, v2y, ECL_NIL, ecl_make_fixnum(1), ecl_make_fixnum(0)))) { goto L17; }
 {
  cl_object v9;
  v9 = _ecl_cdr(v1x);
  {
   cl_object v10;
   v10 = _ecl_cdr(v2y);
   v3x0 = v1x;
   v4y0 = v2y;
   v5switch = ECL_NIL;
   v6path_spec = ecl_make_fixnum(0);
   v8n = 0;
   v2y = v10;
   v1x = v9;
  }
 }
 goto TTL;
L17:;
 value0 = ECL_NIL;
 cl_env_copy->nvalues = 1;
 return value0;
L14:;
 if (Null(v5switch)) { goto L27; }
 {
  cl_object v9mask;
  cl_object v10x0;
  cl_object v11y0;
  v9mask = cl_ash(ecl_make_fixnum(1), ecl_make_fixnum(v8n));
  T0 = ecl_boole(ECL_BOOLAND,(v6path_spec),(v9mask));
  if (!(ecl_zerop(T0))) { goto L31; }
  v10x0 = _ecl_cdr(v3x0);
  goto L30;
L31:;
  v10x0 = _ecl_car(v3x0);
L30:;
  T0 = ecl_boole(ECL_BOOLAND,(v6path_spec),(v9mask));
  if (!(ecl_zerop(T0))) { goto L34; }
  v11y0 = _ecl_cdr(v4y0);
  goto L33;
L34:;
  v11y0 = _ecl_car(v4y0);
L33:;
  T0 = _ecl_car(v1x);
  T1 = _ecl_car(v2y);
  T2 = ecl_boole(ECL_BOOLANDC2,(v6path_spec),(v9mask));
  T3 = ecl_ash(T2,1);
  T4 = ecl_boole(ECL_BOOLIOR,(T3),(ecl_make_fixnum(1)));
  if (Null(LC2989equal_recursive(T0, T1, v10x0, v11y0, ECL_NIL, T4, ecl_make_fixnum(v8n)))) { goto L37; }
  v1x = _ecl_cdr(v1x);
  v2y = _ecl_cdr(v2y);
  v3x0 = v10x0;
  v4y0 = v11y0;
  v5switch = ECL_NIL;
  T0 = ecl_boole(ECL_BOOLANDC2,(v6path_spec),(v9mask));
  v6path_spec = ecl_ash(T0,1);
  goto TTL;
L37:;
  value0 = ECL_NIL;
  cl_env_copy->nvalues = 1;
  return value0;
 }
L27:;
 T0 = _ecl_car(v1x);
 T1 = _ecl_car(v2y);
 T2 = ecl_ash(v6path_spec,1);
 T3 = ecl_boole(ECL_BOOLIOR,(T2),(ecl_make_fixnum(1)));
 {
  cl_fixnum v12;
  v12 = (v8n)+1;
  if (Null(LC2989equal_recursive(T0, T1, v3x0, v4y0, ECL_T, T3, ecl_make_fixnum(v12)))) { goto L48; }
 }
 v1x = _ecl_cdr(v1x);
 v2y = _ecl_cdr(v2y);
 v5switch = ECL_T;
 v6path_spec = ecl_ash(v6path_spec,1);
 v8n = (v8n)+1;
 goto TTL;
L48:;
 value0 = ECL_NIL;
 cl_env_copy->nvalues = 1;
 return value0;
}
/*      local function DEFUN-CACHED                                   */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2991defun_cached(cl_object v1, cl_object v2)
{
 cl_object T0, T1, T2, T3, T4, T5, T6, T7, T8, T9, T10, T11, T12, T13, T14, T15, T16, T17, T18, T19, T20, T21, T22, T23;
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4name;
   cl_object v5lambda_list;
   cl_object v6test;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[91])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4name = v7;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   ecl_function_dispatch(cl_env_copy,VV[91])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L9:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5lambda_list = v7;
   }
   if (!(v3==ECL_NIL)) { goto L15; }
   ecl_function_dispatch(cl_env_copy,VV[91])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L15:;
   {
    cl_object v7;
    v7 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v6test = v7;
   }
   {
    cl_object v7cache_name;
    cl_object v8reset_name;
    cl_object v9hash_function;
    T0 = cl_string(v4name);
    T1 = cl_concatenate(4, ECL_SYM("STRING",807), VV[67], T0, VV[68]);
    T2 = cl_symbol_package(v4name);
    v7cache_name = cl_intern(2, T1, T2);
    T0 = cl_string(v4name);
    T1 = cl_concatenate(3, ECL_SYM("STRING",807), T0, VV[69]);
    T2 = cl_symbol_package(v4name);
    v8reset_name = cl_intern(2, T1, T2);
    {
     cl_object v10;
     v10 = v6test;
     if (!((v10)==(ECL_SYM("EQ",335)))) { goto L24; }
     v9hash_function = VV[70];
     goto L22;
L24:;
     if (!((v10)==(ECL_SYM("EQL",336)))) { goto L26; }
     v9hash_function = ECL_SYM("HASH-EQL",1725);
     goto L22;
L26:;
     if (!((v10)==(ECL_SYM("EQUAL",337)))) { goto L33; }
     goto L30;
     goto L31;
L33:;
     goto L31;
L31:;
     if (!((v10)==(VV[66]))) { goto L28; }
     goto L29;
L30:;
L29:;
     v9hash_function = ECL_SYM("HASH-EQUAL",1726);
     goto L22;
L28:;
     v6test = ECL_SYM("EQUALP",338);
     v9hash_function = ECL_SYM("HASH-EQUALP",1727);
    }
L22:;
    T0 = cl_list(3, ECL_SYM("DEFVAR",292), v7cache_name, VV[73]);
    T1 = cl_list(3, ECL_SYM("SETF",752), v7cache_name, VV[73]);
    T2 = cl_list(4, ECL_SYM("DEFUN",291), v8reset_name, ECL_NIL, T1);
    T3 = cl_listX(3, v4name, v5lambda_list, v3);
    T4 = ecl_list1(T3);
    T5 = CONS(v9hash_function,v5lambda_list);
    T6 = cl_list(3, ECL_SYM("LOGAND",494), T5, ecl_make_fixnum(1023));
    T7 = cl_list(2, VV[74], T6);
    T8 = cl_list(2, VV[75], v7cache_name);
    T9 = cl_list(3, T7, T8, VV[76]);
    {
     cl_object v10arg;
     cl_object v11;
     v10arg = ECL_NIL;
     {
      cl_object v12;
      v12 = v5lambda_list;
      if (ecl_unlikely(!ECL_LISTP(v12))) FEtype_error_list(v12);
      value0 = ECL_NIL;
      cl_env_copy->nvalues = 0;
      v11 = v12;
     }
     {
      cl_object v12;
      cl_object v13;
      v12 = ecl_list1(ECL_NIL);
      v13 = v12;
L45:;
      if (!(ecl_endp(v11))) { goto L47; }
      goto L46;
L47:;
      v10arg = ECL_CONS_CAR(v11);
      {
       cl_object v14;
       v14 = ECL_CONS_CDR(v11);
       if (ecl_unlikely(!ECL_LISTP(v14))) FEtype_error_list(v14);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       v11 = v14;
      }
      {
       cl_object v14;
       v14 = v13;
       if (ecl_unlikely(ECL_ATOM(v14))) FEtype_error_cons(v14);
       value0 = ECL_NIL;
       cl_env_copy->nvalues = 0;
       T11 = v14;
      }
      T12 = cl_list(3, v6test, VV[78], v10arg);
      v13 = ecl_list1(T12);
      (ECL_CONS_CDR(T11)=v13,T11);
      goto L45;
L46:;
      T10 = ecl_cdr(v12);
      goto L38;
     }
    }
L38:;
    T11 = cl_listX(3, ECL_SYM("AND",89), ECL_SYM("ELT",329), T10);
    T12 = CONS(v4name,v5lambda_list);
    T13 = cl_list(2, VV[80], T12);
    T14 = ecl_list1(T13);
    T15 = cl_list(3, ECL_SYM("AREF",94), v7cache_name, VV[74]);
    T16 = ecl_append(v5lambda_list,VV[81]);
    T17 = CONS(ECL_SYM("LIST",483),T16);
    T18 = cl_list(3, ECL_SYM("SETF",752), T15, T17);
    T19 = cl_list(4, ECL_SYM("LET",479), T14, T18, VV[80]);
    T20 = cl_list(4, ECL_SYM("IF",948), T11, VV[79], T19);
    T21 = cl_list(4, ECL_SYM("LET*",480), T9, VV[77], T20);
    T22 = cl_list(3, ECL_SYM("FLET",375), T4, T21);
    T23 = cl_list(4, ECL_SYM("DEFUN",291), v4name, v5lambda_list, T22);
    value0 = cl_list(4, ECL_SYM("PROGN",673), T0, T2, T23);
    return value0;
   }
  }
 }
}
/*      local function DEFUN-EQUAL-CACHED                             */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object LC2992defun_equal_cached(cl_object v1, cl_object v2)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  {
   cl_object v3;
   cl_object v4name;
   cl_object v5lambda_list;
   v3 = ecl_cdr(v1);
   if (!(v3==ECL_NIL)) { goto L3; }
   ecl_function_dispatch(cl_env_copy,VV[91])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L3:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v4name = v6;
   }
   if (!(v3==ECL_NIL)) { goto L9; }
   ecl_function_dispatch(cl_env_copy,VV[91])(1, v1) /*  DM-TOO-FEW-ARGUMENTS */;
L9:;
   {
    cl_object v6;
    v6 = ecl_car(v3);
    v3 = ecl_cdr(v3);
    v5lambda_list = v6;
   }
   value0 = cl_listX(5, VV[82], v4name, v5lambda_list, VV[66], v3);
   return value0;
  }
 }
}
/*      function definition for SAME-FNAME-P                          */
/*      optimize speed 1, debug 1, space 1, safety 2                  */
static cl_object L2993same_fname_p(cl_object v1name1, cl_object v2name2)
{
 cl_object env0 = ECL_NIL;
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 ecl_cs_check(cl_env_copy,value0);
 {
TTL:
  value0 = ecl_make_bool(ecl_equal(v1name1,v2name2));
  cl_env_copy->nvalues = 1;
  return value0;
 }
}

#include "cmp/cmputil.data"
#ifdef __cplusplus
extern "C"
#endif
ECL_DLLEXPORT void _eclvN1x8aNAbT3p9_3pjJpj61(cl_object flag)
{
 const cl_env_ptr cl_env_copy = ecl_process_env();
 cl_object value0;
 cl_object *VVtemp;
 if (flag != OBJNULL){
 Cblock = flag;
 #ifndef ECL_DYNAMIC_VV
 flag->cblock.data = VV;
 #endif
 flag->cblock.data_size = VM;
 flag->cblock.temp_data_size = VMtemp;
 flag->cblock.data_text = compiler_data_text;
 flag->cblock.cfuns_size = compiler_cfuns_size;
 flag->cblock.cfuns = compiler_cfuns;
 flag->cblock.source = ecl_make_constant_base_string("SRC:CMP;CMPUTIL.LSP.NEWEST",-1);
 return;}
 #ifdef ECL_DYNAMIC_VV
 VV = Cblock->cblock.data;
 #endif
 Cblock->cblock.data_text = (const cl_object *)"@EcLtAg:_eclvN1x8aNAbT3p9_3pjJpj61@";
 VVtemp = Cblock->cblock.temp_data;
 ECL_DEFINE_SETF_FUNCTIONS
  si_select_package(VVtemp[0]);
  ecl_cmp_defun(VV[85]);                          /*  BRIEF-NAMESTRING */
  ecl_cmp_defun(VV[86]);                          /*  NORMALIZE-BUILD-TARGET-NAME */
  ecl_cmp_defun(VV[87]);                          /*  INNERMOST-NON-EXPANDED-FORM */
  ecl_cmp_defun(VV[88]);                          /*  DO-COMPILATION-UNIT */
  ecl_cmp_defmacro(VV[90]);                       /*  WITH-COMPILATION-UNIT */
  ecl_cmp_defmacro(VV[92]);                       /*  WITH-COMPILER-ENV */
  ecl_cmp_defun(VV[94]);                          /*  SAFE-LIST-LENGTH */
  ecl_cmp_defun(VV[95]);                          /*  CHECK-ARGS-NUMBER */
  ecl_cmp_defun(VV[99]);                          /*  PRINT-CURRENT-FORM */
  ecl_cmp_defun(VV[100]);                         /*  CMPPROGRESS     */
  ecl_cmp_defun(VV[101]);                         /*  CMP-EVAL        */
  ecl_cmp_defun(VV[102]);                         /*  CMP-EXPAND-MACRO */
  ecl_cmp_defun(VV[103]);                         /*  CMP-EXPAND-COMPILER-MACRO */
  ecl_cmp_defun(VV[105]);                         /*  LISP-TO-C-NAME  */
  ecl_cmp_defun(VV[106]);                         /*  COLLECT-LINES   */
  ecl_cmp_defmacro(VV[107]);                      /*  DEFINE-COMPILER-MACRO* */
  ecl_cmp_defun(VV[108]);                         /*  EQUAL-WITH-CIRCULARITY */
  ecl_cmp_defmacro(VV[109]);                      /*  DEFUN-CACHED    */
  ecl_cmp_defmacro(VV[110]);                      /*  DEFUN-EQUAL-CACHED */
  ecl_cmp_defun(VV[111]);                         /*  SAME-FNAME-P    */
}
